/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* Register Bank Source Fragments                                             *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#ifdef GET_REGBANK_DECLARATIONS
#undef GET_REGBANK_DECLARATIONS
namespace llvm {
namespace M68k {
enum : unsigned {
  InvalidRegBankID = ~0u,
  GPRRegBankID = 0,
  NumRegisterBanks,
};
} // end namespace M68k
} // end namespace llvm
#endif // GET_REGBANK_DECLARATIONS

#ifdef GET_TARGET_REGBANK_CLASS
#undef GET_TARGET_REGBANK_CLASS
private:
  static const RegisterBank *RegBanks[];
  static const unsigned Sizes[];

protected:
  M68kGenRegisterBankInfo(unsigned HwMode = 0);

#endif // GET_TARGET_REGBANK_CLASS

#ifdef GET_TARGET_REGBANK_IMPL
#undef GET_TARGET_REGBANK_IMPL
namespace llvm {
namespace M68k {
const uint32_t GPRRegBankCoverageData[] = {
    // 0-31
    (1u << (M68k::XR32RegClassID - 0)) |
    (1u << (M68k::XR16RegClassID - 0)) |
    (1u << (M68k::SPILLRegClassID - 0)) |
    (1u << (M68k::SPILL_RRegClassID - 0)) |
    (1u << (M68k::AR32RegClassID - 0)) |
    (1u << (M68k::AR16RegClassID - 0)) |
    (1u << (M68k::AR32_NOSPRegClassID - 0)) |
    (1u << (M68k::AR32_TCRegClassID - 0)) |
    (1u << (M68k::SPCRegClassID - 0)) |
    (1u << (M68k::DR32RegClassID - 0)) |
    (1u << (M68k::DR8RegClassID - 0)) |
    (1u << (M68k::DR16RegClassID - 0)) |
    (1u << (M68k::DR32_TCRegClassID - 0)) |
    (1u << (M68k::XR32_TCRegClassID - 0)) |
    0,
};

constexpr RegisterBank GPRRegBank(/* ID */ M68k::GPRRegBankID, /* Name */ "AnyGPR", /* CoveredRegClasses */ GPRRegBankCoverageData, /* NumRegClasses */ 26);
} // end namespace M68k

const RegisterBank *M68kGenRegisterBankInfo::RegBanks[] = {
    &M68k::GPRRegBank,
};

const unsigned M68kGenRegisterBankInfo::Sizes[] = {
    // Mode = 0 (Default)
    32,
};

M68kGenRegisterBankInfo::M68kGenRegisterBankInfo(unsigned HwMode)
    : RegisterBankInfo(RegBanks, M68k::NumRegisterBanks, Sizes, HwMode) {
  // Assert that RegBank indices match their ID's
#ifndef NDEBUG
  for (auto RB : enumerate(RegBanks))
    assert(RB.index() == RB.value()->getID() && "Index != ID");
#endif // NDEBUG
}
} // end namespace llvm
#endif // GET_TARGET_REGBANK_IMPL
