/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|*  * M68k Disassembler                                                       *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/


#include "llvm/MC/MCInst.h"
#include "llvm/MC/MCSubtargetInfo.h"
#include "llvm/Support/DataTypes.h"
#include "llvm/Support/Debug.h"
#include "llvm/Support/LEB128.h"
#include "llvm/Support/raw_ostream.h"
#include "llvm/TargetParser/SubtargetFeature.h"
#include <assert.h>

namespace llvm {

// Helper functions for extracting fields from encoded instructions.
// InsnType must either be integral or an APInt-like object that must:
// * be default-constructible and copy-constructible
// * be constructible from an APInt (this can be private)
// * Support insertBits(bits, startBit, numBits)
// * Support extractBitsAsZExtValue(numBits, startBit)
// * Support the ~, &, ==, and != operators with other objects of the same type
// * Support the != and bitwise & with uint64_t
// * Support put (<<) to raw_ostream&
template <typename InsnType>
#if defined(_MSC_VER) && !defined(__clang__)
__declspec(noinline)
#endif
static std::enable_if_t<std::is_integral<InsnType>::value, InsnType>
fieldFromInstruction(const InsnType &insn, unsigned startBit,
                     unsigned numBits) {
  assert(startBit + numBits <= 64 && "Cannot support >64-bit extractions!");
  assert(startBit + numBits <= (sizeof(InsnType) * 8) &&
         "Instruction field out of bounds!");
  InsnType fieldMask;
  if (numBits == sizeof(InsnType) * 8)
    fieldMask = (InsnType)(-1LL);
  else
    fieldMask = (((InsnType)1 << numBits) - 1) << startBit;
  return (insn & fieldMask) >> startBit;
}

template <typename InsnType>
static std::enable_if_t<!std::is_integral<InsnType>::value, uint64_t>
fieldFromInstruction(const InsnType &insn, unsigned startBit,
                     unsigned numBits) {
  return insn.extractBitsAsZExtValue(numBits, startBit);
}

// Helper function for inserting bits extracted from an encoded instruction into
// a field.
template <typename InsnType>
static std::enable_if_t<std::is_integral<InsnType>::value>
insertBits(InsnType &field, InsnType bits, unsigned startBit, unsigned numBits) {
  assert(startBit + numBits <= sizeof field * 8);
  field |= (InsnType)bits << startBit;
}

template <typename InsnType>
static std::enable_if_t<!std::is_integral<InsnType>::value>
insertBits(InsnType &field, uint64_t bits, unsigned startBit, unsigned numBits) {
  field.insertBits(bits, startBit, numBits);
}

static bool Check(DecodeStatus &Out, DecodeStatus In) {
  Out = static_cast<DecodeStatus>(Out & In);
  return Out != MCDisassembler::Fail;
}

static const uint8_t DecoderTable80[] = {
/* 0 */       MCD::OPC_ExtractField, 12, 4,  // Inst{15-12} ...
/* 3 */       MCD::OPC_FilterValue, 0, 48, 9, 0, // Skip to: 2360
/* 8 */       MCD::OPC_ExtractField, 4, 5,  // Inst{8-4} ...
/* 11 */      MCD::OPC_FilterValue, 0, 65, 0, 0, // Skip to: 81
/* 16 */      MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 19 */      MCD::OPC_FilterValue, 4, 11, 0, 0, // Skip to: 35
/* 24 */      MCD::OPC_CheckField, 24, 8, 0, 241, 55, 0, // Skip to: 14352
/* 31 */      MCD::OPC_Decode, 139, 4, 0, // Opcode: BTST32di
/* 35 */      MCD::OPC_FilterValue, 5, 18, 0, 0, // Skip to: 58
/* 40 */      MCD::OPC_CheckField, 24, 8, 0, 225, 55, 0, // Skip to: 14352
/* 47 */      MCD::OPC_CheckField, 3, 1, 0, 218, 55, 0, // Skip to: 14352
/* 54 */      MCD::OPC_Decode, 164, 10, 1, // Opcode: XOR8di
/* 58 */      MCD::OPC_FilterValue, 6, 209, 55, 0, // Skip to: 14352
/* 63 */      MCD::OPC_CheckField, 24, 8, 0, 202, 55, 0, // Skip to: 14352
/* 70 */      MCD::OPC_CheckField, 3, 1, 0, 195, 55, 0, // Skip to: 14352
/* 77 */      MCD::OPC_Decode, 218, 4, 2, // Opcode: CMP8di
/* 81 */      MCD::OPC_FilterValue, 1, 158, 0, 0, // Skip to: 244
/* 86 */      MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 89 */      MCD::OPC_FilterValue, 0, 18, 0, 0, // Skip to: 112
/* 94 */      MCD::OPC_CheckField, 24, 8, 0, 171, 55, 0, // Skip to: 14352
/* 101 */     MCD::OPC_CheckField, 3, 1, 0, 164, 55, 0, // Skip to: 14352
/* 108 */     MCD::OPC_Decode, 149, 9, 3, // Opcode: OR8ji
/* 112 */     MCD::OPC_FilterValue, 1, 18, 0, 0, // Skip to: 135
/* 117 */     MCD::OPC_CheckField, 24, 8, 0, 148, 55, 0, // Skip to: 14352
/* 124 */     MCD::OPC_CheckField, 3, 1, 0, 141, 55, 0, // Skip to: 14352
/* 131 */     MCD::OPC_Decode, 215, 3, 3, // Opcode: AND8ji
/* 135 */     MCD::OPC_FilterValue, 2, 18, 0, 0, // Skip to: 158
/* 140 */     MCD::OPC_CheckField, 24, 8, 0, 125, 55, 0, // Skip to: 14352
/* 147 */     MCD::OPC_CheckField, 3, 1, 0, 118, 55, 0, // Skip to: 14352
/* 154 */     MCD::OPC_Decode, 144, 10, 3, // Opcode: SUB8ji
/* 158 */     MCD::OPC_FilterValue, 3, 18, 0, 0, // Skip to: 181
/* 163 */     MCD::OPC_CheckField, 24, 8, 0, 102, 55, 0, // Skip to: 14352
/* 170 */     MCD::OPC_CheckField, 3, 1, 0, 95, 55, 0, // Skip to: 14352
/* 177 */     MCD::OPC_Decode, 171, 3, 3, // Opcode: ADD8ji
/* 181 */     MCD::OPC_FilterValue, 4, 35, 0, 0, // Skip to: 221
/* 186 */     MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 189 */     MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 205
/* 194 */     MCD::OPC_CheckField, 24, 8, 0, 71, 55, 0, // Skip to: 14352
/* 201 */     MCD::OPC_Decode, 145, 4, 3, // Opcode: BTST8ji
/* 205 */     MCD::OPC_FilterValue, 1, 62, 55, 0, // Skip to: 14352
/* 210 */     MCD::OPC_CheckField, 24, 8, 0, 55, 55, 0, // Skip to: 14352
/* 217 */     MCD::OPC_Decode, 149, 4, 3, // Opcode: BTST8oi
/* 221 */     MCD::OPC_FilterValue, 6, 46, 55, 0, // Skip to: 14352
/* 226 */     MCD::OPC_CheckField, 24, 8, 0, 39, 55, 0, // Skip to: 14352
/* 233 */     MCD::OPC_CheckField, 3, 1, 0, 32, 55, 0, // Skip to: 14352
/* 240 */     MCD::OPC_Decode, 224, 4, 4, // Opcode: CMP8ji
/* 244 */     MCD::OPC_FilterValue, 2, 158, 0, 0, // Skip to: 407
/* 249 */     MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 252 */     MCD::OPC_FilterValue, 0, 18, 0, 0, // Skip to: 275
/* 257 */     MCD::OPC_CheckField, 24, 8, 0, 8, 55, 0, // Skip to: 14352
/* 264 */     MCD::OPC_CheckField, 3, 1, 1, 1, 55, 0, // Skip to: 14352
/* 271 */     MCD::OPC_Decode, 151, 9, 5, // Opcode: OR8pi
/* 275 */     MCD::OPC_FilterValue, 1, 18, 0, 0, // Skip to: 298
/* 280 */     MCD::OPC_CheckField, 24, 8, 0, 241, 54, 0, // Skip to: 14352
/* 287 */     MCD::OPC_CheckField, 3, 1, 1, 234, 54, 0, // Skip to: 14352
/* 294 */     MCD::OPC_Decode, 217, 3, 5, // Opcode: AND8pi
/* 298 */     MCD::OPC_FilterValue, 2, 18, 0, 0, // Skip to: 321
/* 303 */     MCD::OPC_CheckField, 24, 8, 0, 218, 54, 0, // Skip to: 14352
/* 310 */     MCD::OPC_CheckField, 3, 1, 1, 211, 54, 0, // Skip to: 14352
/* 317 */     MCD::OPC_Decode, 146, 10, 5, // Opcode: SUB8pi
/* 321 */     MCD::OPC_FilterValue, 3, 18, 0, 0, // Skip to: 344
/* 326 */     MCD::OPC_CheckField, 24, 8, 0, 195, 54, 0, // Skip to: 14352
/* 333 */     MCD::OPC_CheckField, 3, 1, 1, 188, 54, 0, // Skip to: 14352
/* 340 */     MCD::OPC_Decode, 173, 3, 5, // Opcode: ADD8pi
/* 344 */     MCD::OPC_FilterValue, 4, 35, 0, 0, // Skip to: 384
/* 349 */     MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 352 */     MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 368
/* 357 */     MCD::OPC_CheckField, 24, 8, 0, 164, 54, 0, // Skip to: 14352
/* 364 */     MCD::OPC_Decode, 141, 4, 3, // Opcode: BTST8ei
/* 368 */     MCD::OPC_FilterValue, 1, 155, 54, 0, // Skip to: 14352
/* 373 */     MCD::OPC_CheckField, 24, 8, 0, 148, 54, 0, // Skip to: 14352
/* 380 */     MCD::OPC_Decode, 151, 4, 5, // Opcode: BTST8pi
/* 384 */     MCD::OPC_FilterValue, 6, 139, 54, 0, // Skip to: 14352
/* 389 */     MCD::OPC_CheckField, 24, 8, 0, 132, 54, 0, // Skip to: 14352
/* 396 */     MCD::OPC_CheckField, 3, 1, 1, 125, 54, 0, // Skip to: 14352
/* 403 */     MCD::OPC_Decode, 226, 4, 6, // Opcode: CMP8pi
/* 407 */     MCD::OPC_FilterValue, 3, 39, 1, 0, // Skip to: 707
/* 412 */     MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 415 */     MCD::OPC_FilterValue, 0, 25, 0, 0, // Skip to: 445
/* 420 */     MCD::OPC_CheckField, 40, 4, 8, 101, 54, 0, // Skip to: 14352
/* 427 */     MCD::OPC_CheckField, 24, 8, 0, 94, 54, 0, // Skip to: 14352
/* 434 */     MCD::OPC_CheckField, 3, 1, 0, 87, 54, 0, // Skip to: 14352
/* 441 */     MCD::OPC_Decode, 147, 9, 7, // Opcode: OR8fi
/* 445 */     MCD::OPC_FilterValue, 1, 25, 0, 0, // Skip to: 475
/* 450 */     MCD::OPC_CheckField, 40, 4, 8, 71, 54, 0, // Skip to: 14352
/* 457 */     MCD::OPC_CheckField, 24, 8, 0, 64, 54, 0, // Skip to: 14352
/* 464 */     MCD::OPC_CheckField, 3, 1, 0, 57, 54, 0, // Skip to: 14352
/* 471 */     MCD::OPC_Decode, 213, 3, 7, // Opcode: AND8fi
/* 475 */     MCD::OPC_FilterValue, 2, 25, 0, 0, // Skip to: 505
/* 480 */     MCD::OPC_CheckField, 40, 4, 8, 41, 54, 0, // Skip to: 14352
/* 487 */     MCD::OPC_CheckField, 24, 8, 0, 34, 54, 0, // Skip to: 14352
/* 494 */     MCD::OPC_CheckField, 3, 1, 0, 27, 54, 0, // Skip to: 14352
/* 501 */     MCD::OPC_Decode, 142, 10, 7, // Opcode: SUB8fi
/* 505 */     MCD::OPC_FilterValue, 3, 25, 0, 0, // Skip to: 535
/* 510 */     MCD::OPC_CheckField, 40, 4, 8, 11, 54, 0, // Skip to: 14352
/* 517 */     MCD::OPC_CheckField, 24, 8, 0, 4, 54, 0, // Skip to: 14352
/* 524 */     MCD::OPC_CheckField, 3, 1, 0, 253, 53, 0, // Skip to: 14352
/* 531 */     MCD::OPC_Decode, 169, 3, 7, // Opcode: ADD8fi
/* 535 */     MCD::OPC_FilterValue, 4, 73, 0, 0, // Skip to: 613
/* 540 */     MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 543 */     MCD::OPC_FilterValue, 0, 18, 0, 0, // Skip to: 566
/* 548 */     MCD::OPC_CheckField, 40, 4, 8, 229, 53, 0, // Skip to: 14352
/* 555 */     MCD::OPC_CheckField, 24, 8, 0, 222, 53, 0, // Skip to: 14352
/* 562 */     MCD::OPC_Decode, 143, 4, 7, // Opcode: BTST8fi
/* 566 */     MCD::OPC_FilterValue, 1, 213, 53, 0, // Skip to: 14352
/* 571 */     MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 574 */     MCD::OPC_FilterValue, 2, 11, 0, 0, // Skip to: 590
/* 579 */     MCD::OPC_CheckField, 24, 8, 0, 198, 53, 0, // Skip to: 14352
/* 586 */     MCD::OPC_Decode, 153, 4, 8, // Opcode: BTST8qi
/* 590 */     MCD::OPC_FilterValue, 3, 189, 53, 0, // Skip to: 14352
/* 595 */     MCD::OPC_CheckField, 40, 4, 8, 182, 53, 0, // Skip to: 14352
/* 602 */     MCD::OPC_CheckField, 24, 8, 0, 175, 53, 0, // Skip to: 14352
/* 609 */     MCD::OPC_Decode, 147, 4, 9, // Opcode: BTST8ki
/* 613 */     MCD::OPC_FilterValue, 6, 166, 53, 0, // Skip to: 14352
/* 618 */     MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 621 */     MCD::OPC_FilterValue, 0, 18, 0, 0, // Skip to: 644
/* 626 */     MCD::OPC_CheckField, 40, 4, 8, 151, 53, 0, // Skip to: 14352
/* 633 */     MCD::OPC_CheckField, 24, 8, 0, 144, 53, 0, // Skip to: 14352
/* 640 */     MCD::OPC_Decode, 223, 4, 10, // Opcode: CMP8fi
/* 644 */     MCD::OPC_FilterValue, 1, 135, 53, 0, // Skip to: 14352
/* 649 */     MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 652 */     MCD::OPC_FilterValue, 1, 11, 0, 0, // Skip to: 668
/* 657 */     MCD::OPC_CheckField, 24, 8, 0, 120, 53, 0, // Skip to: 14352
/* 664 */     MCD::OPC_Decode, 215, 4, 11, // Opcode: CMP8bi
/* 668 */     MCD::OPC_FilterValue, 2, 11, 0, 0, // Skip to: 684
/* 673 */     MCD::OPC_CheckField, 24, 8, 0, 104, 53, 0, // Skip to: 14352
/* 680 */     MCD::OPC_Decode, 227, 4, 12, // Opcode: CMP8qi
/* 684 */     MCD::OPC_FilterValue, 3, 95, 53, 0, // Skip to: 14352
/* 689 */     MCD::OPC_CheckField, 40, 4, 8, 88, 53, 0, // Skip to: 14352
/* 696 */     MCD::OPC_CheckField, 24, 8, 0, 81, 53, 0, // Skip to: 14352
/* 703 */     MCD::OPC_Decode, 225, 4, 13, // Opcode: CMP8ki
/* 707 */     MCD::OPC_FilterValue, 4, 51, 0, 0, // Skip to: 763
/* 712 */     MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 715 */     MCD::OPC_FilterValue, 4, 11, 0, 0, // Skip to: 731
/* 720 */     MCD::OPC_CheckField, 24, 8, 0, 57, 53, 0, // Skip to: 14352
/* 727 */     MCD::OPC_Decode, 225, 3, 0, // Opcode: BCHG32di
/* 731 */     MCD::OPC_FilterValue, 5, 11, 0, 0, // Skip to: 747
/* 736 */     MCD::OPC_CheckField, 3, 1, 0, 41, 53, 0, // Skip to: 14352
/* 743 */     MCD::OPC_Decode, 160, 10, 14, // Opcode: XOR16di
/* 747 */     MCD::OPC_FilterValue, 6, 32, 53, 0, // Skip to: 14352
/* 752 */     MCD::OPC_CheckField, 3, 1, 0, 25, 53, 0, // Skip to: 14352
/* 759 */     MCD::OPC_Decode, 191, 4, 15, // Opcode: CMP16di
/* 763 */     MCD::OPC_FilterValue, 5, 123, 0, 0, // Skip to: 891
/* 768 */     MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 771 */     MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 787
/* 776 */     MCD::OPC_CheckField, 3, 1, 0, 1, 53, 0, // Skip to: 14352
/* 783 */     MCD::OPC_Decode, 250, 8, 16, // Opcode: OR16ji
/* 787 */     MCD::OPC_FilterValue, 1, 11, 0, 0, // Skip to: 803
/* 792 */     MCD::OPC_CheckField, 3, 1, 0, 241, 52, 0, // Skip to: 14352
/* 799 */     MCD::OPC_Decode, 188, 3, 16, // Opcode: AND16ji
/* 803 */     MCD::OPC_FilterValue, 2, 11, 0, 0, // Skip to: 819
/* 808 */     MCD::OPC_CheckField, 3, 1, 0, 225, 52, 0, // Skip to: 14352
/* 815 */     MCD::OPC_Decode, 237, 9, 16, // Opcode: SUB16ji
/* 819 */     MCD::OPC_FilterValue, 3, 11, 0, 0, // Skip to: 835
/* 824 */     MCD::OPC_CheckField, 3, 1, 0, 209, 52, 0, // Skip to: 14352
/* 831 */     MCD::OPC_Decode, 136, 3, 16, // Opcode: ADD16ji
/* 835 */     MCD::OPC_FilterValue, 4, 35, 0, 0, // Skip to: 875
/* 840 */     MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 843 */     MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 859
/* 848 */     MCD::OPC_CheckField, 24, 8, 0, 185, 52, 0, // Skip to: 14352
/* 855 */     MCD::OPC_Decode, 231, 3, 3, // Opcode: BCHG8ji
/* 859 */     MCD::OPC_FilterValue, 1, 176, 52, 0, // Skip to: 14352
/* 864 */     MCD::OPC_CheckField, 24, 8, 0, 169, 52, 0, // Skip to: 14352
/* 871 */     MCD::OPC_Decode, 233, 3, 3, // Opcode: BCHG8oi
/* 875 */     MCD::OPC_FilterValue, 6, 160, 52, 0, // Skip to: 14352
/* 880 */     MCD::OPC_CheckField, 3, 1, 0, 153, 52, 0, // Skip to: 14352
/* 887 */     MCD::OPC_Decode, 198, 4, 17, // Opcode: CMP16ji
/* 891 */     MCD::OPC_FilterValue, 6, 123, 0, 0, // Skip to: 1019
/* 896 */     MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 899 */     MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 915
/* 904 */     MCD::OPC_CheckField, 3, 1, 1, 129, 52, 0, // Skip to: 14352
/* 911 */     MCD::OPC_Decode, 252, 8, 18, // Opcode: OR16pi
/* 915 */     MCD::OPC_FilterValue, 1, 11, 0, 0, // Skip to: 931
/* 920 */     MCD::OPC_CheckField, 3, 1, 1, 113, 52, 0, // Skip to: 14352
/* 927 */     MCD::OPC_Decode, 190, 3, 18, // Opcode: AND16pi
/* 931 */     MCD::OPC_FilterValue, 2, 11, 0, 0, // Skip to: 947
/* 936 */     MCD::OPC_CheckField, 3, 1, 1, 97, 52, 0, // Skip to: 14352
/* 943 */     MCD::OPC_Decode, 239, 9, 18, // Opcode: SUB16pi
/* 947 */     MCD::OPC_FilterValue, 3, 11, 0, 0, // Skip to: 963
/* 952 */     MCD::OPC_CheckField, 3, 1, 1, 81, 52, 0, // Skip to: 14352
/* 959 */     MCD::OPC_Decode, 138, 3, 18, // Opcode: ADD16pi
/* 963 */     MCD::OPC_FilterValue, 4, 35, 0, 0, // Skip to: 1003
/* 968 */     MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 971 */     MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 987
/* 976 */     MCD::OPC_CheckField, 24, 8, 0, 57, 52, 0, // Skip to: 14352
/* 983 */     MCD::OPC_Decode, 227, 3, 3, // Opcode: BCHG8ei
/* 987 */     MCD::OPC_FilterValue, 1, 48, 52, 0, // Skip to: 14352
/* 992 */     MCD::OPC_CheckField, 24, 8, 0, 41, 52, 0, // Skip to: 14352
/* 999 */     MCD::OPC_Decode, 235, 3, 5, // Opcode: BCHG8pi
/* 1003 */    MCD::OPC_FilterValue, 6, 32, 52, 0, // Skip to: 14352
/* 1008 */    MCD::OPC_CheckField, 3, 1, 1, 25, 52, 0, // Skip to: 14352
/* 1015 */    MCD::OPC_Decode, 200, 4, 19, // Opcode: CMP16pi
/* 1019 */    MCD::OPC_FilterValue, 7, 191, 0, 0, // Skip to: 1215
/* 1024 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 1027 */    MCD::OPC_FilterValue, 0, 18, 0, 0, // Skip to: 1050
/* 1032 */    MCD::OPC_CheckField, 40, 4, 8, 1, 52, 0, // Skip to: 14352
/* 1039 */    MCD::OPC_CheckField, 3, 1, 0, 250, 51, 0, // Skip to: 14352
/* 1046 */    MCD::OPC_Decode, 248, 8, 20, // Opcode: OR16fi
/* 1050 */    MCD::OPC_FilterValue, 1, 18, 0, 0, // Skip to: 1073
/* 1055 */    MCD::OPC_CheckField, 40, 4, 8, 234, 51, 0, // Skip to: 14352
/* 1062 */    MCD::OPC_CheckField, 3, 1, 0, 227, 51, 0, // Skip to: 14352
/* 1069 */    MCD::OPC_Decode, 186, 3, 20, // Opcode: AND16fi
/* 1073 */    MCD::OPC_FilterValue, 2, 18, 0, 0, // Skip to: 1096
/* 1078 */    MCD::OPC_CheckField, 40, 4, 8, 211, 51, 0, // Skip to: 14352
/* 1085 */    MCD::OPC_CheckField, 3, 1, 0, 204, 51, 0, // Skip to: 14352
/* 1092 */    MCD::OPC_Decode, 235, 9, 20, // Opcode: SUB16fi
/* 1096 */    MCD::OPC_FilterValue, 3, 18, 0, 0, // Skip to: 1119
/* 1101 */    MCD::OPC_CheckField, 40, 4, 8, 188, 51, 0, // Skip to: 14352
/* 1108 */    MCD::OPC_CheckField, 3, 1, 0, 181, 51, 0, // Skip to: 14352
/* 1115 */    MCD::OPC_Decode, 134, 3, 20, // Opcode: ADD16fi
/* 1119 */    MCD::OPC_FilterValue, 4, 25, 0, 0, // Skip to: 1149
/* 1124 */    MCD::OPC_CheckField, 40, 4, 8, 165, 51, 0, // Skip to: 14352
/* 1131 */    MCD::OPC_CheckField, 24, 8, 0, 158, 51, 0, // Skip to: 14352
/* 1138 */    MCD::OPC_CheckField, 3, 1, 0, 151, 51, 0, // Skip to: 14352
/* 1145 */    MCD::OPC_Decode, 229, 3, 7, // Opcode: BCHG8fi
/* 1149 */    MCD::OPC_FilterValue, 6, 142, 51, 0, // Skip to: 14352
/* 1154 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 1157 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 1173
/* 1162 */    MCD::OPC_CheckField, 40, 4, 8, 127, 51, 0, // Skip to: 14352
/* 1169 */    MCD::OPC_Decode, 197, 4, 21, // Opcode: CMP16fi
/* 1173 */    MCD::OPC_FilterValue, 1, 118, 51, 0, // Skip to: 14352
/* 1178 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 1181 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 1190
/* 1186 */    MCD::OPC_Decode, 189, 4, 22, // Opcode: CMP16bi
/* 1190 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 1199
/* 1195 */    MCD::OPC_Decode, 201, 4, 23, // Opcode: CMP16qi
/* 1199 */    MCD::OPC_FilterValue, 3, 92, 51, 0, // Skip to: 14352
/* 1204 */    MCD::OPC_CheckField, 40, 4, 8, 85, 51, 0, // Skip to: 14352
/* 1211 */    MCD::OPC_Decode, 199, 4, 24, // Opcode: CMP16ki
/* 1215 */    MCD::OPC_FilterValue, 8, 51, 0, 0, // Skip to: 1271
/* 1220 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 1223 */    MCD::OPC_FilterValue, 4, 11, 0, 0, // Skip to: 1239
/* 1228 */    MCD::OPC_CheckField, 24, 8, 0, 61, 51, 0, // Skip to: 14352
/* 1235 */    MCD::OPC_Decode, 237, 3, 0, // Opcode: BCLR32di
/* 1239 */    MCD::OPC_FilterValue, 5, 11, 0, 0, // Skip to: 1255
/* 1244 */    MCD::OPC_CheckField, 3, 1, 0, 45, 51, 0, // Skip to: 14352
/* 1251 */    MCD::OPC_Decode, 162, 10, 25, // Opcode: XOR32di
/* 1255 */    MCD::OPC_FilterValue, 6, 36, 51, 0, // Skip to: 14352
/* 1260 */    MCD::OPC_CheckField, 3, 1, 0, 29, 51, 0, // Skip to: 14352
/* 1267 */    MCD::OPC_Decode, 204, 4, 26, // Opcode: CMP32di
/* 1271 */    MCD::OPC_FilterValue, 9, 123, 0, 0, // Skip to: 1399
/* 1276 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 1279 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 1295
/* 1284 */    MCD::OPC_CheckField, 3, 1, 0, 5, 51, 0, // Skip to: 14352
/* 1291 */    MCD::OPC_Decode, 136, 9, 27, // Opcode: OR32ji
/* 1295 */    MCD::OPC_FilterValue, 1, 11, 0, 0, // Skip to: 1311
/* 1300 */    MCD::OPC_CheckField, 3, 1, 0, 245, 50, 0, // Skip to: 14352
/* 1307 */    MCD::OPC_Decode, 202, 3, 27, // Opcode: AND32ji
/* 1311 */    MCD::OPC_FilterValue, 2, 11, 0, 0, // Skip to: 1327
/* 1316 */    MCD::OPC_CheckField, 3, 1, 0, 229, 50, 0, // Skip to: 14352
/* 1323 */    MCD::OPC_Decode, 131, 10, 27, // Opcode: SUB32ji
/* 1327 */    MCD::OPC_FilterValue, 3, 11, 0, 0, // Skip to: 1343
/* 1332 */    MCD::OPC_CheckField, 3, 1, 0, 213, 50, 0, // Skip to: 14352
/* 1339 */    MCD::OPC_Decode, 158, 3, 27, // Opcode: ADD32ji
/* 1343 */    MCD::OPC_FilterValue, 4, 35, 0, 0, // Skip to: 1383
/* 1348 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 1351 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 1367
/* 1356 */    MCD::OPC_CheckField, 24, 8, 0, 189, 50, 0, // Skip to: 14352
/* 1363 */    MCD::OPC_Decode, 243, 3, 3, // Opcode: BCLR8ji
/* 1367 */    MCD::OPC_FilterValue, 1, 180, 50, 0, // Skip to: 14352
/* 1372 */    MCD::OPC_CheckField, 24, 8, 0, 173, 50, 0, // Skip to: 14352
/* 1379 */    MCD::OPC_Decode, 245, 3, 3, // Opcode: BCLR8oi
/* 1383 */    MCD::OPC_FilterValue, 6, 164, 50, 0, // Skip to: 14352
/* 1388 */    MCD::OPC_CheckField, 3, 1, 0, 157, 50, 0, // Skip to: 14352
/* 1395 */    MCD::OPC_Decode, 211, 4, 28, // Opcode: CMP32ji
/* 1399 */    MCD::OPC_FilterValue, 10, 123, 0, 0, // Skip to: 1527
/* 1404 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 1407 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 1423
/* 1412 */    MCD::OPC_CheckField, 3, 1, 1, 133, 50, 0, // Skip to: 14352
/* 1419 */    MCD::OPC_Decode, 138, 9, 29, // Opcode: OR32pi
/* 1423 */    MCD::OPC_FilterValue, 1, 11, 0, 0, // Skip to: 1439
/* 1428 */    MCD::OPC_CheckField, 3, 1, 1, 117, 50, 0, // Skip to: 14352
/* 1435 */    MCD::OPC_Decode, 204, 3, 29, // Opcode: AND32pi
/* 1439 */    MCD::OPC_FilterValue, 2, 11, 0, 0, // Skip to: 1455
/* 1444 */    MCD::OPC_CheckField, 3, 1, 1, 101, 50, 0, // Skip to: 14352
/* 1451 */    MCD::OPC_Decode, 133, 10, 29, // Opcode: SUB32pi
/* 1455 */    MCD::OPC_FilterValue, 3, 11, 0, 0, // Skip to: 1471
/* 1460 */    MCD::OPC_CheckField, 3, 1, 1, 85, 50, 0, // Skip to: 14352
/* 1467 */    MCD::OPC_Decode, 160, 3, 29, // Opcode: ADD32pi
/* 1471 */    MCD::OPC_FilterValue, 4, 35, 0, 0, // Skip to: 1511
/* 1476 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 1479 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 1495
/* 1484 */    MCD::OPC_CheckField, 24, 8, 0, 61, 50, 0, // Skip to: 14352
/* 1491 */    MCD::OPC_Decode, 239, 3, 3, // Opcode: BCLR8ei
/* 1495 */    MCD::OPC_FilterValue, 1, 52, 50, 0, // Skip to: 14352
/* 1500 */    MCD::OPC_CheckField, 24, 8, 0, 45, 50, 0, // Skip to: 14352
/* 1507 */    MCD::OPC_Decode, 247, 3, 5, // Opcode: BCLR8pi
/* 1511 */    MCD::OPC_FilterValue, 6, 36, 50, 0, // Skip to: 14352
/* 1516 */    MCD::OPC_CheckField, 3, 1, 1, 29, 50, 0, // Skip to: 14352
/* 1523 */    MCD::OPC_Decode, 213, 4, 30, // Opcode: CMP32pi
/* 1527 */    MCD::OPC_FilterValue, 11, 191, 0, 0, // Skip to: 1723
/* 1532 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 1535 */    MCD::OPC_FilterValue, 0, 18, 0, 0, // Skip to: 1558
/* 1540 */    MCD::OPC_CheckField, 56, 4, 8, 5, 50, 0, // Skip to: 14352
/* 1547 */    MCD::OPC_CheckField, 3, 1, 0, 254, 49, 0, // Skip to: 14352
/* 1554 */    MCD::OPC_Decode, 134, 9, 31, // Opcode: OR32fi
/* 1558 */    MCD::OPC_FilterValue, 1, 18, 0, 0, // Skip to: 1581
/* 1563 */    MCD::OPC_CheckField, 56, 4, 8, 238, 49, 0, // Skip to: 14352
/* 1570 */    MCD::OPC_CheckField, 3, 1, 0, 231, 49, 0, // Skip to: 14352
/* 1577 */    MCD::OPC_Decode, 200, 3, 31, // Opcode: AND32fi
/* 1581 */    MCD::OPC_FilterValue, 2, 18, 0, 0, // Skip to: 1604
/* 1586 */    MCD::OPC_CheckField, 56, 4, 8, 215, 49, 0, // Skip to: 14352
/* 1593 */    MCD::OPC_CheckField, 3, 1, 0, 208, 49, 0, // Skip to: 14352
/* 1600 */    MCD::OPC_Decode, 129, 10, 31, // Opcode: SUB32fi
/* 1604 */    MCD::OPC_FilterValue, 3, 18, 0, 0, // Skip to: 1627
/* 1609 */    MCD::OPC_CheckField, 56, 4, 8, 192, 49, 0, // Skip to: 14352
/* 1616 */    MCD::OPC_CheckField, 3, 1, 0, 185, 49, 0, // Skip to: 14352
/* 1623 */    MCD::OPC_Decode, 156, 3, 31, // Opcode: ADD32fi
/* 1627 */    MCD::OPC_FilterValue, 4, 25, 0, 0, // Skip to: 1657
/* 1632 */    MCD::OPC_CheckField, 40, 4, 8, 169, 49, 0, // Skip to: 14352
/* 1639 */    MCD::OPC_CheckField, 24, 8, 0, 162, 49, 0, // Skip to: 14352
/* 1646 */    MCD::OPC_CheckField, 3, 1, 0, 155, 49, 0, // Skip to: 14352
/* 1653 */    MCD::OPC_Decode, 241, 3, 7, // Opcode: BCLR8fi
/* 1657 */    MCD::OPC_FilterValue, 6, 146, 49, 0, // Skip to: 14352
/* 1662 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 1665 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 1681
/* 1670 */    MCD::OPC_CheckField, 56, 4, 8, 131, 49, 0, // Skip to: 14352
/* 1677 */    MCD::OPC_Decode, 210, 4, 32, // Opcode: CMP32fi
/* 1681 */    MCD::OPC_FilterValue, 1, 122, 49, 0, // Skip to: 14352
/* 1686 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 1689 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 1698
/* 1694 */    MCD::OPC_Decode, 202, 4, 33, // Opcode: CMP32bi
/* 1698 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 1707
/* 1703 */    MCD::OPC_Decode, 214, 4, 34, // Opcode: CMP32qi
/* 1707 */    MCD::OPC_FilterValue, 3, 96, 49, 0, // Skip to: 14352
/* 1712 */    MCD::OPC_CheckField, 56, 4, 8, 89, 49, 0, // Skip to: 14352
/* 1719 */    MCD::OPC_Decode, 212, 4, 35, // Opcode: CMP32ki
/* 1723 */    MCD::OPC_FilterValue, 12, 18, 0, 0, // Skip to: 1746
/* 1728 */    MCD::OPC_CheckField, 24, 8, 0, 73, 49, 0, // Skip to: 14352
/* 1735 */    MCD::OPC_CheckField, 9, 3, 4, 66, 49, 0, // Skip to: 14352
/* 1742 */    MCD::OPC_Decode, 252, 3, 0, // Opcode: BSET32di
/* 1746 */    MCD::OPC_FilterValue, 13, 148, 0, 0, // Skip to: 1899
/* 1751 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 1754 */    MCD::OPC_FilterValue, 4, 35, 0, 0, // Skip to: 1794
/* 1759 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 1762 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 1778
/* 1767 */    MCD::OPC_CheckField, 24, 8, 0, 34, 49, 0, // Skip to: 14352
/* 1774 */    MCD::OPC_Decode, 130, 4, 3, // Opcode: BSET8ji
/* 1778 */    MCD::OPC_FilterValue, 1, 25, 49, 0, // Skip to: 14352
/* 1783 */    MCD::OPC_CheckField, 24, 8, 0, 18, 49, 0, // Skip to: 14352
/* 1790 */    MCD::OPC_Decode, 132, 4, 3, // Opcode: BSET8oi
/* 1794 */    MCD::OPC_FilterValue, 5, 30, 0, 0, // Skip to: 1829
/* 1799 */    MCD::OPC_CheckPredicate, 0, 4, 49, 0, // Skip to: 14352
/* 1804 */    MCD::OPC_CheckField, 25, 7, 0, 253, 48, 0, // Skip to: 14352
/* 1811 */    MCD::OPC_CheckField, 19, 3, 0, 246, 48, 0, // Skip to: 14352
/* 1818 */    MCD::OPC_CheckField, 3, 1, 0, 239, 48, 0, // Skip to: 14352
/* 1825 */    MCD::OPC_Decode, 188, 4, 36, // Opcode: CAS8
/* 1829 */    MCD::OPC_FilterValue, 6, 30, 0, 0, // Skip to: 1864
/* 1834 */    MCD::OPC_CheckPredicate, 0, 225, 48, 0, // Skip to: 14352
/* 1839 */    MCD::OPC_CheckField, 25, 7, 0, 218, 48, 0, // Skip to: 14352
/* 1846 */    MCD::OPC_CheckField, 19, 3, 0, 211, 48, 0, // Skip to: 14352
/* 1853 */    MCD::OPC_CheckField, 3, 1, 0, 204, 48, 0, // Skip to: 14352
/* 1860 */    MCD::OPC_Decode, 186, 4, 37, // Opcode: CAS16
/* 1864 */    MCD::OPC_FilterValue, 7, 195, 48, 0, // Skip to: 14352
/* 1869 */    MCD::OPC_CheckPredicate, 0, 190, 48, 0, // Skip to: 14352
/* 1874 */    MCD::OPC_CheckField, 25, 7, 0, 183, 48, 0, // Skip to: 14352
/* 1881 */    MCD::OPC_CheckField, 19, 3, 0, 176, 48, 0, // Skip to: 14352
/* 1888 */    MCD::OPC_CheckField, 3, 1, 0, 169, 48, 0, // Skip to: 14352
/* 1895 */    MCD::OPC_Decode, 187, 4, 38, // Opcode: CAS32
/* 1899 */    MCD::OPC_FilterValue, 14, 49, 0, 0, // Skip to: 1953
/* 1904 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 1907 */    MCD::OPC_FilterValue, 0, 18, 0, 0, // Skip to: 1930
/* 1912 */    MCD::OPC_CheckField, 24, 8, 0, 145, 48, 0, // Skip to: 14352
/* 1919 */    MCD::OPC_CheckField, 9, 3, 4, 138, 48, 0, // Skip to: 14352
/* 1926 */    MCD::OPC_Decode, 254, 3, 3, // Opcode: BSET8ei
/* 1930 */    MCD::OPC_FilterValue, 1, 129, 48, 0, // Skip to: 14352
/* 1935 */    MCD::OPC_CheckField, 24, 8, 0, 122, 48, 0, // Skip to: 14352
/* 1942 */    MCD::OPC_CheckField, 9, 3, 4, 115, 48, 0, // Skip to: 14352
/* 1949 */    MCD::OPC_Decode, 134, 4, 5, // Opcode: BSET8pi
/* 1953 */    MCD::OPC_FilterValue, 15, 32, 0, 0, // Skip to: 1990
/* 1958 */    MCD::OPC_CheckField, 40, 4, 8, 99, 48, 0, // Skip to: 14352
/* 1965 */    MCD::OPC_CheckField, 24, 8, 0, 92, 48, 0, // Skip to: 14352
/* 1972 */    MCD::OPC_CheckField, 9, 3, 4, 85, 48, 0, // Skip to: 14352
/* 1979 */    MCD::OPC_CheckField, 3, 1, 0, 78, 48, 0, // Skip to: 14352
/* 1986 */    MCD::OPC_Decode, 128, 4, 7, // Opcode: BSET8fi
/* 1990 */    MCD::OPC_FilterValue, 16, 4, 0, 0, // Skip to: 1999
/* 1995 */    MCD::OPC_Decode, 138, 4, 39, // Opcode: BTST32dd
/* 1999 */    MCD::OPC_FilterValue, 17, 21, 0, 0, // Skip to: 2025
/* 2004 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 2007 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 2016
/* 2012 */    MCD::OPC_Decode, 144, 4, 40, // Opcode: BTST8jd
/* 2016 */    MCD::OPC_FilterValue, 1, 43, 48, 0, // Skip to: 14352
/* 2021 */    MCD::OPC_Decode, 148, 4, 40, // Opcode: BTST8od
/* 2025 */    MCD::OPC_FilterValue, 18, 21, 0, 0, // Skip to: 2051
/* 2030 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 2033 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 2042
/* 2038 */    MCD::OPC_Decode, 140, 4, 40, // Opcode: BTST8ed
/* 2042 */    MCD::OPC_FilterValue, 1, 17, 48, 0, // Skip to: 14352
/* 2047 */    MCD::OPC_Decode, 150, 4, 41, // Opcode: BTST8pd
/* 2051 */    MCD::OPC_FilterValue, 19, 52, 0, 0, // Skip to: 2108
/* 2056 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 2059 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 2075
/* 2064 */    MCD::OPC_CheckField, 24, 4, 8, 249, 47, 0, // Skip to: 14352
/* 2071 */    MCD::OPC_Decode, 142, 4, 42, // Opcode: BTST8fd
/* 2075 */    MCD::OPC_FilterValue, 1, 240, 47, 0, // Skip to: 14352
/* 2080 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 2083 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 2092
/* 2088 */    MCD::OPC_Decode, 152, 4, 43, // Opcode: BTST8qd
/* 2092 */    MCD::OPC_FilterValue, 3, 223, 47, 0, // Skip to: 14352
/* 2097 */    MCD::OPC_CheckField, 24, 4, 8, 216, 47, 0, // Skip to: 14352
/* 2104 */    MCD::OPC_Decode, 146, 4, 44, // Opcode: BTST8kd
/* 2108 */    MCD::OPC_FilterValue, 20, 4, 0, 0, // Skip to: 2117
/* 2113 */    MCD::OPC_Decode, 224, 3, 39, // Opcode: BCHG32dd
/* 2117 */    MCD::OPC_FilterValue, 21, 21, 0, 0, // Skip to: 2143
/* 2122 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 2125 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 2134
/* 2130 */    MCD::OPC_Decode, 230, 3, 40, // Opcode: BCHG8jd
/* 2134 */    MCD::OPC_FilterValue, 1, 181, 47, 0, // Skip to: 14352
/* 2139 */    MCD::OPC_Decode, 232, 3, 40, // Opcode: BCHG8od
/* 2143 */    MCD::OPC_FilterValue, 22, 21, 0, 0, // Skip to: 2169
/* 2148 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 2151 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 2160
/* 2156 */    MCD::OPC_Decode, 226, 3, 40, // Opcode: BCHG8ed
/* 2160 */    MCD::OPC_FilterValue, 1, 155, 47, 0, // Skip to: 14352
/* 2165 */    MCD::OPC_Decode, 234, 3, 41, // Opcode: BCHG8pd
/* 2169 */    MCD::OPC_FilterValue, 23, 18, 0, 0, // Skip to: 2192
/* 2174 */    MCD::OPC_CheckField, 24, 4, 8, 139, 47, 0, // Skip to: 14352
/* 2181 */    MCD::OPC_CheckField, 3, 1, 0, 132, 47, 0, // Skip to: 14352
/* 2188 */    MCD::OPC_Decode, 228, 3, 42, // Opcode: BCHG8fd
/* 2192 */    MCD::OPC_FilterValue, 24, 4, 0, 0, // Skip to: 2201
/* 2197 */    MCD::OPC_Decode, 236, 3, 39, // Opcode: BCLR32dd
/* 2201 */    MCD::OPC_FilterValue, 25, 21, 0, 0, // Skip to: 2227
/* 2206 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 2209 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 2218
/* 2214 */    MCD::OPC_Decode, 242, 3, 40, // Opcode: BCLR8jd
/* 2218 */    MCD::OPC_FilterValue, 1, 97, 47, 0, // Skip to: 14352
/* 2223 */    MCD::OPC_Decode, 244, 3, 40, // Opcode: BCLR8od
/* 2227 */    MCD::OPC_FilterValue, 26, 21, 0, 0, // Skip to: 2253
/* 2232 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 2235 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 2244
/* 2240 */    MCD::OPC_Decode, 238, 3, 40, // Opcode: BCLR8ed
/* 2244 */    MCD::OPC_FilterValue, 1, 71, 47, 0, // Skip to: 14352
/* 2249 */    MCD::OPC_Decode, 246, 3, 41, // Opcode: BCLR8pd
/* 2253 */    MCD::OPC_FilterValue, 27, 18, 0, 0, // Skip to: 2276
/* 2258 */    MCD::OPC_CheckField, 24, 4, 8, 55, 47, 0, // Skip to: 14352
/* 2265 */    MCD::OPC_CheckField, 3, 1, 0, 48, 47, 0, // Skip to: 14352
/* 2272 */    MCD::OPC_Decode, 240, 3, 42, // Opcode: BCLR8fd
/* 2276 */    MCD::OPC_FilterValue, 28, 4, 0, 0, // Skip to: 2285
/* 2281 */    MCD::OPC_Decode, 251, 3, 39, // Opcode: BSET32dd
/* 2285 */    MCD::OPC_FilterValue, 29, 21, 0, 0, // Skip to: 2311
/* 2290 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 2293 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 2302
/* 2298 */    MCD::OPC_Decode, 129, 4, 40, // Opcode: BSET8jd
/* 2302 */    MCD::OPC_FilterValue, 1, 13, 47, 0, // Skip to: 14352
/* 2307 */    MCD::OPC_Decode, 131, 4, 40, // Opcode: BSET8od
/* 2311 */    MCD::OPC_FilterValue, 30, 21, 0, 0, // Skip to: 2337
/* 2316 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 2319 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 2328
/* 2324 */    MCD::OPC_Decode, 253, 3, 40, // Opcode: BSET8ed
/* 2328 */    MCD::OPC_FilterValue, 1, 243, 46, 0, // Skip to: 14352
/* 2333 */    MCD::OPC_Decode, 133, 4, 41, // Opcode: BSET8pd
/* 2337 */    MCD::OPC_FilterValue, 31, 234, 46, 0, // Skip to: 14352
/* 2342 */    MCD::OPC_CheckField, 24, 4, 8, 227, 46, 0, // Skip to: 14352
/* 2349 */    MCD::OPC_CheckField, 3, 1, 0, 220, 46, 0, // Skip to: 14352
/* 2356 */    MCD::OPC_Decode, 255, 3, 42, // Opcode: BSET8fd
/* 2360 */    MCD::OPC_FilterValue, 1, 254, 4, 0, // Skip to: 3643
/* 2365 */    MCD::OPC_ExtractField, 3, 6,  // Inst{8-3} ...
/* 2368 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 2377
/* 2373 */    MCD::OPC_Decode, 245, 7, 45, // Opcode: MOV8dd
/* 2377 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 2386
/* 2382 */    MCD::OPC_Decode, 249, 7, 46, // Opcode: MOV8dj
/* 2386 */    MCD::OPC_FilterValue, 3, 4, 0, 0, // Skip to: 2395
/* 2391 */    MCD::OPC_Decode, 251, 7, 46, // Opcode: MOV8do
/* 2395 */    MCD::OPC_FilterValue, 4, 4, 0, 0, // Skip to: 2404
/* 2400 */    MCD::OPC_Decode, 246, 7, 46, // Opcode: MOV8de
/* 2404 */    MCD::OPC_FilterValue, 5, 4, 0, 0, // Skip to: 2413
/* 2409 */    MCD::OPC_Decode, 252, 7, 47, // Opcode: MOV8dp
/* 2413 */    MCD::OPC_FilterValue, 6, 11, 0, 0, // Skip to: 2429
/* 2418 */    MCD::OPC_CheckField, 24, 4, 8, 151, 46, 0, // Skip to: 14352
/* 2425 */    MCD::OPC_Decode, 247, 7, 48, // Opcode: MOV8df
/* 2429 */    MCD::OPC_FilterValue, 7, 53, 0, 0, // Skip to: 2487
/* 2434 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 2437 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 2446
/* 2442 */    MCD::OPC_Decode, 244, 7, 49, // Opcode: MOV8db
/* 2446 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 2455
/* 2451 */    MCD::OPC_Decode, 253, 7, 50, // Opcode: MOV8dq
/* 2455 */    MCD::OPC_FilterValue, 3, 11, 0, 0, // Skip to: 2471
/* 2460 */    MCD::OPC_CheckField, 24, 4, 8, 109, 46, 0, // Skip to: 14352
/* 2467 */    MCD::OPC_Decode, 250, 7, 51, // Opcode: MOV8dk
/* 2471 */    MCD::OPC_FilterValue, 4, 100, 46, 0, // Skip to: 14352
/* 2476 */    MCD::OPC_CheckField, 24, 8, 0, 93, 46, 0, // Skip to: 14352
/* 2483 */    MCD::OPC_Decode, 248, 7, 52, // Opcode: MOV8di
/* 2487 */    MCD::OPC_FilterValue, 16, 4, 0, 0, // Skip to: 2496
/* 2492 */    MCD::OPC_Decode, 147, 8, 53, // Opcode: MOV8jd
/* 2496 */    MCD::OPC_FilterValue, 18, 4, 0, 0, // Skip to: 2505
/* 2501 */    MCD::OPC_Decode, 151, 8, 54, // Opcode: MOV8jj
/* 2505 */    MCD::OPC_FilterValue, 19, 4, 0, 0, // Skip to: 2514
/* 2510 */    MCD::OPC_Decode, 153, 8, 54, // Opcode: MOV8jo
/* 2514 */    MCD::OPC_FilterValue, 20, 4, 0, 0, // Skip to: 2523
/* 2519 */    MCD::OPC_Decode, 148, 8, 54, // Opcode: MOV8je
/* 2523 */    MCD::OPC_FilterValue, 21, 4, 0, 0, // Skip to: 2532
/* 2528 */    MCD::OPC_Decode, 154, 8, 55, // Opcode: MOV8jp
/* 2532 */    MCD::OPC_FilterValue, 22, 11, 0, 0, // Skip to: 2548
/* 2537 */    MCD::OPC_CheckField, 24, 4, 8, 32, 46, 0, // Skip to: 14352
/* 2544 */    MCD::OPC_Decode, 149, 8, 56, // Opcode: MOV8jf
/* 2548 */    MCD::OPC_FilterValue, 23, 53, 0, 0, // Skip to: 2606
/* 2553 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 2556 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 2565
/* 2561 */    MCD::OPC_Decode, 146, 8, 57, // Opcode: MOV8jb
/* 2565 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 2574
/* 2570 */    MCD::OPC_Decode, 155, 8, 58, // Opcode: MOV8jq
/* 2574 */    MCD::OPC_FilterValue, 3, 11, 0, 0, // Skip to: 2590
/* 2579 */    MCD::OPC_CheckField, 24, 4, 8, 246, 45, 0, // Skip to: 14352
/* 2586 */    MCD::OPC_Decode, 152, 8, 59, // Opcode: MOV8jk
/* 2590 */    MCD::OPC_FilterValue, 4, 237, 45, 0, // Skip to: 14352
/* 2595 */    MCD::OPC_CheckField, 24, 8, 0, 230, 45, 0, // Skip to: 14352
/* 2602 */    MCD::OPC_Decode, 150, 8, 60, // Opcode: MOV8ji
/* 2606 */    MCD::OPC_FilterValue, 24, 4, 0, 0, // Skip to: 2615
/* 2611 */    MCD::OPC_Decode, 167, 8, 53, // Opcode: MOV8od
/* 2615 */    MCD::OPC_FilterValue, 26, 4, 0, 0, // Skip to: 2624
/* 2620 */    MCD::OPC_Decode, 171, 8, 54, // Opcode: MOV8oj
/* 2624 */    MCD::OPC_FilterValue, 27, 4, 0, 0, // Skip to: 2633
/* 2629 */    MCD::OPC_Decode, 173, 8, 54, // Opcode: MOV8oo
/* 2633 */    MCD::OPC_FilterValue, 28, 4, 0, 0, // Skip to: 2642
/* 2638 */    MCD::OPC_Decode, 168, 8, 54, // Opcode: MOV8oe
/* 2642 */    MCD::OPC_FilterValue, 29, 4, 0, 0, // Skip to: 2651
/* 2647 */    MCD::OPC_Decode, 174, 8, 55, // Opcode: MOV8op
/* 2651 */    MCD::OPC_FilterValue, 30, 11, 0, 0, // Skip to: 2667
/* 2656 */    MCD::OPC_CheckField, 24, 4, 8, 169, 45, 0, // Skip to: 14352
/* 2663 */    MCD::OPC_Decode, 169, 8, 56, // Opcode: MOV8of
/* 2667 */    MCD::OPC_FilterValue, 31, 53, 0, 0, // Skip to: 2725
/* 2672 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 2675 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 2684
/* 2680 */    MCD::OPC_Decode, 166, 8, 57, // Opcode: MOV8ob
/* 2684 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 2693
/* 2689 */    MCD::OPC_Decode, 175, 8, 58, // Opcode: MOV8oq
/* 2693 */    MCD::OPC_FilterValue, 3, 11, 0, 0, // Skip to: 2709
/* 2698 */    MCD::OPC_CheckField, 24, 4, 8, 127, 45, 0, // Skip to: 14352
/* 2705 */    MCD::OPC_Decode, 172, 8, 59, // Opcode: MOV8ok
/* 2709 */    MCD::OPC_FilterValue, 4, 118, 45, 0, // Skip to: 14352
/* 2714 */    MCD::OPC_CheckField, 24, 8, 0, 111, 45, 0, // Skip to: 14352
/* 2721 */    MCD::OPC_Decode, 170, 8, 60, // Opcode: MOV8oi
/* 2725 */    MCD::OPC_FilterValue, 32, 4, 0, 0, // Skip to: 2734
/* 2730 */    MCD::OPC_Decode, 255, 7, 53, // Opcode: MOV8ed
/* 2734 */    MCD::OPC_FilterValue, 34, 4, 0, 0, // Skip to: 2743
/* 2739 */    MCD::OPC_Decode, 131, 8, 54, // Opcode: MOV8ej
/* 2743 */    MCD::OPC_FilterValue, 35, 4, 0, 0, // Skip to: 2752
/* 2748 */    MCD::OPC_Decode, 133, 8, 54, // Opcode: MOV8eo
/* 2752 */    MCD::OPC_FilterValue, 36, 4, 0, 0, // Skip to: 2761
/* 2757 */    MCD::OPC_Decode, 128, 8, 54, // Opcode: MOV8ee
/* 2761 */    MCD::OPC_FilterValue, 37, 4, 0, 0, // Skip to: 2770
/* 2766 */    MCD::OPC_Decode, 134, 8, 55, // Opcode: MOV8ep
/* 2770 */    MCD::OPC_FilterValue, 38, 11, 0, 0, // Skip to: 2786
/* 2775 */    MCD::OPC_CheckField, 24, 4, 8, 50, 45, 0, // Skip to: 14352
/* 2782 */    MCD::OPC_Decode, 129, 8, 56, // Opcode: MOV8ef
/* 2786 */    MCD::OPC_FilterValue, 39, 53, 0, 0, // Skip to: 2844
/* 2791 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 2794 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 2803
/* 2799 */    MCD::OPC_Decode, 254, 7, 57, // Opcode: MOV8eb
/* 2803 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 2812
/* 2808 */    MCD::OPC_Decode, 135, 8, 58, // Opcode: MOV8eq
/* 2812 */    MCD::OPC_FilterValue, 3, 11, 0, 0, // Skip to: 2828
/* 2817 */    MCD::OPC_CheckField, 24, 4, 8, 8, 45, 0, // Skip to: 14352
/* 2824 */    MCD::OPC_Decode, 132, 8, 59, // Opcode: MOV8ek
/* 2828 */    MCD::OPC_FilterValue, 4, 255, 44, 0, // Skip to: 14352
/* 2833 */    MCD::OPC_CheckField, 24, 8, 0, 248, 44, 0, // Skip to: 14352
/* 2840 */    MCD::OPC_Decode, 130, 8, 60, // Opcode: MOV8ei
/* 2844 */    MCD::OPC_FilterValue, 40, 4, 0, 0, // Skip to: 2853
/* 2849 */    MCD::OPC_Decode, 177, 8, 61, // Opcode: MOV8pd
/* 2853 */    MCD::OPC_FilterValue, 42, 4, 0, 0, // Skip to: 2862
/* 2858 */    MCD::OPC_Decode, 181, 8, 62, // Opcode: MOV8pj
/* 2862 */    MCD::OPC_FilterValue, 43, 4, 0, 0, // Skip to: 2871
/* 2867 */    MCD::OPC_Decode, 183, 8, 62, // Opcode: MOV8po
/* 2871 */    MCD::OPC_FilterValue, 44, 4, 0, 0, // Skip to: 2880
/* 2876 */    MCD::OPC_Decode, 178, 8, 62, // Opcode: MOV8pe
/* 2880 */    MCD::OPC_FilterValue, 45, 4, 0, 0, // Skip to: 2889
/* 2885 */    MCD::OPC_Decode, 184, 8, 63, // Opcode: MOV8pp
/* 2889 */    MCD::OPC_FilterValue, 46, 11, 0, 0, // Skip to: 2905
/* 2894 */    MCD::OPC_CheckField, 24, 4, 8, 187, 44, 0, // Skip to: 14352
/* 2901 */    MCD::OPC_Decode, 179, 8, 64, // Opcode: MOV8pf
/* 2905 */    MCD::OPC_FilterValue, 47, 53, 0, 0, // Skip to: 2963
/* 2910 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 2913 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 2922
/* 2918 */    MCD::OPC_Decode, 176, 8, 65, // Opcode: MOV8pb
/* 2922 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 2931
/* 2927 */    MCD::OPC_Decode, 185, 8, 66, // Opcode: MOV8pq
/* 2931 */    MCD::OPC_FilterValue, 3, 11, 0, 0, // Skip to: 2947
/* 2936 */    MCD::OPC_CheckField, 24, 4, 8, 145, 44, 0, // Skip to: 14352
/* 2943 */    MCD::OPC_Decode, 182, 8, 67, // Opcode: MOV8pk
/* 2947 */    MCD::OPC_FilterValue, 4, 136, 44, 0, // Skip to: 14352
/* 2952 */    MCD::OPC_CheckField, 24, 8, 0, 129, 44, 0, // Skip to: 14352
/* 2959 */    MCD::OPC_Decode, 180, 8, 68, // Opcode: MOV8pi
/* 2963 */    MCD::OPC_FilterValue, 48, 11, 0, 0, // Skip to: 2979
/* 2968 */    MCD::OPC_CheckField, 24, 4, 8, 113, 44, 0, // Skip to: 14352
/* 2975 */    MCD::OPC_Decode, 137, 8, 69, // Opcode: MOV8fd
/* 2979 */    MCD::OPC_FilterValue, 50, 11, 0, 0, // Skip to: 2995
/* 2984 */    MCD::OPC_CheckField, 24, 4, 8, 97, 44, 0, // Skip to: 14352
/* 2991 */    MCD::OPC_Decode, 141, 8, 70, // Opcode: MOV8fj
/* 2995 */    MCD::OPC_FilterValue, 51, 11, 0, 0, // Skip to: 3011
/* 3000 */    MCD::OPC_CheckField, 24, 4, 8, 81, 44, 0, // Skip to: 14352
/* 3007 */    MCD::OPC_Decode, 143, 8, 70, // Opcode: MOV8fo
/* 3011 */    MCD::OPC_FilterValue, 52, 11, 0, 0, // Skip to: 3027
/* 3016 */    MCD::OPC_CheckField, 24, 4, 8, 65, 44, 0, // Skip to: 14352
/* 3023 */    MCD::OPC_Decode, 138, 8, 70, // Opcode: MOV8fe
/* 3027 */    MCD::OPC_FilterValue, 53, 11, 0, 0, // Skip to: 3043
/* 3032 */    MCD::OPC_CheckField, 40, 4, 8, 49, 44, 0, // Skip to: 14352
/* 3039 */    MCD::OPC_Decode, 144, 8, 71, // Opcode: MOV8fp
/* 3043 */    MCD::OPC_FilterValue, 54, 18, 0, 0, // Skip to: 3066
/* 3048 */    MCD::OPC_CheckField, 40, 4, 8, 33, 44, 0, // Skip to: 14352
/* 3055 */    MCD::OPC_CheckField, 24, 4, 8, 26, 44, 0, // Skip to: 14352
/* 3062 */    MCD::OPC_Decode, 139, 8, 72, // Opcode: MOV8ff
/* 3066 */    MCD::OPC_FilterValue, 55, 81, 0, 0, // Skip to: 3152
/* 3071 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 3074 */    MCD::OPC_FilterValue, 1, 11, 0, 0, // Skip to: 3090
/* 3079 */    MCD::OPC_CheckField, 56, 4, 8, 2, 44, 0, // Skip to: 14352
/* 3086 */    MCD::OPC_Decode, 136, 8, 73, // Opcode: MOV8fb
/* 3090 */    MCD::OPC_FilterValue, 2, 11, 0, 0, // Skip to: 3106
/* 3095 */    MCD::OPC_CheckField, 40, 4, 8, 242, 43, 0, // Skip to: 14352
/* 3102 */    MCD::OPC_Decode, 145, 8, 74, // Opcode: MOV8fq
/* 3106 */    MCD::OPC_FilterValue, 3, 18, 0, 0, // Skip to: 3129
/* 3111 */    MCD::OPC_CheckField, 40, 4, 8, 226, 43, 0, // Skip to: 14352
/* 3118 */    MCD::OPC_CheckField, 24, 4, 8, 219, 43, 0, // Skip to: 14352
/* 3125 */    MCD::OPC_Decode, 142, 8, 75, // Opcode: MOV8fk
/* 3129 */    MCD::OPC_FilterValue, 4, 210, 43, 0, // Skip to: 14352
/* 3134 */    MCD::OPC_CheckField, 40, 4, 8, 203, 43, 0, // Skip to: 14352
/* 3141 */    MCD::OPC_CheckField, 24, 8, 0, 196, 43, 0, // Skip to: 14352
/* 3148 */    MCD::OPC_Decode, 140, 8, 76, // Opcode: MOV8fi
/* 3152 */    MCD::OPC_FilterValue, 56, 37, 0, 0, // Skip to: 3194
/* 3157 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 3160 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 3169
/* 3165 */    MCD::OPC_Decode, 235, 7, 77, // Opcode: MOV8bd
/* 3169 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 3178
/* 3174 */    MCD::OPC_Decode, 187, 8, 78, // Opcode: MOV8qd
/* 3178 */    MCD::OPC_FilterValue, 3, 161, 43, 0, // Skip to: 14352
/* 3183 */    MCD::OPC_CheckField, 24, 4, 8, 154, 43, 0, // Skip to: 14352
/* 3190 */    MCD::OPC_Decode, 157, 8, 79, // Opcode: MOV8kd
/* 3194 */    MCD::OPC_FilterValue, 58, 37, 0, 0, // Skip to: 3236
/* 3199 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 3202 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 3211
/* 3207 */    MCD::OPC_Decode, 239, 7, 28, // Opcode: MOV8bj
/* 3211 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 3220
/* 3216 */    MCD::OPC_Decode, 191, 8, 17, // Opcode: MOV8qj
/* 3220 */    MCD::OPC_FilterValue, 3, 119, 43, 0, // Skip to: 14352
/* 3225 */    MCD::OPC_CheckField, 24, 4, 8, 112, 43, 0, // Skip to: 14352
/* 3232 */    MCD::OPC_Decode, 161, 8, 80, // Opcode: MOV8kj
/* 3236 */    MCD::OPC_FilterValue, 59, 37, 0, 0, // Skip to: 3278
/* 3241 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 3244 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 3253
/* 3249 */    MCD::OPC_Decode, 241, 7, 28, // Opcode: MOV8bo
/* 3253 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 3262
/* 3258 */    MCD::OPC_Decode, 193, 8, 17, // Opcode: MOV8qo
/* 3262 */    MCD::OPC_FilterValue, 3, 77, 43, 0, // Skip to: 14352
/* 3267 */    MCD::OPC_CheckField, 24, 4, 8, 70, 43, 0, // Skip to: 14352
/* 3274 */    MCD::OPC_Decode, 163, 8, 80, // Opcode: MOV8ko
/* 3278 */    MCD::OPC_FilterValue, 60, 37, 0, 0, // Skip to: 3320
/* 3283 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 3286 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 3295
/* 3291 */    MCD::OPC_Decode, 236, 7, 28, // Opcode: MOV8be
/* 3295 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 3304
/* 3300 */    MCD::OPC_Decode, 188, 8, 17, // Opcode: MOV8qe
/* 3304 */    MCD::OPC_FilterValue, 3, 35, 43, 0, // Skip to: 14352
/* 3309 */    MCD::OPC_CheckField, 24, 4, 8, 28, 43, 0, // Skip to: 14352
/* 3316 */    MCD::OPC_Decode, 158, 8, 80, // Opcode: MOV8ke
/* 3320 */    MCD::OPC_FilterValue, 61, 37, 0, 0, // Skip to: 3362
/* 3325 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 3328 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 3337
/* 3333 */    MCD::OPC_Decode, 242, 7, 81, // Opcode: MOV8bp
/* 3337 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 3346
/* 3342 */    MCD::OPC_Decode, 194, 8, 82, // Opcode: MOV8qp
/* 3346 */    MCD::OPC_FilterValue, 3, 249, 42, 0, // Skip to: 14352
/* 3351 */    MCD::OPC_CheckField, 40, 4, 8, 242, 42, 0, // Skip to: 14352
/* 3358 */    MCD::OPC_Decode, 164, 8, 83, // Opcode: MOV8kp
/* 3362 */    MCD::OPC_FilterValue, 62, 58, 0, 0, // Skip to: 3425
/* 3367 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 3370 */    MCD::OPC_FilterValue, 1, 11, 0, 0, // Skip to: 3386
/* 3375 */    MCD::OPC_CheckField, 24, 4, 8, 218, 42, 0, // Skip to: 14352
/* 3382 */    MCD::OPC_Decode, 237, 7, 84, // Opcode: MOV8bf
/* 3386 */    MCD::OPC_FilterValue, 2, 11, 0, 0, // Skip to: 3402
/* 3391 */    MCD::OPC_CheckField, 24, 4, 8, 202, 42, 0, // Skip to: 14352
/* 3398 */    MCD::OPC_Decode, 189, 8, 85, // Opcode: MOV8qf
/* 3402 */    MCD::OPC_FilterValue, 3, 193, 42, 0, // Skip to: 14352
/* 3407 */    MCD::OPC_CheckField, 40, 4, 8, 186, 42, 0, // Skip to: 14352
/* 3414 */    MCD::OPC_CheckField, 24, 4, 8, 179, 42, 0, // Skip to: 14352
/* 3421 */    MCD::OPC_Decode, 159, 8, 86, // Opcode: MOV8kf
/* 3425 */    MCD::OPC_FilterValue, 63, 170, 42, 0, // Skip to: 14352
/* 3430 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 3433 */    MCD::OPC_FilterValue, 1, 37, 0, 0, // Skip to: 3475
/* 3438 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 3441 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 3450
/* 3446 */    MCD::OPC_Decode, 234, 7, 87, // Opcode: MOV8bb
/* 3450 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 3459
/* 3455 */    MCD::OPC_Decode, 186, 8, 88, // Opcode: MOV8qb
/* 3459 */    MCD::OPC_FilterValue, 3, 136, 42, 0, // Skip to: 14352
/* 3464 */    MCD::OPC_CheckField, 56, 4, 8, 129, 42, 0, // Skip to: 14352
/* 3471 */    MCD::OPC_Decode, 156, 8, 89, // Opcode: MOV8kb
/* 3475 */    MCD::OPC_FilterValue, 2, 37, 0, 0, // Skip to: 3517
/* 3480 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 3483 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 3492
/* 3488 */    MCD::OPC_Decode, 243, 7, 90, // Opcode: MOV8bq
/* 3492 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 3501
/* 3497 */    MCD::OPC_Decode, 195, 8, 91, // Opcode: MOV8qq
/* 3501 */    MCD::OPC_FilterValue, 3, 94, 42, 0, // Skip to: 14352
/* 3506 */    MCD::OPC_CheckField, 40, 4, 8, 87, 42, 0, // Skip to: 14352
/* 3513 */    MCD::OPC_Decode, 165, 8, 92, // Opcode: MOV8kq
/* 3517 */    MCD::OPC_FilterValue, 3, 58, 0, 0, // Skip to: 3580
/* 3522 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 3525 */    MCD::OPC_FilterValue, 1, 11, 0, 0, // Skip to: 3541
/* 3530 */    MCD::OPC_CheckField, 24, 4, 8, 63, 42, 0, // Skip to: 14352
/* 3537 */    MCD::OPC_Decode, 240, 7, 93, // Opcode: MOV8bk
/* 3541 */    MCD::OPC_FilterValue, 2, 11, 0, 0, // Skip to: 3557
/* 3546 */    MCD::OPC_CheckField, 24, 4, 8, 47, 42, 0, // Skip to: 14352
/* 3553 */    MCD::OPC_Decode, 192, 8, 94, // Opcode: MOV8qk
/* 3557 */    MCD::OPC_FilterValue, 3, 38, 42, 0, // Skip to: 14352
/* 3562 */    MCD::OPC_CheckField, 40, 4, 8, 31, 42, 0, // Skip to: 14352
/* 3569 */    MCD::OPC_CheckField, 24, 4, 8, 24, 42, 0, // Skip to: 14352
/* 3576 */    MCD::OPC_Decode, 162, 8, 95, // Opcode: MOV8kk
/* 3580 */    MCD::OPC_FilterValue, 4, 15, 42, 0, // Skip to: 14352
/* 3585 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 3588 */    MCD::OPC_FilterValue, 1, 11, 0, 0, // Skip to: 3604
/* 3593 */    MCD::OPC_CheckField, 24, 8, 0, 0, 42, 0, // Skip to: 14352
/* 3600 */    MCD::OPC_Decode, 238, 7, 96, // Opcode: MOV8bi
/* 3604 */    MCD::OPC_FilterValue, 2, 11, 0, 0, // Skip to: 3620
/* 3609 */    MCD::OPC_CheckField, 24, 8, 0, 240, 41, 0, // Skip to: 14352
/* 3616 */    MCD::OPC_Decode, 190, 8, 8, // Opcode: MOV8qi
/* 3620 */    MCD::OPC_FilterValue, 3, 231, 41, 0, // Skip to: 14352
/* 3625 */    MCD::OPC_CheckField, 40, 4, 8, 224, 41, 0, // Skip to: 14352
/* 3632 */    MCD::OPC_CheckField, 24, 8, 0, 217, 41, 0, // Skip to: 14352
/* 3639 */    MCD::OPC_Decode, 160, 8, 9, // Opcode: MOV8ki
/* 3643 */    MCD::OPC_FilterValue, 2, 178, 7, 0, // Skip to: 5618
/* 3648 */    MCD::OPC_ExtractField, 4, 2,  // Inst{5-4} ...
/* 3651 */    MCD::OPC_FilterValue, 0, 94, 1, 0, // Skip to: 4006
/* 3656 */    MCD::OPC_ExtractField, 7, 2,  // Inst{8-7} ...
/* 3659 */    MCD::OPC_FilterValue, 0, 54, 0, 0, // Skip to: 3718
/* 3664 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 3667 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 3683
/* 3672 */    MCD::OPC_CheckField, 6, 1, 0, 24, 0, 0, // Skip to: 3703
/* 3679 */    MCD::OPC_Decode, 250, 6, 97, // Opcode: MOV32dd
/* 3683 */    MCD::OPC_FilterValue, 1, 15, 0, 0, // Skip to: 3703
/* 3688 */    MCD::OPC_CheckField, 6, 1, 1, 4, 0, 0, // Skip to: 3699
/* 3695 */    MCD::OPC_Decode, 218, 6, 54, // Opcode: MOV32aa
/* 3699 */    MCD::OPC_Decode, 215, 7, 98, // Opcode: MOV32ra
/* 3703 */    MCD::OPC_CheckField, 6, 1, 1, 4, 0, 0, // Skip to: 3714
/* 3710 */    MCD::OPC_Decode, 236, 6, 99, // Opcode: MOV32ar
/* 3714 */    MCD::OPC_Decode, 233, 7, 100, // Opcode: MOV32rr
/* 3718 */    MCD::OPC_FilterValue, 1, 63, 0, 0, // Skip to: 3786
/* 3723 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 3726 */    MCD::OPC_FilterValue, 0, 25, 0, 0, // Skip to: 3756
/* 3731 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 3734 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 3743
/* 3739 */    MCD::OPC_Decode, 157, 7, 101, // Opcode: MOV32jd
/* 3743 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 3752
/* 3748 */    MCD::OPC_Decode, 155, 7, 54, // Opcode: MOV32ja
/* 3752 */    MCD::OPC_Decode, 166, 7, 99, // Opcode: MOV32jr
/* 3756 */    MCD::OPC_FilterValue, 1, 95, 41, 0, // Skip to: 14352
/* 3761 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 3764 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 3773
/* 3769 */    MCD::OPC_Decode, 181, 7, 101, // Opcode: MOV32od
/* 3773 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 3782
/* 3778 */    MCD::OPC_Decode, 179, 7, 54, // Opcode: MOV32oa
/* 3782 */    MCD::OPC_Decode, 190, 7, 99, // Opcode: MOV32or
/* 3786 */    MCD::OPC_FilterValue, 2, 63, 0, 0, // Skip to: 3854
/* 3791 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 3794 */    MCD::OPC_FilterValue, 0, 25, 0, 0, // Skip to: 3824
/* 3799 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 3802 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 3811
/* 3807 */    MCD::OPC_Decode, 133, 7, 101, // Opcode: MOV32ed
/* 3811 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 3820
/* 3816 */    MCD::OPC_Decode, 131, 7, 54, // Opcode: MOV32ea
/* 3820 */    MCD::OPC_Decode, 142, 7, 99, // Opcode: MOV32er
/* 3824 */    MCD::OPC_FilterValue, 1, 27, 41, 0, // Skip to: 14352
/* 3829 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 3832 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 3841
/* 3837 */    MCD::OPC_Decode, 193, 7, 102, // Opcode: MOV32pd
/* 3841 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 3850
/* 3846 */    MCD::OPC_Decode, 191, 7, 62, // Opcode: MOV32pa
/* 3850 */    MCD::OPC_Decode, 202, 7, 103, // Opcode: MOV32pr
/* 3854 */    MCD::OPC_FilterValue, 3, 253, 40, 0, // Skip to: 14352
/* 3859 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 3862 */    MCD::OPC_FilterValue, 0, 33, 0, 0, // Skip to: 3900
/* 3867 */    MCD::OPC_ExtractField, 24, 4,  // Inst{27-24} ...
/* 3870 */    MCD::OPC_FilterValue, 8, 237, 40, 0, // Skip to: 14352
/* 3875 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 3878 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 3887
/* 3883 */    MCD::OPC_Decode, 145, 7, 104, // Opcode: MOV32fd
/* 3887 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 3896
/* 3892 */    MCD::OPC_Decode, 143, 7, 70, // Opcode: MOV32fa
/* 3896 */    MCD::OPC_Decode, 154, 7, 105, // Opcode: MOV32fr
/* 3900 */    MCD::OPC_FilterValue, 1, 207, 40, 0, // Skip to: 14352
/* 3905 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 3908 */    MCD::OPC_FilterValue, 1, 25, 0, 0, // Skip to: 3938
/* 3913 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 3916 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 3925
/* 3921 */    MCD::OPC_Decode, 239, 6, 26, // Opcode: MOV32bd
/* 3925 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 3934
/* 3930 */    MCD::OPC_Decode, 237, 6, 28, // Opcode: MOV32ba
/* 3934 */    MCD::OPC_Decode, 248, 6, 106, // Opcode: MOV32br
/* 3938 */    MCD::OPC_FilterValue, 2, 25, 0, 0, // Skip to: 3968
/* 3943 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 3946 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 3955
/* 3951 */    MCD::OPC_Decode, 205, 7, 107, // Opcode: MOV32qd
/* 3955 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 3964
/* 3960 */    MCD::OPC_Decode, 203, 7, 17, // Opcode: MOV32qa
/* 3964 */    MCD::OPC_Decode, 214, 7, 108, // Opcode: MOV32qr
/* 3968 */    MCD::OPC_FilterValue, 3, 139, 40, 0, // Skip to: 14352
/* 3973 */    MCD::OPC_ExtractField, 24, 4,  // Inst{27-24} ...
/* 3976 */    MCD::OPC_FilterValue, 8, 131, 40, 0, // Skip to: 14352
/* 3981 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 3984 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 3993
/* 3989 */    MCD::OPC_Decode, 169, 7, 109, // Opcode: MOV32kd
/* 3993 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 4002
/* 3998 */    MCD::OPC_Decode, 167, 7, 80, // Opcode: MOV32ka
/* 4002 */    MCD::OPC_Decode, 178, 7, 110, // Opcode: MOV32kr
/* 4006 */    MCD::OPC_FilterValue, 1, 75, 1, 0, // Skip to: 4342
/* 4011 */    MCD::OPC_ExtractField, 7, 2,  // Inst{8-7} ...
/* 4014 */    MCD::OPC_FilterValue, 0, 63, 0, 0, // Skip to: 4082
/* 4019 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 4022 */    MCD::OPC_FilterValue, 0, 25, 0, 0, // Skip to: 4052
/* 4027 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 4030 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 4039
/* 4035 */    MCD::OPC_Decode, 254, 6, 111, // Opcode: MOV32dj
/* 4039 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 4048
/* 4044 */    MCD::OPC_Decode, 226, 6, 54, // Opcode: MOV32aj
/* 4048 */    MCD::OPC_Decode, 223, 7, 98, // Opcode: MOV32rj
/* 4052 */    MCD::OPC_FilterValue, 1, 55, 40, 0, // Skip to: 14352
/* 4057 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 4060 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 4069
/* 4065 */    MCD::OPC_Decode, 128, 7, 111, // Opcode: MOV32do
/* 4069 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 4078
/* 4074 */    MCD::OPC_Decode, 230, 6, 54, // Opcode: MOV32ao
/* 4078 */    MCD::OPC_Decode, 227, 7, 98, // Opcode: MOV32ro
/* 4082 */    MCD::OPC_FilterValue, 1, 55, 0, 0, // Skip to: 4142
/* 4087 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 4090 */    MCD::OPC_FilterValue, 0, 21, 0, 0, // Skip to: 4116
/* 4095 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 4098 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 4107
/* 4103 */    MCD::OPC_Decode, 161, 7, 54, // Opcode: MOV32jj
/* 4107 */    MCD::OPC_FilterValue, 1, 0, 40, 0, // Skip to: 14352
/* 4112 */    MCD::OPC_Decode, 185, 7, 54, // Opcode: MOV32oj
/* 4116 */    MCD::OPC_FilterValue, 1, 247, 39, 0, // Skip to: 14352
/* 4121 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 4124 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 4133
/* 4129 */    MCD::OPC_Decode, 163, 7, 54, // Opcode: MOV32jo
/* 4133 */    MCD::OPC_FilterValue, 1, 230, 39, 0, // Skip to: 14352
/* 4138 */    MCD::OPC_Decode, 187, 7, 54, // Opcode: MOV32oo
/* 4142 */    MCD::OPC_FilterValue, 2, 55, 0, 0, // Skip to: 4202
/* 4147 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 4150 */    MCD::OPC_FilterValue, 0, 21, 0, 0, // Skip to: 4176
/* 4155 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 4158 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 4167
/* 4163 */    MCD::OPC_Decode, 137, 7, 54, // Opcode: MOV32ej
/* 4167 */    MCD::OPC_FilterValue, 1, 196, 39, 0, // Skip to: 14352
/* 4172 */    MCD::OPC_Decode, 197, 7, 62, // Opcode: MOV32pj
/* 4176 */    MCD::OPC_FilterValue, 1, 187, 39, 0, // Skip to: 14352
/* 4181 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 4184 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 4193
/* 4189 */    MCD::OPC_Decode, 139, 7, 54, // Opcode: MOV32eo
/* 4193 */    MCD::OPC_FilterValue, 1, 170, 39, 0, // Skip to: 14352
/* 4198 */    MCD::OPC_Decode, 199, 7, 62, // Opcode: MOV32po
/* 4202 */    MCD::OPC_FilterValue, 3, 161, 39, 0, // Skip to: 14352
/* 4207 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 4210 */    MCD::OPC_FilterValue, 0, 61, 0, 0, // Skip to: 4276
/* 4215 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 4218 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 4234
/* 4223 */    MCD::OPC_CheckField, 24, 4, 8, 138, 39, 0, // Skip to: 14352
/* 4230 */    MCD::OPC_Decode, 149, 7, 70, // Opcode: MOV32fj
/* 4234 */    MCD::OPC_FilterValue, 1, 129, 39, 0, // Skip to: 14352
/* 4239 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 4242 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 4251
/* 4247 */    MCD::OPC_Decode, 243, 6, 28, // Opcode: MOV32bj
/* 4251 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 4260
/* 4256 */    MCD::OPC_Decode, 209, 7, 17, // Opcode: MOV32qj
/* 4260 */    MCD::OPC_FilterValue, 3, 103, 39, 0, // Skip to: 14352
/* 4265 */    MCD::OPC_CheckField, 24, 4, 8, 96, 39, 0, // Skip to: 14352
/* 4272 */    MCD::OPC_Decode, 173, 7, 80, // Opcode: MOV32kj
/* 4276 */    MCD::OPC_FilterValue, 1, 87, 39, 0, // Skip to: 14352
/* 4281 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 4284 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 4300
/* 4289 */    MCD::OPC_CheckField, 24, 4, 8, 72, 39, 0, // Skip to: 14352
/* 4296 */    MCD::OPC_Decode, 151, 7, 70, // Opcode: MOV32fo
/* 4300 */    MCD::OPC_FilterValue, 1, 63, 39, 0, // Skip to: 14352
/* 4305 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 4308 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 4317
/* 4313 */    MCD::OPC_Decode, 245, 6, 28, // Opcode: MOV32bo
/* 4317 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 4326
/* 4322 */    MCD::OPC_Decode, 211, 7, 17, // Opcode: MOV32qo
/* 4326 */    MCD::OPC_FilterValue, 3, 37, 39, 0, // Skip to: 14352
/* 4331 */    MCD::OPC_CheckField, 24, 4, 8, 30, 39, 0, // Skip to: 14352
/* 4338 */    MCD::OPC_Decode, 175, 7, 80, // Opcode: MOV32ko
/* 4342 */    MCD::OPC_FilterValue, 2, 75, 1, 0, // Skip to: 4678
/* 4347 */    MCD::OPC_ExtractField, 7, 2,  // Inst{8-7} ...
/* 4350 */    MCD::OPC_FilterValue, 0, 63, 0, 0, // Skip to: 4418
/* 4355 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 4358 */    MCD::OPC_FilterValue, 0, 25, 0, 0, // Skip to: 4388
/* 4363 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 4366 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 4375
/* 4371 */    MCD::OPC_Decode, 251, 6, 111, // Opcode: MOV32de
/* 4375 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 4384
/* 4380 */    MCD::OPC_Decode, 221, 6, 54, // Opcode: MOV32ae
/* 4384 */    MCD::OPC_Decode, 218, 7, 98, // Opcode: MOV32re
/* 4388 */    MCD::OPC_FilterValue, 1, 231, 38, 0, // Skip to: 14352
/* 4393 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 4396 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 4405
/* 4401 */    MCD::OPC_Decode, 129, 7, 112, // Opcode: MOV32dp
/* 4405 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 4414
/* 4410 */    MCD::OPC_Decode, 232, 6, 55, // Opcode: MOV32ap
/* 4414 */    MCD::OPC_Decode, 229, 7, 113, // Opcode: MOV32rp
/* 4418 */    MCD::OPC_FilterValue, 1, 55, 0, 0, // Skip to: 4478
/* 4423 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 4426 */    MCD::OPC_FilterValue, 0, 21, 0, 0, // Skip to: 4452
/* 4431 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 4434 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 4443
/* 4439 */    MCD::OPC_Decode, 158, 7, 54, // Opcode: MOV32je
/* 4443 */    MCD::OPC_FilterValue, 1, 176, 38, 0, // Skip to: 14352
/* 4448 */    MCD::OPC_Decode, 182, 7, 54, // Opcode: MOV32oe
/* 4452 */    MCD::OPC_FilterValue, 1, 167, 38, 0, // Skip to: 14352
/* 4457 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 4460 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 4469
/* 4465 */    MCD::OPC_Decode, 164, 7, 55, // Opcode: MOV32jp
/* 4469 */    MCD::OPC_FilterValue, 1, 150, 38, 0, // Skip to: 14352
/* 4474 */    MCD::OPC_Decode, 188, 7, 55, // Opcode: MOV32op
/* 4478 */    MCD::OPC_FilterValue, 2, 55, 0, 0, // Skip to: 4538
/* 4483 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 4486 */    MCD::OPC_FilterValue, 0, 21, 0, 0, // Skip to: 4512
/* 4491 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 4494 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 4503
/* 4499 */    MCD::OPC_Decode, 134, 7, 54, // Opcode: MOV32ee
/* 4503 */    MCD::OPC_FilterValue, 1, 116, 38, 0, // Skip to: 14352
/* 4508 */    MCD::OPC_Decode, 194, 7, 62, // Opcode: MOV32pe
/* 4512 */    MCD::OPC_FilterValue, 1, 107, 38, 0, // Skip to: 14352
/* 4517 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 4520 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 4529
/* 4525 */    MCD::OPC_Decode, 140, 7, 55, // Opcode: MOV32ep
/* 4529 */    MCD::OPC_FilterValue, 1, 90, 38, 0, // Skip to: 14352
/* 4534 */    MCD::OPC_Decode, 200, 7, 63, // Opcode: MOV32pp
/* 4538 */    MCD::OPC_FilterValue, 3, 81, 38, 0, // Skip to: 14352
/* 4543 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 4546 */    MCD::OPC_FilterValue, 0, 61, 0, 0, // Skip to: 4612
/* 4551 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 4554 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 4570
/* 4559 */    MCD::OPC_CheckField, 24, 4, 8, 58, 38, 0, // Skip to: 14352
/* 4566 */    MCD::OPC_Decode, 146, 7, 70, // Opcode: MOV32fe
/* 4570 */    MCD::OPC_FilterValue, 1, 49, 38, 0, // Skip to: 14352
/* 4575 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 4578 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 4587
/* 4583 */    MCD::OPC_Decode, 240, 6, 28, // Opcode: MOV32be
/* 4587 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 4596
/* 4592 */    MCD::OPC_Decode, 206, 7, 17, // Opcode: MOV32qe
/* 4596 */    MCD::OPC_FilterValue, 3, 23, 38, 0, // Skip to: 14352
/* 4601 */    MCD::OPC_CheckField, 24, 4, 8, 16, 38, 0, // Skip to: 14352
/* 4608 */    MCD::OPC_Decode, 170, 7, 80, // Opcode: MOV32ke
/* 4612 */    MCD::OPC_FilterValue, 1, 7, 38, 0, // Skip to: 14352
/* 4617 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 4620 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 4636
/* 4625 */    MCD::OPC_CheckField, 40, 4, 8, 248, 37, 0, // Skip to: 14352
/* 4632 */    MCD::OPC_Decode, 152, 7, 71, // Opcode: MOV32fp
/* 4636 */    MCD::OPC_FilterValue, 1, 239, 37, 0, // Skip to: 14352
/* 4641 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 4644 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 4653
/* 4649 */    MCD::OPC_Decode, 246, 6, 81, // Opcode: MOV32bp
/* 4653 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 4662
/* 4658 */    MCD::OPC_Decode, 212, 7, 82, // Opcode: MOV32qp
/* 4662 */    MCD::OPC_FilterValue, 3, 213, 37, 0, // Skip to: 14352
/* 4667 */    MCD::OPC_CheckField, 40, 4, 8, 206, 37, 0, // Skip to: 14352
/* 4674 */    MCD::OPC_Decode, 176, 7, 83, // Opcode: MOV32kp
/* 4678 */    MCD::OPC_FilterValue, 3, 197, 37, 0, // Skip to: 14352
/* 4683 */    MCD::OPC_ExtractField, 7, 2,  // Inst{8-7} ...
/* 4686 */    MCD::OPC_FilterValue, 0, 177, 0, 0, // Skip to: 4868
/* 4691 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 4694 */    MCD::OPC_FilterValue, 0, 33, 0, 0, // Skip to: 4732
/* 4699 */    MCD::OPC_ExtractField, 24, 4,  // Inst{27-24} ...
/* 4702 */    MCD::OPC_FilterValue, 8, 173, 37, 0, // Skip to: 14352
/* 4707 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 4710 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 4719
/* 4715 */    MCD::OPC_Decode, 252, 6, 114, // Opcode: MOV32df
/* 4719 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 4728
/* 4724 */    MCD::OPC_Decode, 223, 6, 56, // Opcode: MOV32af
/* 4728 */    MCD::OPC_Decode, 220, 7, 115, // Opcode: MOV32rf
/* 4732 */    MCD::OPC_FilterValue, 1, 143, 37, 0, // Skip to: 14352
/* 4737 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 4740 */    MCD::OPC_FilterValue, 1, 25, 0, 0, // Skip to: 4770
/* 4745 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 4748 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 4757
/* 4753 */    MCD::OPC_Decode, 249, 6, 116, // Opcode: MOV32db
/* 4757 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 4766
/* 4762 */    MCD::OPC_Decode, 219, 6, 57, // Opcode: MOV32ab
/* 4766 */    MCD::OPC_Decode, 216, 7, 117, // Opcode: MOV32rb
/* 4770 */    MCD::OPC_FilterValue, 2, 25, 0, 0, // Skip to: 4800
/* 4775 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 4778 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 4787
/* 4783 */    MCD::OPC_Decode, 130, 7, 118, // Opcode: MOV32dq
/* 4787 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 4796
/* 4792 */    MCD::OPC_Decode, 234, 6, 58, // Opcode: MOV32aq
/* 4796 */    MCD::OPC_Decode, 231, 7, 119, // Opcode: MOV32rq
/* 4800 */    MCD::OPC_FilterValue, 3, 33, 0, 0, // Skip to: 4838
/* 4805 */    MCD::OPC_ExtractField, 24, 4,  // Inst{27-24} ...
/* 4808 */    MCD::OPC_FilterValue, 8, 67, 37, 0, // Skip to: 14352
/* 4813 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 4816 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 4825
/* 4821 */    MCD::OPC_Decode, 255, 6, 120, // Opcode: MOV32dk
/* 4825 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 4834
/* 4830 */    MCD::OPC_Decode, 228, 6, 59, // Opcode: MOV32ak
/* 4834 */    MCD::OPC_Decode, 225, 7, 121, // Opcode: MOV32rk
/* 4838 */    MCD::OPC_FilterValue, 4, 37, 37, 0, // Skip to: 14352
/* 4843 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 4846 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 4855
/* 4851 */    MCD::OPC_Decode, 253, 6, 116, // Opcode: MOV32di
/* 4855 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 4864
/* 4860 */    MCD::OPC_Decode, 225, 6, 57, // Opcode: MOV32ai
/* 4864 */    MCD::OPC_Decode, 222, 7, 117, // Opcode: MOV32ri
/* 4868 */    MCD::OPC_FilterValue, 1, 169, 0, 0, // Skip to: 5042
/* 4873 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 4876 */    MCD::OPC_FilterValue, 0, 35, 0, 0, // Skip to: 4916
/* 4881 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 4884 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 4900
/* 4889 */    MCD::OPC_CheckField, 24, 4, 8, 240, 36, 0, // Skip to: 14352
/* 4896 */    MCD::OPC_Decode, 159, 7, 56, // Opcode: MOV32jf
/* 4900 */    MCD::OPC_FilterValue, 1, 231, 36, 0, // Skip to: 14352
/* 4905 */    MCD::OPC_CheckField, 24, 4, 8, 224, 36, 0, // Skip to: 14352
/* 4912 */    MCD::OPC_Decode, 183, 7, 56, // Opcode: MOV32of
/* 4916 */    MCD::OPC_FilterValue, 1, 215, 36, 0, // Skip to: 14352
/* 4921 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 4924 */    MCD::OPC_FilterValue, 1, 21, 0, 0, // Skip to: 4950
/* 4929 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 4932 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 4941
/* 4937 */    MCD::OPC_Decode, 156, 7, 57, // Opcode: MOV32jb
/* 4941 */    MCD::OPC_FilterValue, 1, 190, 36, 0, // Skip to: 14352
/* 4946 */    MCD::OPC_Decode, 180, 7, 57, // Opcode: MOV32ob
/* 4950 */    MCD::OPC_FilterValue, 2, 21, 0, 0, // Skip to: 4976
/* 4955 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 4958 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 4967
/* 4963 */    MCD::OPC_Decode, 165, 7, 58, // Opcode: MOV32jq
/* 4967 */    MCD::OPC_FilterValue, 1, 164, 36, 0, // Skip to: 14352
/* 4972 */    MCD::OPC_Decode, 189, 7, 58, // Opcode: MOV32oq
/* 4976 */    MCD::OPC_FilterValue, 3, 35, 0, 0, // Skip to: 5016
/* 4981 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 4984 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 5000
/* 4989 */    MCD::OPC_CheckField, 24, 4, 8, 140, 36, 0, // Skip to: 14352
/* 4996 */    MCD::OPC_Decode, 162, 7, 59, // Opcode: MOV32jk
/* 5000 */    MCD::OPC_FilterValue, 1, 131, 36, 0, // Skip to: 14352
/* 5005 */    MCD::OPC_CheckField, 24, 4, 8, 124, 36, 0, // Skip to: 14352
/* 5012 */    MCD::OPC_Decode, 186, 7, 59, // Opcode: MOV32ok
/* 5016 */    MCD::OPC_FilterValue, 4, 115, 36, 0, // Skip to: 14352
/* 5021 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 5024 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 5033
/* 5029 */    MCD::OPC_Decode, 160, 7, 57, // Opcode: MOV32ji
/* 5033 */    MCD::OPC_FilterValue, 1, 98, 36, 0, // Skip to: 14352
/* 5038 */    MCD::OPC_Decode, 184, 7, 57, // Opcode: MOV32oi
/* 5042 */    MCD::OPC_FilterValue, 2, 169, 0, 0, // Skip to: 5216
/* 5047 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 5050 */    MCD::OPC_FilterValue, 0, 35, 0, 0, // Skip to: 5090
/* 5055 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 5058 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 5074
/* 5063 */    MCD::OPC_CheckField, 24, 4, 8, 66, 36, 0, // Skip to: 14352
/* 5070 */    MCD::OPC_Decode, 135, 7, 56, // Opcode: MOV32ef
/* 5074 */    MCD::OPC_FilterValue, 1, 57, 36, 0, // Skip to: 14352
/* 5079 */    MCD::OPC_CheckField, 24, 4, 8, 50, 36, 0, // Skip to: 14352
/* 5086 */    MCD::OPC_Decode, 195, 7, 64, // Opcode: MOV32pf
/* 5090 */    MCD::OPC_FilterValue, 1, 41, 36, 0, // Skip to: 14352
/* 5095 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 5098 */    MCD::OPC_FilterValue, 1, 21, 0, 0, // Skip to: 5124
/* 5103 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 5106 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 5115
/* 5111 */    MCD::OPC_Decode, 132, 7, 57, // Opcode: MOV32eb
/* 5115 */    MCD::OPC_FilterValue, 1, 16, 36, 0, // Skip to: 14352
/* 5120 */    MCD::OPC_Decode, 192, 7, 65, // Opcode: MOV32pb
/* 5124 */    MCD::OPC_FilterValue, 2, 21, 0, 0, // Skip to: 5150
/* 5129 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 5132 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 5141
/* 5137 */    MCD::OPC_Decode, 141, 7, 58, // Opcode: MOV32eq
/* 5141 */    MCD::OPC_FilterValue, 1, 246, 35, 0, // Skip to: 14352
/* 5146 */    MCD::OPC_Decode, 201, 7, 66, // Opcode: MOV32pq
/* 5150 */    MCD::OPC_FilterValue, 3, 35, 0, 0, // Skip to: 5190
/* 5155 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 5158 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 5174
/* 5163 */    MCD::OPC_CheckField, 24, 4, 8, 222, 35, 0, // Skip to: 14352
/* 5170 */    MCD::OPC_Decode, 138, 7, 59, // Opcode: MOV32ek
/* 5174 */    MCD::OPC_FilterValue, 1, 213, 35, 0, // Skip to: 14352
/* 5179 */    MCD::OPC_CheckField, 24, 4, 8, 206, 35, 0, // Skip to: 14352
/* 5186 */    MCD::OPC_Decode, 198, 7, 67, // Opcode: MOV32pk
/* 5190 */    MCD::OPC_FilterValue, 4, 197, 35, 0, // Skip to: 14352
/* 5195 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 5198 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 5207
/* 5203 */    MCD::OPC_Decode, 136, 7, 57, // Opcode: MOV32ei
/* 5207 */    MCD::OPC_FilterValue, 1, 180, 35, 0, // Skip to: 14352
/* 5212 */    MCD::OPC_Decode, 196, 7, 65, // Opcode: MOV32pi
/* 5216 */    MCD::OPC_FilterValue, 3, 171, 35, 0, // Skip to: 14352
/* 5221 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 5224 */    MCD::OPC_FilterValue, 0, 89, 0, 0, // Skip to: 5318
/* 5229 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 5232 */    MCD::OPC_FilterValue, 0, 18, 0, 0, // Skip to: 5255
/* 5237 */    MCD::OPC_CheckField, 40, 4, 8, 148, 35, 0, // Skip to: 14352
/* 5244 */    MCD::OPC_CheckField, 24, 4, 8, 141, 35, 0, // Skip to: 14352
/* 5251 */    MCD::OPC_Decode, 147, 7, 72, // Opcode: MOV32ff
/* 5255 */    MCD::OPC_FilterValue, 1, 132, 35, 0, // Skip to: 14352
/* 5260 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 5263 */    MCD::OPC_FilterValue, 1, 11, 0, 0, // Skip to: 5279
/* 5268 */    MCD::OPC_CheckField, 24, 4, 8, 117, 35, 0, // Skip to: 14352
/* 5275 */    MCD::OPC_Decode, 241, 6, 84, // Opcode: MOV32bf
/* 5279 */    MCD::OPC_FilterValue, 2, 11, 0, 0, // Skip to: 5295
/* 5284 */    MCD::OPC_CheckField, 24, 4, 8, 101, 35, 0, // Skip to: 14352
/* 5291 */    MCD::OPC_Decode, 207, 7, 85, // Opcode: MOV32qf
/* 5295 */    MCD::OPC_FilterValue, 3, 92, 35, 0, // Skip to: 14352
/* 5300 */    MCD::OPC_CheckField, 40, 4, 8, 85, 35, 0, // Skip to: 14352
/* 5307 */    MCD::OPC_CheckField, 24, 4, 8, 78, 35, 0, // Skip to: 14352
/* 5314 */    MCD::OPC_Decode, 171, 7, 86, // Opcode: MOV32kf
/* 5318 */    MCD::OPC_FilterValue, 1, 69, 35, 0, // Skip to: 14352
/* 5323 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 5326 */    MCD::OPC_FilterValue, 1, 61, 0, 0, // Skip to: 5392
/* 5331 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 5334 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 5350
/* 5339 */    MCD::OPC_CheckField, 56, 4, 8, 46, 35, 0, // Skip to: 14352
/* 5346 */    MCD::OPC_Decode, 144, 7, 73, // Opcode: MOV32fb
/* 5350 */    MCD::OPC_FilterValue, 1, 37, 35, 0, // Skip to: 14352
/* 5355 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 5358 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 5367
/* 5363 */    MCD::OPC_Decode, 238, 6, 87, // Opcode: MOV32bb
/* 5367 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 5376
/* 5372 */    MCD::OPC_Decode, 204, 7, 88, // Opcode: MOV32qb
/* 5376 */    MCD::OPC_FilterValue, 3, 11, 35, 0, // Skip to: 14352
/* 5381 */    MCD::OPC_CheckField, 56, 4, 8, 4, 35, 0, // Skip to: 14352
/* 5388 */    MCD::OPC_Decode, 168, 7, 89, // Opcode: MOV32kb
/* 5392 */    MCD::OPC_FilterValue, 2, 61, 0, 0, // Skip to: 5458
/* 5397 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 5400 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 5416
/* 5405 */    MCD::OPC_CheckField, 40, 4, 8, 236, 34, 0, // Skip to: 14352
/* 5412 */    MCD::OPC_Decode, 153, 7, 74, // Opcode: MOV32fq
/* 5416 */    MCD::OPC_FilterValue, 1, 227, 34, 0, // Skip to: 14352
/* 5421 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 5424 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 5433
/* 5429 */    MCD::OPC_Decode, 247, 6, 90, // Opcode: MOV32bq
/* 5433 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 5442
/* 5438 */    MCD::OPC_Decode, 213, 7, 91, // Opcode: MOV32qq
/* 5442 */    MCD::OPC_FilterValue, 3, 201, 34, 0, // Skip to: 14352
/* 5447 */    MCD::OPC_CheckField, 40, 4, 8, 194, 34, 0, // Skip to: 14352
/* 5454 */    MCD::OPC_Decode, 177, 7, 92, // Opcode: MOV32kq
/* 5458 */    MCD::OPC_FilterValue, 3, 89, 0, 0, // Skip to: 5552
/* 5463 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 5466 */    MCD::OPC_FilterValue, 0, 18, 0, 0, // Skip to: 5489
/* 5471 */    MCD::OPC_CheckField, 40, 4, 8, 170, 34, 0, // Skip to: 14352
/* 5478 */    MCD::OPC_CheckField, 24, 4, 8, 163, 34, 0, // Skip to: 14352
/* 5485 */    MCD::OPC_Decode, 150, 7, 75, // Opcode: MOV32fk
/* 5489 */    MCD::OPC_FilterValue, 1, 154, 34, 0, // Skip to: 14352
/* 5494 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 5497 */    MCD::OPC_FilterValue, 1, 11, 0, 0, // Skip to: 5513
/* 5502 */    MCD::OPC_CheckField, 24, 4, 8, 139, 34, 0, // Skip to: 14352
/* 5509 */    MCD::OPC_Decode, 244, 6, 93, // Opcode: MOV32bk
/* 5513 */    MCD::OPC_FilterValue, 2, 11, 0, 0, // Skip to: 5529
/* 5518 */    MCD::OPC_CheckField, 24, 4, 8, 123, 34, 0, // Skip to: 14352
/* 5525 */    MCD::OPC_Decode, 210, 7, 94, // Opcode: MOV32qk
/* 5529 */    MCD::OPC_FilterValue, 3, 114, 34, 0, // Skip to: 14352
/* 5534 */    MCD::OPC_CheckField, 40, 4, 8, 107, 34, 0, // Skip to: 14352
/* 5541 */    MCD::OPC_CheckField, 24, 4, 8, 100, 34, 0, // Skip to: 14352
/* 5548 */    MCD::OPC_Decode, 174, 7, 95, // Opcode: MOV32kk
/* 5552 */    MCD::OPC_FilterValue, 4, 91, 34, 0, // Skip to: 14352
/* 5557 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 5560 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 5576
/* 5565 */    MCD::OPC_CheckField, 56, 4, 8, 76, 34, 0, // Skip to: 14352
/* 5572 */    MCD::OPC_Decode, 148, 7, 73, // Opcode: MOV32fi
/* 5576 */    MCD::OPC_FilterValue, 1, 67, 34, 0, // Skip to: 14352
/* 5581 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 5584 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 5593
/* 5589 */    MCD::OPC_Decode, 242, 6, 87, // Opcode: MOV32bi
/* 5593 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 5602
/* 5598 */    MCD::OPC_Decode, 208, 7, 88, // Opcode: MOV32qi
/* 5602 */    MCD::OPC_FilterValue, 3, 41, 34, 0, // Skip to: 14352
/* 5607 */    MCD::OPC_CheckField, 56, 4, 8, 34, 34, 0, // Skip to: 14352
/* 5614 */    MCD::OPC_Decode, 172, 7, 89, // Opcode: MOV32ki
/* 5618 */    MCD::OPC_FilterValue, 3, 225, 7, 0, // Skip to: 7640
/* 5623 */    MCD::OPC_ExtractField, 4, 2,  // Inst{5-4} ...
/* 5626 */    MCD::OPC_FilterValue, 0, 114, 1, 0, // Skip to: 6001
/* 5631 */    MCD::OPC_ExtractField, 7, 2,  // Inst{8-7} ...
/* 5634 */    MCD::OPC_FilterValue, 0, 54, 0, 0, // Skip to: 5693
/* 5639 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 5642 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 5658
/* 5647 */    MCD::OPC_CheckField, 6, 1, 0, 24, 0, 0, // Skip to: 5678
/* 5654 */    MCD::OPC_Decode, 227, 5, 122, // Opcode: MOV16dd
/* 5658 */    MCD::OPC_FilterValue, 1, 15, 0, 0, // Skip to: 5678
/* 5663 */    MCD::OPC_CheckField, 6, 1, 1, 4, 0, 0, // Skip to: 5674
/* 5670 */    MCD::OPC_Decode, 184, 5, 123, // Opcode: MOV16aa
/* 5674 */    MCD::OPC_Decode, 199, 6, 124, // Opcode: MOV16ra
/* 5678 */    MCD::OPC_CheckField, 6, 1, 1, 4, 0, 0, // Skip to: 5689
/* 5685 */    MCD::OPC_Decode, 202, 5, 125, // Opcode: MOV16ar
/* 5689 */    MCD::OPC_Decode, 217, 6, 126, // Opcode: MOV16rr
/* 5693 */    MCD::OPC_FilterValue, 1, 67, 0, 0, // Skip to: 5765
/* 5698 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 5701 */    MCD::OPC_FilterValue, 0, 27, 0, 0, // Skip to: 5733
/* 5706 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 5709 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 5718
/* 5714 */    MCD::OPC_Decode, 137, 6, 127, // Opcode: MOV16jd
/* 5718 */    MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 5728
/* 5723 */    MCD::OPC_Decode, 134, 6, 128, 1, // Opcode: MOV16ja
/* 5728 */    MCD::OPC_Decode, 146, 6, 129, 1, // Opcode: MOV16jr
/* 5733 */    MCD::OPC_FilterValue, 1, 166, 33, 0, // Skip to: 14352
/* 5738 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 5741 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 5750
/* 5746 */    MCD::OPC_Decode, 163, 6, 127, // Opcode: MOV16od
/* 5750 */    MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 5760
/* 5755 */    MCD::OPC_Decode, 160, 6, 128, 1, // Opcode: MOV16oa
/* 5760 */    MCD::OPC_Decode, 172, 6, 129, 1, // Opcode: MOV16or
/* 5765 */    MCD::OPC_FilterValue, 2, 68, 0, 0, // Skip to: 5838
/* 5770 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 5773 */    MCD::OPC_FilterValue, 0, 27, 0, 0, // Skip to: 5805
/* 5778 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 5781 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 5790
/* 5786 */    MCD::OPC_Decode, 239, 5, 127, // Opcode: MOV16ed
/* 5790 */    MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 5800
/* 5795 */    MCD::OPC_Decode, 236, 5, 128, 1, // Opcode: MOV16ea
/* 5800 */    MCD::OPC_Decode, 248, 5, 129, 1, // Opcode: MOV16er
/* 5805 */    MCD::OPC_FilterValue, 1, 94, 33, 0, // Skip to: 14352
/* 5810 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 5813 */    MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 5823
/* 5818 */    MCD::OPC_Decode, 176, 6, 130, 1, // Opcode: MOV16pd
/* 5823 */    MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 5833
/* 5828 */    MCD::OPC_Decode, 173, 6, 131, 1, // Opcode: MOV16pa
/* 5833 */    MCD::OPC_Decode, 185, 6, 132, 1, // Opcode: MOV16pr
/* 5838 */    MCD::OPC_FilterValue, 3, 61, 33, 0, // Skip to: 14352
/* 5843 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 5846 */    MCD::OPC_FilterValue, 0, 36, 0, 0, // Skip to: 5887
/* 5851 */    MCD::OPC_ExtractField, 24, 4,  // Inst{27-24} ...
/* 5854 */    MCD::OPC_FilterValue, 8, 45, 33, 0, // Skip to: 14352
/* 5859 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 5862 */    MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 5872
/* 5867 */    MCD::OPC_Decode, 252, 5, 133, 1, // Opcode: MOV16fd
/* 5872 */    MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 5882
/* 5877 */    MCD::OPC_Decode, 249, 5, 134, 1, // Opcode: MOV16fa
/* 5882 */    MCD::OPC_Decode, 133, 6, 135, 1, // Opcode: MOV16fr
/* 5887 */    MCD::OPC_FilterValue, 1, 12, 33, 0, // Skip to: 14352
/* 5892 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 5895 */    MCD::OPC_FilterValue, 1, 28, 0, 0, // Skip to: 5928
/* 5900 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 5903 */    MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 5913
/* 5908 */    MCD::OPC_Decode, 206, 5, 136, 1, // Opcode: MOV16bd
/* 5913 */    MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 5923
/* 5918 */    MCD::OPC_Decode, 203, 5, 137, 1, // Opcode: MOV16ba
/* 5923 */    MCD::OPC_Decode, 215, 5, 138, 1, // Opcode: MOV16br
/* 5928 */    MCD::OPC_FilterValue, 2, 27, 0, 0, // Skip to: 5960
/* 5933 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 5936 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 5945
/* 5941 */    MCD::OPC_Decode, 189, 6, 15, // Opcode: MOV16qd
/* 5945 */    MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 5955
/* 5950 */    MCD::OPC_Decode, 186, 6, 139, 1, // Opcode: MOV16qa
/* 5955 */    MCD::OPC_Decode, 198, 6, 140, 1, // Opcode: MOV16qr
/* 5960 */    MCD::OPC_FilterValue, 3, 195, 32, 0, // Skip to: 14352
/* 5965 */    MCD::OPC_ExtractField, 24, 4,  // Inst{27-24} ...
/* 5968 */    MCD::OPC_FilterValue, 8, 187, 32, 0, // Skip to: 14352
/* 5973 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 5976 */    MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 5986
/* 5981 */    MCD::OPC_Decode, 150, 6, 141, 1, // Opcode: MOV16kd
/* 5986 */    MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 5996
/* 5991 */    MCD::OPC_Decode, 147, 6, 142, 1, // Opcode: MOV16ka
/* 5996 */    MCD::OPC_Decode, 159, 6, 143, 1, // Opcode: MOV16kr
/* 6001 */    MCD::OPC_FilterValue, 1, 81, 1, 0, // Skip to: 6343
/* 6006 */    MCD::OPC_ExtractField, 7, 2,  // Inst{8-7} ...
/* 6009 */    MCD::OPC_FilterValue, 0, 69, 0, 0, // Skip to: 6083
/* 6014 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 6017 */    MCD::OPC_FilterValue, 0, 28, 0, 0, // Skip to: 6050
/* 6022 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 6025 */    MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 6035
/* 6030 */    MCD::OPC_Decode, 231, 5, 144, 1, // Opcode: MOV16dj
/* 6035 */    MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 6045
/* 6040 */    MCD::OPC_Decode, 192, 5, 145, 1, // Opcode: MOV16aj
/* 6045 */    MCD::OPC_Decode, 207, 6, 146, 1, // Opcode: MOV16rj
/* 6050 */    MCD::OPC_FilterValue, 1, 105, 32, 0, // Skip to: 14352
/* 6055 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 6058 */    MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 6068
/* 6063 */    MCD::OPC_Decode, 233, 5, 144, 1, // Opcode: MOV16do
/* 6068 */    MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 6078
/* 6073 */    MCD::OPC_Decode, 196, 5, 145, 1, // Opcode: MOV16ao
/* 6078 */    MCD::OPC_Decode, 211, 6, 146, 1, // Opcode: MOV16ro
/* 6083 */    MCD::OPC_FilterValue, 1, 55, 0, 0, // Skip to: 6143
/* 6088 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 6091 */    MCD::OPC_FilterValue, 0, 21, 0, 0, // Skip to: 6117
/* 6096 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 6099 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 6108
/* 6104 */    MCD::OPC_Decode, 141, 6, 54, // Opcode: MOV16jj
/* 6108 */    MCD::OPC_FilterValue, 1, 47, 32, 0, // Skip to: 14352
/* 6113 */    MCD::OPC_Decode, 167, 6, 54, // Opcode: MOV16oj
/* 6117 */    MCD::OPC_FilterValue, 1, 38, 32, 0, // Skip to: 14352
/* 6122 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 6125 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 6134
/* 6130 */    MCD::OPC_Decode, 143, 6, 54, // Opcode: MOV16jo
/* 6134 */    MCD::OPC_FilterValue, 1, 21, 32, 0, // Skip to: 14352
/* 6139 */    MCD::OPC_Decode, 169, 6, 54, // Opcode: MOV16oo
/* 6143 */    MCD::OPC_FilterValue, 2, 55, 0, 0, // Skip to: 6203
/* 6148 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 6151 */    MCD::OPC_FilterValue, 0, 21, 0, 0, // Skip to: 6177
/* 6156 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 6159 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 6168
/* 6164 */    MCD::OPC_Decode, 243, 5, 54, // Opcode: MOV16ej
/* 6168 */    MCD::OPC_FilterValue, 1, 243, 31, 0, // Skip to: 14352
/* 6173 */    MCD::OPC_Decode, 180, 6, 62, // Opcode: MOV16pj
/* 6177 */    MCD::OPC_FilterValue, 1, 234, 31, 0, // Skip to: 14352
/* 6182 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 6185 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 6194
/* 6190 */    MCD::OPC_Decode, 245, 5, 54, // Opcode: MOV16eo
/* 6194 */    MCD::OPC_FilterValue, 1, 217, 31, 0, // Skip to: 14352
/* 6199 */    MCD::OPC_Decode, 182, 6, 62, // Opcode: MOV16po
/* 6203 */    MCD::OPC_FilterValue, 3, 208, 31, 0, // Skip to: 14352
/* 6208 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 6211 */    MCD::OPC_FilterValue, 0, 61, 0, 0, // Skip to: 6277
/* 6216 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 6219 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 6235
/* 6224 */    MCD::OPC_CheckField, 24, 4, 8, 185, 31, 0, // Skip to: 14352
/* 6231 */    MCD::OPC_Decode, 128, 6, 70, // Opcode: MOV16fj
/* 6235 */    MCD::OPC_FilterValue, 1, 176, 31, 0, // Skip to: 14352
/* 6240 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 6243 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 6252
/* 6248 */    MCD::OPC_Decode, 210, 5, 28, // Opcode: MOV16bj
/* 6252 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 6261
/* 6257 */    MCD::OPC_Decode, 193, 6, 17, // Opcode: MOV16qj
/* 6261 */    MCD::OPC_FilterValue, 3, 150, 31, 0, // Skip to: 14352
/* 6266 */    MCD::OPC_CheckField, 24, 4, 8, 143, 31, 0, // Skip to: 14352
/* 6273 */    MCD::OPC_Decode, 154, 6, 80, // Opcode: MOV16kj
/* 6277 */    MCD::OPC_FilterValue, 1, 134, 31, 0, // Skip to: 14352
/* 6282 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 6285 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 6301
/* 6290 */    MCD::OPC_CheckField, 24, 4, 8, 119, 31, 0, // Skip to: 14352
/* 6297 */    MCD::OPC_Decode, 130, 6, 70, // Opcode: MOV16fo
/* 6301 */    MCD::OPC_FilterValue, 1, 110, 31, 0, // Skip to: 14352
/* 6306 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 6309 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 6318
/* 6314 */    MCD::OPC_Decode, 212, 5, 28, // Opcode: MOV16bo
/* 6318 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 6327
/* 6323 */    MCD::OPC_Decode, 195, 6, 17, // Opcode: MOV16qo
/* 6327 */    MCD::OPC_FilterValue, 3, 84, 31, 0, // Skip to: 14352
/* 6332 */    MCD::OPC_CheckField, 24, 4, 8, 77, 31, 0, // Skip to: 14352
/* 6339 */    MCD::OPC_Decode, 156, 6, 80, // Opcode: MOV16ko
/* 6343 */    MCD::OPC_FilterValue, 2, 81, 1, 0, // Skip to: 6685
/* 6348 */    MCD::OPC_ExtractField, 7, 2,  // Inst{8-7} ...
/* 6351 */    MCD::OPC_FilterValue, 0, 69, 0, 0, // Skip to: 6425
/* 6356 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 6359 */    MCD::OPC_FilterValue, 0, 28, 0, 0, // Skip to: 6392
/* 6364 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 6367 */    MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 6377
/* 6372 */    MCD::OPC_Decode, 228, 5, 144, 1, // Opcode: MOV16de
/* 6377 */    MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 6387
/* 6382 */    MCD::OPC_Decode, 187, 5, 145, 1, // Opcode: MOV16ae
/* 6387 */    MCD::OPC_Decode, 202, 6, 146, 1, // Opcode: MOV16re
/* 6392 */    MCD::OPC_FilterValue, 1, 19, 31, 0, // Skip to: 14352
/* 6397 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 6400 */    MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 6410
/* 6405 */    MCD::OPC_Decode, 234, 5, 147, 1, // Opcode: MOV16dp
/* 6410 */    MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 6420
/* 6415 */    MCD::OPC_Decode, 198, 5, 148, 1, // Opcode: MOV16ap
/* 6420 */    MCD::OPC_Decode, 213, 6, 149, 1, // Opcode: MOV16rp
/* 6425 */    MCD::OPC_FilterValue, 1, 55, 0, 0, // Skip to: 6485
/* 6430 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 6433 */    MCD::OPC_FilterValue, 0, 21, 0, 0, // Skip to: 6459
/* 6438 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 6441 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 6450
/* 6446 */    MCD::OPC_Decode, 138, 6, 54, // Opcode: MOV16je
/* 6450 */    MCD::OPC_FilterValue, 1, 217, 30, 0, // Skip to: 14352
/* 6455 */    MCD::OPC_Decode, 164, 6, 54, // Opcode: MOV16oe
/* 6459 */    MCD::OPC_FilterValue, 1, 208, 30, 0, // Skip to: 14352
/* 6464 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 6467 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 6476
/* 6472 */    MCD::OPC_Decode, 144, 6, 55, // Opcode: MOV16jp
/* 6476 */    MCD::OPC_FilterValue, 1, 191, 30, 0, // Skip to: 14352
/* 6481 */    MCD::OPC_Decode, 170, 6, 55, // Opcode: MOV16op
/* 6485 */    MCD::OPC_FilterValue, 2, 55, 0, 0, // Skip to: 6545
/* 6490 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 6493 */    MCD::OPC_FilterValue, 0, 21, 0, 0, // Skip to: 6519
/* 6498 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 6501 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 6510
/* 6506 */    MCD::OPC_Decode, 240, 5, 54, // Opcode: MOV16ee
/* 6510 */    MCD::OPC_FilterValue, 1, 157, 30, 0, // Skip to: 14352
/* 6515 */    MCD::OPC_Decode, 177, 6, 62, // Opcode: MOV16pe
/* 6519 */    MCD::OPC_FilterValue, 1, 148, 30, 0, // Skip to: 14352
/* 6524 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 6527 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 6536
/* 6532 */    MCD::OPC_Decode, 246, 5, 55, // Opcode: MOV16ep
/* 6536 */    MCD::OPC_FilterValue, 1, 131, 30, 0, // Skip to: 14352
/* 6541 */    MCD::OPC_Decode, 183, 6, 63, // Opcode: MOV16pp
/* 6545 */    MCD::OPC_FilterValue, 3, 122, 30, 0, // Skip to: 14352
/* 6550 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 6553 */    MCD::OPC_FilterValue, 0, 61, 0, 0, // Skip to: 6619
/* 6558 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 6561 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 6577
/* 6566 */    MCD::OPC_CheckField, 24, 4, 8, 99, 30, 0, // Skip to: 14352
/* 6573 */    MCD::OPC_Decode, 253, 5, 70, // Opcode: MOV16fe
/* 6577 */    MCD::OPC_FilterValue, 1, 90, 30, 0, // Skip to: 14352
/* 6582 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 6585 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 6594
/* 6590 */    MCD::OPC_Decode, 207, 5, 28, // Opcode: MOV16be
/* 6594 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 6603
/* 6599 */    MCD::OPC_Decode, 190, 6, 17, // Opcode: MOV16qe
/* 6603 */    MCD::OPC_FilterValue, 3, 64, 30, 0, // Skip to: 14352
/* 6608 */    MCD::OPC_CheckField, 24, 4, 8, 57, 30, 0, // Skip to: 14352
/* 6615 */    MCD::OPC_Decode, 151, 6, 80, // Opcode: MOV16ke
/* 6619 */    MCD::OPC_FilterValue, 1, 48, 30, 0, // Skip to: 14352
/* 6624 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 6627 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 6643
/* 6632 */    MCD::OPC_CheckField, 40, 4, 8, 33, 30, 0, // Skip to: 14352
/* 6639 */    MCD::OPC_Decode, 131, 6, 71, // Opcode: MOV16fp
/* 6643 */    MCD::OPC_FilterValue, 1, 24, 30, 0, // Skip to: 14352
/* 6648 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 6651 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 6660
/* 6656 */    MCD::OPC_Decode, 213, 5, 81, // Opcode: MOV16bp
/* 6660 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 6669
/* 6665 */    MCD::OPC_Decode, 196, 6, 82, // Opcode: MOV16qp
/* 6669 */    MCD::OPC_FilterValue, 3, 254, 29, 0, // Skip to: 14352
/* 6674 */    MCD::OPC_CheckField, 40, 4, 8, 247, 29, 0, // Skip to: 14352
/* 6681 */    MCD::OPC_Decode, 157, 6, 83, // Opcode: MOV16kp
/* 6685 */    MCD::OPC_FilterValue, 3, 238, 29, 0, // Skip to: 14352
/* 6690 */    MCD::OPC_ExtractField, 7, 2,  // Inst{8-7} ...
/* 6693 */    MCD::OPC_FilterValue, 0, 192, 0, 0, // Skip to: 6890
/* 6698 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 6701 */    MCD::OPC_FilterValue, 0, 36, 0, 0, // Skip to: 6742
/* 6706 */    MCD::OPC_ExtractField, 24, 4,  // Inst{27-24} ...
/* 6709 */    MCD::OPC_FilterValue, 8, 214, 29, 0, // Skip to: 14352
/* 6714 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 6717 */    MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 6727
/* 6722 */    MCD::OPC_Decode, 229, 5, 150, 1, // Opcode: MOV16df
/* 6727 */    MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 6737
/* 6732 */    MCD::OPC_Decode, 189, 5, 151, 1, // Opcode: MOV16af
/* 6737 */    MCD::OPC_Decode, 204, 6, 152, 1, // Opcode: MOV16rf
/* 6742 */    MCD::OPC_FilterValue, 1, 181, 29, 0, // Skip to: 14352
/* 6747 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 6750 */    MCD::OPC_FilterValue, 1, 28, 0, 0, // Skip to: 6783
/* 6755 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 6758 */    MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 6768
/* 6763 */    MCD::OPC_Decode, 225, 5, 153, 1, // Opcode: MOV16db
/* 6768 */    MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 6778
/* 6773 */    MCD::OPC_Decode, 185, 5, 154, 1, // Opcode: MOV16ab
/* 6778 */    MCD::OPC_Decode, 200, 6, 155, 1, // Opcode: MOV16rb
/* 6783 */    MCD::OPC_FilterValue, 2, 28, 0, 0, // Skip to: 6816
/* 6788 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 6791 */    MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 6801
/* 6796 */    MCD::OPC_Decode, 235, 5, 156, 1, // Opcode: MOV16dq
/* 6801 */    MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 6811
/* 6806 */    MCD::OPC_Decode, 200, 5, 157, 1, // Opcode: MOV16aq
/* 6811 */    MCD::OPC_Decode, 215, 6, 158, 1, // Opcode: MOV16rq
/* 6816 */    MCD::OPC_FilterValue, 3, 36, 0, 0, // Skip to: 6857
/* 6821 */    MCD::OPC_ExtractField, 24, 4,  // Inst{27-24} ...
/* 6824 */    MCD::OPC_FilterValue, 8, 99, 29, 0, // Skip to: 14352
/* 6829 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 6832 */    MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 6842
/* 6837 */    MCD::OPC_Decode, 232, 5, 159, 1, // Opcode: MOV16dk
/* 6842 */    MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 6852
/* 6847 */    MCD::OPC_Decode, 194, 5, 160, 1, // Opcode: MOV16ak
/* 6852 */    MCD::OPC_Decode, 209, 6, 161, 1, // Opcode: MOV16rk
/* 6857 */    MCD::OPC_FilterValue, 4, 66, 29, 0, // Skip to: 14352
/* 6862 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 6865 */    MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 6875
/* 6870 */    MCD::OPC_Decode, 230, 5, 156, 1, // Opcode: MOV16di
/* 6875 */    MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 6885
/* 6880 */    MCD::OPC_Decode, 191, 5, 157, 1, // Opcode: MOV16ai
/* 6885 */    MCD::OPC_Decode, 206, 6, 158, 1, // Opcode: MOV16ri
/* 6890 */    MCD::OPC_FilterValue, 1, 169, 0, 0, // Skip to: 7064
/* 6895 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 6898 */    MCD::OPC_FilterValue, 0, 35, 0, 0, // Skip to: 6938
/* 6903 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 6906 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 6922
/* 6911 */    MCD::OPC_CheckField, 24, 4, 8, 10, 29, 0, // Skip to: 14352
/* 6918 */    MCD::OPC_Decode, 139, 6, 56, // Opcode: MOV16jf
/* 6922 */    MCD::OPC_FilterValue, 1, 1, 29, 0, // Skip to: 14352
/* 6927 */    MCD::OPC_CheckField, 24, 4, 8, 250, 28, 0, // Skip to: 14352
/* 6934 */    MCD::OPC_Decode, 165, 6, 56, // Opcode: MOV16of
/* 6938 */    MCD::OPC_FilterValue, 1, 241, 28, 0, // Skip to: 14352
/* 6943 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 6946 */    MCD::OPC_FilterValue, 1, 21, 0, 0, // Skip to: 6972
/* 6951 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 6954 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 6963
/* 6959 */    MCD::OPC_Decode, 135, 6, 57, // Opcode: MOV16jb
/* 6963 */    MCD::OPC_FilterValue, 1, 216, 28, 0, // Skip to: 14352
/* 6968 */    MCD::OPC_Decode, 161, 6, 57, // Opcode: MOV16ob
/* 6972 */    MCD::OPC_FilterValue, 2, 21, 0, 0, // Skip to: 6998
/* 6977 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 6980 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 6989
/* 6985 */    MCD::OPC_Decode, 145, 6, 58, // Opcode: MOV16jq
/* 6989 */    MCD::OPC_FilterValue, 1, 190, 28, 0, // Skip to: 14352
/* 6994 */    MCD::OPC_Decode, 171, 6, 58, // Opcode: MOV16oq
/* 6998 */    MCD::OPC_FilterValue, 3, 35, 0, 0, // Skip to: 7038
/* 7003 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 7006 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 7022
/* 7011 */    MCD::OPC_CheckField, 24, 4, 8, 166, 28, 0, // Skip to: 14352
/* 7018 */    MCD::OPC_Decode, 142, 6, 59, // Opcode: MOV16jk
/* 7022 */    MCD::OPC_FilterValue, 1, 157, 28, 0, // Skip to: 14352
/* 7027 */    MCD::OPC_CheckField, 24, 4, 8, 150, 28, 0, // Skip to: 14352
/* 7034 */    MCD::OPC_Decode, 168, 6, 59, // Opcode: MOV16ok
/* 7038 */    MCD::OPC_FilterValue, 4, 141, 28, 0, // Skip to: 14352
/* 7043 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 7046 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 7055
/* 7051 */    MCD::OPC_Decode, 140, 6, 58, // Opcode: MOV16ji
/* 7055 */    MCD::OPC_FilterValue, 1, 124, 28, 0, // Skip to: 14352
/* 7060 */    MCD::OPC_Decode, 166, 6, 58, // Opcode: MOV16oi
/* 7064 */    MCD::OPC_FilterValue, 2, 169, 0, 0, // Skip to: 7238
/* 7069 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 7072 */    MCD::OPC_FilterValue, 0, 35, 0, 0, // Skip to: 7112
/* 7077 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 7080 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 7096
/* 7085 */    MCD::OPC_CheckField, 24, 4, 8, 92, 28, 0, // Skip to: 14352
/* 7092 */    MCD::OPC_Decode, 241, 5, 56, // Opcode: MOV16ef
/* 7096 */    MCD::OPC_FilterValue, 1, 83, 28, 0, // Skip to: 14352
/* 7101 */    MCD::OPC_CheckField, 24, 4, 8, 76, 28, 0, // Skip to: 14352
/* 7108 */    MCD::OPC_Decode, 178, 6, 64, // Opcode: MOV16pf
/* 7112 */    MCD::OPC_FilterValue, 1, 67, 28, 0, // Skip to: 14352
/* 7117 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 7120 */    MCD::OPC_FilterValue, 1, 21, 0, 0, // Skip to: 7146
/* 7125 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 7128 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 7137
/* 7133 */    MCD::OPC_Decode, 237, 5, 57, // Opcode: MOV16eb
/* 7137 */    MCD::OPC_FilterValue, 1, 42, 28, 0, // Skip to: 14352
/* 7142 */    MCD::OPC_Decode, 174, 6, 65, // Opcode: MOV16pb
/* 7146 */    MCD::OPC_FilterValue, 2, 21, 0, 0, // Skip to: 7172
/* 7151 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 7154 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 7163
/* 7159 */    MCD::OPC_Decode, 247, 5, 58, // Opcode: MOV16eq
/* 7163 */    MCD::OPC_FilterValue, 1, 16, 28, 0, // Skip to: 14352
/* 7168 */    MCD::OPC_Decode, 184, 6, 66, // Opcode: MOV16pq
/* 7172 */    MCD::OPC_FilterValue, 3, 35, 0, 0, // Skip to: 7212
/* 7177 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 7180 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 7196
/* 7185 */    MCD::OPC_CheckField, 24, 4, 8, 248, 27, 0, // Skip to: 14352
/* 7192 */    MCD::OPC_Decode, 244, 5, 59, // Opcode: MOV16ek
/* 7196 */    MCD::OPC_FilterValue, 1, 239, 27, 0, // Skip to: 14352
/* 7201 */    MCD::OPC_CheckField, 24, 4, 8, 232, 27, 0, // Skip to: 14352
/* 7208 */    MCD::OPC_Decode, 181, 6, 67, // Opcode: MOV16pk
/* 7212 */    MCD::OPC_FilterValue, 4, 223, 27, 0, // Skip to: 14352
/* 7217 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 7220 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 7229
/* 7225 */    MCD::OPC_Decode, 242, 5, 58, // Opcode: MOV16ei
/* 7229 */    MCD::OPC_FilterValue, 1, 206, 27, 0, // Skip to: 14352
/* 7234 */    MCD::OPC_Decode, 179, 6, 66, // Opcode: MOV16pi
/* 7238 */    MCD::OPC_FilterValue, 3, 197, 27, 0, // Skip to: 14352
/* 7243 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 7246 */    MCD::OPC_FilterValue, 0, 89, 0, 0, // Skip to: 7340
/* 7251 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 7254 */    MCD::OPC_FilterValue, 0, 18, 0, 0, // Skip to: 7277
/* 7259 */    MCD::OPC_CheckField, 40, 4, 8, 174, 27, 0, // Skip to: 14352
/* 7266 */    MCD::OPC_CheckField, 24, 4, 8, 167, 27, 0, // Skip to: 14352
/* 7273 */    MCD::OPC_Decode, 254, 5, 72, // Opcode: MOV16ff
/* 7277 */    MCD::OPC_FilterValue, 1, 158, 27, 0, // Skip to: 14352
/* 7282 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 7285 */    MCD::OPC_FilterValue, 1, 11, 0, 0, // Skip to: 7301
/* 7290 */    MCD::OPC_CheckField, 24, 4, 8, 143, 27, 0, // Skip to: 14352
/* 7297 */    MCD::OPC_Decode, 208, 5, 84, // Opcode: MOV16bf
/* 7301 */    MCD::OPC_FilterValue, 2, 11, 0, 0, // Skip to: 7317
/* 7306 */    MCD::OPC_CheckField, 24, 4, 8, 127, 27, 0, // Skip to: 14352
/* 7313 */    MCD::OPC_Decode, 191, 6, 85, // Opcode: MOV16qf
/* 7317 */    MCD::OPC_FilterValue, 3, 118, 27, 0, // Skip to: 14352
/* 7322 */    MCD::OPC_CheckField, 40, 4, 8, 111, 27, 0, // Skip to: 14352
/* 7329 */    MCD::OPC_CheckField, 24, 4, 8, 104, 27, 0, // Skip to: 14352
/* 7336 */    MCD::OPC_Decode, 152, 6, 86, // Opcode: MOV16kf
/* 7340 */    MCD::OPC_FilterValue, 1, 95, 27, 0, // Skip to: 14352
/* 7345 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 7348 */    MCD::OPC_FilterValue, 1, 61, 0, 0, // Skip to: 7414
/* 7353 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 7356 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 7372
/* 7361 */    MCD::OPC_CheckField, 56, 4, 8, 72, 27, 0, // Skip to: 14352
/* 7368 */    MCD::OPC_Decode, 250, 5, 73, // Opcode: MOV16fb
/* 7372 */    MCD::OPC_FilterValue, 1, 63, 27, 0, // Skip to: 14352
/* 7377 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 7380 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 7389
/* 7385 */    MCD::OPC_Decode, 204, 5, 87, // Opcode: MOV16bb
/* 7389 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 7398
/* 7394 */    MCD::OPC_Decode, 187, 6, 88, // Opcode: MOV16qb
/* 7398 */    MCD::OPC_FilterValue, 3, 37, 27, 0, // Skip to: 14352
/* 7403 */    MCD::OPC_CheckField, 56, 4, 8, 30, 27, 0, // Skip to: 14352
/* 7410 */    MCD::OPC_Decode, 148, 6, 89, // Opcode: MOV16kb
/* 7414 */    MCD::OPC_FilterValue, 2, 61, 0, 0, // Skip to: 7480
/* 7419 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 7422 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 7438
/* 7427 */    MCD::OPC_CheckField, 40, 4, 8, 6, 27, 0, // Skip to: 14352
/* 7434 */    MCD::OPC_Decode, 132, 6, 74, // Opcode: MOV16fq
/* 7438 */    MCD::OPC_FilterValue, 1, 253, 26, 0, // Skip to: 14352
/* 7443 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 7446 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 7455
/* 7451 */    MCD::OPC_Decode, 214, 5, 90, // Opcode: MOV16bq
/* 7455 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 7464
/* 7460 */    MCD::OPC_Decode, 197, 6, 91, // Opcode: MOV16qq
/* 7464 */    MCD::OPC_FilterValue, 3, 227, 26, 0, // Skip to: 14352
/* 7469 */    MCD::OPC_CheckField, 40, 4, 8, 220, 26, 0, // Skip to: 14352
/* 7476 */    MCD::OPC_Decode, 158, 6, 92, // Opcode: MOV16kq
/* 7480 */    MCD::OPC_FilterValue, 3, 89, 0, 0, // Skip to: 7574
/* 7485 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 7488 */    MCD::OPC_FilterValue, 0, 18, 0, 0, // Skip to: 7511
/* 7493 */    MCD::OPC_CheckField, 40, 4, 8, 196, 26, 0, // Skip to: 14352
/* 7500 */    MCD::OPC_CheckField, 24, 4, 8, 189, 26, 0, // Skip to: 14352
/* 7507 */    MCD::OPC_Decode, 129, 6, 75, // Opcode: MOV16fk
/* 7511 */    MCD::OPC_FilterValue, 1, 180, 26, 0, // Skip to: 14352
/* 7516 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 7519 */    MCD::OPC_FilterValue, 1, 11, 0, 0, // Skip to: 7535
/* 7524 */    MCD::OPC_CheckField, 24, 4, 8, 165, 26, 0, // Skip to: 14352
/* 7531 */    MCD::OPC_Decode, 211, 5, 93, // Opcode: MOV16bk
/* 7535 */    MCD::OPC_FilterValue, 2, 11, 0, 0, // Skip to: 7551
/* 7540 */    MCD::OPC_CheckField, 24, 4, 8, 149, 26, 0, // Skip to: 14352
/* 7547 */    MCD::OPC_Decode, 194, 6, 94, // Opcode: MOV16qk
/* 7551 */    MCD::OPC_FilterValue, 3, 140, 26, 0, // Skip to: 14352
/* 7556 */    MCD::OPC_CheckField, 40, 4, 8, 133, 26, 0, // Skip to: 14352
/* 7563 */    MCD::OPC_CheckField, 24, 4, 8, 126, 26, 0, // Skip to: 14352
/* 7570 */    MCD::OPC_Decode, 155, 6, 95, // Opcode: MOV16kk
/* 7574 */    MCD::OPC_FilterValue, 4, 117, 26, 0, // Skip to: 14352
/* 7579 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 7582 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 7598
/* 7587 */    MCD::OPC_CheckField, 40, 4, 8, 102, 26, 0, // Skip to: 14352
/* 7594 */    MCD::OPC_Decode, 255, 5, 74, // Opcode: MOV16fi
/* 7598 */    MCD::OPC_FilterValue, 1, 93, 26, 0, // Skip to: 14352
/* 7603 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 7606 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 7615
/* 7611 */    MCD::OPC_Decode, 209, 5, 90, // Opcode: MOV16bi
/* 7615 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 7624
/* 7620 */    MCD::OPC_Decode, 192, 6, 91, // Opcode: MOV16qi
/* 7624 */    MCD::OPC_FilterValue, 3, 67, 26, 0, // Skip to: 14352
/* 7629 */    MCD::OPC_CheckField, 40, 4, 8, 60, 26, 0, // Skip to: 14352
/* 7636 */    MCD::OPC_Decode, 153, 6, 92, // Opcode: MOV16ki
/* 7640 */    MCD::OPC_FilterValue, 4, 184, 5, 0, // Skip to: 9109
/* 7645 */    MCD::OPC_ExtractField, 4, 5,  // Inst{8-4} ...
/* 7648 */    MCD::OPC_FilterValue, 0, 107, 0, 0, // Skip to: 7760
/* 7653 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 7656 */    MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 7666
/* 7661 */    MCD::OPC_Decode, 234, 8, 162, 1, // Opcode: NEGX8d
/* 7666 */    MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 7676
/* 7671 */    MCD::OPC_Decode, 231, 8, 162, 1, // Opcode: NEG8d
/* 7676 */    MCD::OPC_FilterValue, 3, 5, 0, 0, // Skip to: 7686
/* 7681 */    MCD::OPC_Decode, 238, 8, 162, 1, // Opcode: NOT8d
/* 7686 */    MCD::OPC_FilterValue, 4, 12, 0, 0, // Skip to: 7703
/* 7691 */    MCD::OPC_CheckField, 3, 1, 1, 254, 25, 0, // Skip to: 14352
/* 7698 */    MCD::OPC_Decode, 177, 5, 163, 1, // Opcode: LINK32
/* 7703 */    MCD::OPC_FilterValue, 6, 244, 25, 0, // Skip to: 14352
/* 7708 */    MCD::OPC_ExtractField, 16, 12,  // Inst{27-16} ...
/* 7711 */    MCD::OPC_FilterValue, 0, 19, 0, 0, // Skip to: 7735
/* 7716 */    MCD::OPC_CheckField, 31, 1, 0, 229, 25, 0, // Skip to: 14352
/* 7723 */    MCD::OPC_CheckField, 3, 1, 0, 222, 25, 0, // Skip to: 14352
/* 7730 */    MCD::OPC_Decode, 156, 10, 164, 1, // Opcode: UMULd32d32
/* 7735 */    MCD::OPC_FilterValue, 128, 16, 211, 25, 0, // Skip to: 14352
/* 7741 */    MCD::OPC_CheckField, 31, 1, 0, 204, 25, 0, // Skip to: 14352
/* 7748 */    MCD::OPC_CheckField, 3, 1, 0, 197, 25, 0, // Skip to: 14352
/* 7755 */    MCD::OPC_Decode, 224, 9, 164, 1, // Opcode: SMULd32d32
/* 7760 */    MCD::OPC_FilterValue, 4, 117, 0, 0, // Skip to: 7882
/* 7765 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 7768 */    MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 7778
/* 7773 */    MCD::OPC_Decode, 232, 8, 165, 1, // Opcode: NEGX16d
/* 7778 */    MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 7788
/* 7783 */    MCD::OPC_Decode, 229, 8, 165, 1, // Opcode: NEG16d
/* 7788 */    MCD::OPC_FilterValue, 3, 5, 0, 0, // Skip to: 7798
/* 7793 */    MCD::OPC_Decode, 236, 8, 165, 1, // Opcode: NOT16d
/* 7798 */    MCD::OPC_FilterValue, 4, 12, 0, 0, // Skip to: 7815
/* 7803 */    MCD::OPC_CheckField, 3, 1, 1, 142, 25, 0, // Skip to: 14352
/* 7810 */    MCD::OPC_Decode, 248, 3, 166, 1, // Opcode: BKPT
/* 7815 */    MCD::OPC_FilterValue, 6, 52, 0, 0, // Skip to: 7872
/* 7820 */    MCD::OPC_ExtractField, 16, 12,  // Inst{27-16} ...
/* 7823 */    MCD::OPC_FilterValue, 0, 19, 0, 0, // Skip to: 7847
/* 7828 */    MCD::OPC_CheckField, 31, 1, 0, 117, 25, 0, // Skip to: 14352
/* 7835 */    MCD::OPC_CheckField, 3, 1, 0, 110, 25, 0, // Skip to: 14352
/* 7842 */    MCD::OPC_Decode, 153, 10, 164, 1, // Opcode: UDIVd32d32
/* 7847 */    MCD::OPC_FilterValue, 128, 16, 99, 25, 0, // Skip to: 14352
/* 7853 */    MCD::OPC_CheckField, 31, 1, 0, 92, 25, 0, // Skip to: 14352
/* 7860 */    MCD::OPC_CheckField, 3, 1, 0, 85, 25, 0, // Skip to: 14352
/* 7867 */    MCD::OPC_Decode, 167, 9, 164, 1, // Opcode: SDIVd32d32
/* 7872 */    MCD::OPC_FilterValue, 7, 75, 25, 0, // Skip to: 14352
/* 7877 */    MCD::OPC_Decode, 150, 10, 167, 1, // Opcode: TRAP
/* 7882 */    MCD::OPC_FilterValue, 5, 37, 0, 0, // Skip to: 7924
/* 7887 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 7890 */    MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 7907
/* 7895 */    MCD::OPC_CheckField, 9, 3, 7, 50, 25, 0, // Skip to: 14352
/* 7902 */    MCD::OPC_Decode, 176, 5, 168, 1, // Opcode: LINK16
/* 7907 */    MCD::OPC_FilterValue, 1, 40, 25, 0, // Skip to: 14352
/* 7912 */    MCD::OPC_CheckField, 9, 3, 7, 33, 25, 0, // Skip to: 14352
/* 7919 */    MCD::OPC_Decode, 158, 10, 169, 1, // Opcode: UNLK
/* 7924 */    MCD::OPC_FilterValue, 7, 71, 0, 0, // Skip to: 8000
/* 7929 */    MCD::OPC_ExtractField, 0, 4,  // Inst{3-0} ...
/* 7932 */    MCD::OPC_FilterValue, 1, 12, 0, 0, // Skip to: 7949
/* 7937 */    MCD::OPC_CheckField, 9, 3, 7, 8, 25, 0, // Skip to: 14352
/* 7944 */    MCD::OPC_Decode, 235, 8, 170, 1, // Opcode: NOP
/* 7949 */    MCD::OPC_FilterValue, 3, 12, 0, 0, // Skip to: 7966
/* 7954 */    MCD::OPC_CheckField, 9, 3, 7, 247, 24, 0, // Skip to: 14352
/* 7961 */    MCD::OPC_Decode, 164, 9, 170, 1, // Opcode: RTE
/* 7966 */    MCD::OPC_FilterValue, 5, 12, 0, 0, // Skip to: 7983
/* 7971 */    MCD::OPC_CheckField, 9, 3, 7, 230, 24, 0, // Skip to: 14352
/* 7978 */    MCD::OPC_Decode, 165, 9, 170, 1, // Opcode: RTS
/* 7983 */    MCD::OPC_FilterValue, 6, 220, 24, 0, // Skip to: 14352
/* 7988 */    MCD::OPC_CheckField, 9, 3, 7, 213, 24, 0, // Skip to: 14352
/* 7995 */    MCD::OPC_Decode, 151, 10, 170, 1, // Opcode: TRAPV
/* 8000 */    MCD::OPC_FilterValue, 8, 50, 0, 0, // Skip to: 8055
/* 8005 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 8008 */    MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 8018
/* 8013 */    MCD::OPC_Decode, 233, 8, 171, 1, // Opcode: NEGX32d
/* 8018 */    MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 8028
/* 8023 */    MCD::OPC_Decode, 230, 8, 171, 1, // Opcode: NEG32d
/* 8028 */    MCD::OPC_FilterValue, 3, 5, 0, 0, // Skip to: 8038
/* 8033 */    MCD::OPC_Decode, 237, 8, 171, 1, // Opcode: NOT32d
/* 8038 */    MCD::OPC_FilterValue, 4, 165, 24, 0, // Skip to: 14352
/* 8043 */    MCD::OPC_CheckField, 3, 1, 0, 158, 24, 0, // Skip to: 14352
/* 8050 */    MCD::OPC_Decode, 228, 4, 172, 1, // Opcode: EXT16
/* 8055 */    MCD::OPC_FilterValue, 9, 72, 0, 0, // Skip to: 8132
/* 8060 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 8063 */    MCD::OPC_FilterValue, 4, 21, 0, 0, // Skip to: 8089
/* 8068 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 8071 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 8080
/* 8076 */    MCD::OPC_Decode, 199, 8, 16, // Opcode: MOVM16jm
/* 8080 */    MCD::OPC_FilterValue, 1, 123, 24, 0, // Skip to: 14352
/* 8085 */    MCD::OPC_Decode, 209, 8, 16, // Opcode: MOVM16om
/* 8089 */    MCD::OPC_FilterValue, 6, 21, 0, 0, // Skip to: 8115
/* 8094 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 8097 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 8106
/* 8102 */    MCD::OPC_Decode, 204, 8, 17, // Opcode: MOVM16mj
/* 8106 */    MCD::OPC_FilterValue, 1, 97, 24, 0, // Skip to: 14352
/* 8111 */    MCD::OPC_Decode, 206, 8, 17, // Opcode: MOVM16mo
/* 8115 */    MCD::OPC_FilterValue, 7, 88, 24, 0, // Skip to: 14352
/* 8120 */    MCD::OPC_CheckField, 3, 1, 0, 81, 24, 0, // Skip to: 14352
/* 8127 */    MCD::OPC_Decode, 183, 4, 169, 1, // Opcode: CALLj
/* 8132 */    MCD::OPC_FilterValue, 10, 55, 0, 0, // Skip to: 8192
/* 8137 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 8140 */    MCD::OPC_FilterValue, 0, 21, 0, 0, // Skip to: 8166
/* 8145 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 8148 */    MCD::OPC_FilterValue, 4, 4, 0, 0, // Skip to: 8157
/* 8153 */    MCD::OPC_Decode, 197, 8, 16, // Opcode: MOVM16em
/* 8157 */    MCD::OPC_FilterValue, 6, 46, 24, 0, // Skip to: 14352
/* 8162 */    MCD::OPC_Decode, 202, 8, 17, // Opcode: MOVM16me
/* 8166 */    MCD::OPC_FilterValue, 1, 37, 24, 0, // Skip to: 14352
/* 8171 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 8174 */    MCD::OPC_FilterValue, 4, 4, 0, 0, // Skip to: 8183
/* 8179 */    MCD::OPC_Decode, 210, 8, 18, // Opcode: MOVM16pm
/* 8183 */    MCD::OPC_FilterValue, 6, 20, 24, 0, // Skip to: 14352
/* 8188 */    MCD::OPC_Decode, 207, 8, 19, // Opcode: MOVM16mp
/* 8192 */    MCD::OPC_FilterValue, 11, 180, 0, 0, // Skip to: 8377
/* 8197 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 8200 */    MCD::OPC_FilterValue, 4, 61, 0, 0, // Skip to: 8266
/* 8205 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 8208 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 8224
/* 8213 */    MCD::OPC_CheckField, 40, 4, 8, 244, 23, 0, // Skip to: 14352
/* 8220 */    MCD::OPC_Decode, 198, 8, 20, // Opcode: MOVM16fm
/* 8224 */    MCD::OPC_FilterValue, 1, 235, 23, 0, // Skip to: 14352
/* 8229 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 8232 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 8241
/* 8237 */    MCD::OPC_Decode, 196, 8, 90, // Opcode: MOVM16bm
/* 8241 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 8250
/* 8246 */    MCD::OPC_Decode, 211, 8, 91, // Opcode: MOVM16qm
/* 8250 */    MCD::OPC_FilterValue, 3, 209, 23, 0, // Skip to: 14352
/* 8255 */    MCD::OPC_CheckField, 40, 4, 8, 202, 23, 0, // Skip to: 14352
/* 8262 */    MCD::OPC_Decode, 200, 8, 92, // Opcode: MOVM16km
/* 8266 */    MCD::OPC_FilterValue, 6, 61, 0, 0, // Skip to: 8332
/* 8271 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 8274 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 8290
/* 8279 */    MCD::OPC_CheckField, 40, 4, 8, 178, 23, 0, // Skip to: 14352
/* 8286 */    MCD::OPC_Decode, 203, 8, 21, // Opcode: MOVM16mf
/* 8290 */    MCD::OPC_FilterValue, 1, 169, 23, 0, // Skip to: 14352
/* 8295 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 8298 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 8307
/* 8303 */    MCD::OPC_Decode, 201, 8, 22, // Opcode: MOVM16mb
/* 8307 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 8316
/* 8312 */    MCD::OPC_Decode, 208, 8, 23, // Opcode: MOVM16mq
/* 8316 */    MCD::OPC_FilterValue, 3, 143, 23, 0, // Skip to: 14352
/* 8321 */    MCD::OPC_CheckField, 40, 4, 8, 136, 23, 0, // Skip to: 14352
/* 8328 */    MCD::OPC_Decode, 205, 8, 24, // Opcode: MOVM16mk
/* 8332 */    MCD::OPC_FilterValue, 7, 127, 23, 0, // Skip to: 14352
/* 8337 */    MCD::OPC_ExtractField, 0, 4,  // Inst{3-0} ...
/* 8340 */    MCD::OPC_FilterValue, 9, 5, 0, 0, // Skip to: 8350
/* 8345 */    MCD::OPC_Decode, 182, 4, 173, 1, // Opcode: CALLb
/* 8350 */    MCD::OPC_FilterValue, 10, 5, 0, 0, // Skip to: 8360
/* 8355 */    MCD::OPC_Decode, 185, 4, 174, 1, // Opcode: CALLq
/* 8360 */    MCD::OPC_FilterValue, 11, 99, 23, 0, // Skip to: 14352
/* 8365 */    MCD::OPC_CheckField, 24, 4, 8, 92, 23, 0, // Skip to: 14352
/* 8372 */    MCD::OPC_Decode, 184, 4, 175, 1, // Opcode: CALLk
/* 8377 */    MCD::OPC_FilterValue, 12, 59, 0, 0, // Skip to: 8441
/* 8382 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 8385 */    MCD::OPC_FilterValue, 1, 17, 0, 0, // Skip to: 8407
/* 8390 */    MCD::OPC_CheckPredicate, 1, 69, 23, 0, // Skip to: 14352
/* 8395 */    MCD::OPC_CheckField, 3, 1, 0, 62, 23, 0, // Skip to: 14352
/* 8402 */    MCD::OPC_Decode, 226, 5, 176, 1, // Opcode: MOV16dc
/* 8407 */    MCD::OPC_FilterValue, 2, 12, 0, 0, // Skip to: 8424
/* 8412 */    MCD::OPC_CheckField, 3, 1, 0, 45, 23, 0, // Skip to: 14352
/* 8419 */    MCD::OPC_Decode, 217, 5, 177, 1, // Opcode: MOV16cd
/* 8424 */    MCD::OPC_FilterValue, 4, 35, 23, 0, // Skip to: 14352
/* 8429 */    MCD::OPC_CheckField, 3, 1, 0, 28, 23, 0, // Skip to: 14352
/* 8436 */    MCD::OPC_Decode, 229, 4, 178, 1, // Opcode: EXT32
/* 8441 */    MCD::OPC_FilterValue, 13, 138, 0, 0, // Skip to: 8584
/* 8446 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 8449 */    MCD::OPC_FilterValue, 1, 33, 0, 0, // Skip to: 8487
/* 8454 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 8457 */    MCD::OPC_FilterValue, 0, 10, 0, 0, // Skip to: 8472
/* 8462 */    MCD::OPC_CheckPredicate, 1, 253, 22, 0, // Skip to: 14352
/* 8467 */    MCD::OPC_Decode, 136, 6, 179, 1, // Opcode: MOV16jc
/* 8472 */    MCD::OPC_FilterValue, 1, 243, 22, 0, // Skip to: 14352
/* 8477 */    MCD::OPC_CheckPredicate, 1, 238, 22, 0, // Skip to: 14352
/* 8482 */    MCD::OPC_Decode, 162, 6, 179, 1, // Opcode: MOV16oc
/* 8487 */    MCD::OPC_FilterValue, 2, 23, 0, 0, // Skip to: 8515
/* 8492 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 8495 */    MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 8505
/* 8500 */    MCD::OPC_Decode, 220, 5, 177, 1, // Opcode: MOV16cj
/* 8505 */    MCD::OPC_FilterValue, 1, 210, 22, 0, // Skip to: 14352
/* 8510 */    MCD::OPC_Decode, 222, 5, 177, 1, // Opcode: MOV16co
/* 8515 */    MCD::OPC_FilterValue, 4, 21, 0, 0, // Skip to: 8541
/* 8520 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 8523 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 8532
/* 8528 */    MCD::OPC_Decode, 215, 8, 16, // Opcode: MOVM32jm
/* 8532 */    MCD::OPC_FilterValue, 1, 183, 22, 0, // Skip to: 14352
/* 8537 */    MCD::OPC_Decode, 225, 8, 16, // Opcode: MOVM32om
/* 8541 */    MCD::OPC_FilterValue, 6, 21, 0, 0, // Skip to: 8567
/* 8546 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 8549 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 8558
/* 8554 */    MCD::OPC_Decode, 220, 8, 17, // Opcode: MOVM32mj
/* 8558 */    MCD::OPC_FilterValue, 1, 157, 22, 0, // Skip to: 14352
/* 8563 */    MCD::OPC_Decode, 222, 8, 17, // Opcode: MOVM32mo
/* 8567 */    MCD::OPC_FilterValue, 7, 148, 22, 0, // Skip to: 14352
/* 8572 */    MCD::OPC_CheckField, 3, 1, 0, 141, 22, 0, // Skip to: 14352
/* 8579 */    MCD::OPC_Decode, 170, 5, 169, 1, // Opcode: JMP32j
/* 8584 */    MCD::OPC_FilterValue, 14, 121, 0, 0, // Skip to: 8710
/* 8589 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 8592 */    MCD::OPC_FilterValue, 1, 33, 0, 0, // Skip to: 8630
/* 8597 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 8600 */    MCD::OPC_FilterValue, 0, 10, 0, 0, // Skip to: 8615
/* 8605 */    MCD::OPC_CheckPredicate, 1, 110, 22, 0, // Skip to: 14352
/* 8610 */    MCD::OPC_Decode, 238, 5, 179, 1, // Opcode: MOV16ec
/* 8615 */    MCD::OPC_FilterValue, 1, 100, 22, 0, // Skip to: 14352
/* 8620 */    MCD::OPC_CheckPredicate, 1, 95, 22, 0, // Skip to: 14352
/* 8625 */    MCD::OPC_Decode, 175, 6, 180, 1, // Opcode: MOV16pc
/* 8630 */    MCD::OPC_FilterValue, 2, 23, 0, 0, // Skip to: 8658
/* 8635 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 8638 */    MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 8648
/* 8643 */    MCD::OPC_Decode, 218, 5, 177, 1, // Opcode: MOV16ce
/* 8648 */    MCD::OPC_FilterValue, 1, 67, 22, 0, // Skip to: 14352
/* 8653 */    MCD::OPC_Decode, 223, 5, 177, 1, // Opcode: MOV16cp
/* 8658 */    MCD::OPC_FilterValue, 4, 21, 0, 0, // Skip to: 8684
/* 8663 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 8666 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 8675
/* 8671 */    MCD::OPC_Decode, 213, 8, 16, // Opcode: MOVM32em
/* 8675 */    MCD::OPC_FilterValue, 1, 40, 22, 0, // Skip to: 14352
/* 8680 */    MCD::OPC_Decode, 226, 8, 18, // Opcode: MOVM32pm
/* 8684 */    MCD::OPC_FilterValue, 6, 31, 22, 0, // Skip to: 14352
/* 8689 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 8692 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 8701
/* 8697 */    MCD::OPC_Decode, 218, 8, 17, // Opcode: MOVM32me
/* 8701 */    MCD::OPC_FilterValue, 1, 14, 22, 0, // Skip to: 14352
/* 8706 */    MCD::OPC_Decode, 223, 8, 19, // Opcode: MOVM32mp
/* 8710 */    MCD::OPC_FilterValue, 15, 56, 1, 0, // Skip to: 9027
/* 8715 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 8718 */    MCD::OPC_FilterValue, 1, 85, 0, 0, // Skip to: 8808
/* 8723 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 8726 */    MCD::OPC_FilterValue, 0, 17, 0, 0, // Skip to: 8748
/* 8731 */    MCD::OPC_CheckPredicate, 1, 240, 21, 0, // Skip to: 14352
/* 8736 */    MCD::OPC_CheckField, 24, 4, 8, 233, 21, 0, // Skip to: 14352
/* 8743 */    MCD::OPC_Decode, 251, 5, 181, 1, // Opcode: MOV16fc
/* 8748 */    MCD::OPC_FilterValue, 1, 223, 21, 0, // Skip to: 14352
/* 8753 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 8756 */    MCD::OPC_FilterValue, 1, 10, 0, 0, // Skip to: 8771
/* 8761 */    MCD::OPC_CheckPredicate, 1, 210, 21, 0, // Skip to: 14352
/* 8766 */    MCD::OPC_Decode, 205, 5, 182, 1, // Opcode: MOV16bc
/* 8771 */    MCD::OPC_FilterValue, 2, 10, 0, 0, // Skip to: 8786
/* 8776 */    MCD::OPC_CheckPredicate, 1, 195, 21, 0, // Skip to: 14352
/* 8781 */    MCD::OPC_Decode, 188, 6, 183, 1, // Opcode: MOV16qc
/* 8786 */    MCD::OPC_FilterValue, 3, 185, 21, 0, // Skip to: 14352
/* 8791 */    MCD::OPC_CheckPredicate, 1, 180, 21, 0, // Skip to: 14352
/* 8796 */    MCD::OPC_CheckField, 24, 4, 8, 173, 21, 0, // Skip to: 14352
/* 8803 */    MCD::OPC_Decode, 149, 6, 184, 1, // Opcode: MOV16kc
/* 8808 */    MCD::OPC_FilterValue, 2, 65, 0, 0, // Skip to: 8878
/* 8813 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 8816 */    MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 8833
/* 8821 */    MCD::OPC_CheckField, 24, 4, 8, 148, 21, 0, // Skip to: 14352
/* 8828 */    MCD::OPC_Decode, 219, 5, 177, 1, // Opcode: MOV16cf
/* 8833 */    MCD::OPC_FilterValue, 1, 138, 21, 0, // Skip to: 14352
/* 8838 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 8841 */    MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 8851
/* 8846 */    MCD::OPC_Decode, 216, 5, 177, 1, // Opcode: MOV16cb
/* 8851 */    MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 8861
/* 8856 */    MCD::OPC_Decode, 224, 5, 177, 1, // Opcode: MOV16cq
/* 8861 */    MCD::OPC_FilterValue, 3, 110, 21, 0, // Skip to: 14352
/* 8866 */    MCD::OPC_CheckField, 24, 4, 8, 103, 21, 0, // Skip to: 14352
/* 8873 */    MCD::OPC_Decode, 221, 5, 177, 1, // Opcode: MOV16ck
/* 8878 */    MCD::OPC_FilterValue, 4, 61, 0, 0, // Skip to: 8944
/* 8883 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 8886 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 8902
/* 8891 */    MCD::OPC_CheckField, 40, 4, 8, 78, 21, 0, // Skip to: 14352
/* 8898 */    MCD::OPC_Decode, 214, 8, 20, // Opcode: MOVM32fm
/* 8902 */    MCD::OPC_FilterValue, 1, 69, 21, 0, // Skip to: 14352
/* 8907 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 8910 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 8919
/* 8915 */    MCD::OPC_Decode, 212, 8, 90, // Opcode: MOVM32bm
/* 8919 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 8928
/* 8924 */    MCD::OPC_Decode, 227, 8, 91, // Opcode: MOVM32qm
/* 8928 */    MCD::OPC_FilterValue, 3, 43, 21, 0, // Skip to: 14352
/* 8933 */    MCD::OPC_CheckField, 40, 4, 8, 36, 21, 0, // Skip to: 14352
/* 8940 */    MCD::OPC_Decode, 216, 8, 92, // Opcode: MOVM32km
/* 8944 */    MCD::OPC_FilterValue, 5, 12, 0, 0, // Skip to: 8961
/* 8949 */    MCD::OPC_CheckField, 0, 4, 12, 20, 21, 0, // Skip to: 14352
/* 8956 */    MCD::OPC_Decode, 169, 5, 170, 1, // Opcode: ILLEGAL
/* 8961 */    MCD::OPC_FilterValue, 6, 10, 21, 0, // Skip to: 14352
/* 8966 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 8969 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 8985
/* 8974 */    MCD::OPC_CheckField, 40, 4, 8, 251, 20, 0, // Skip to: 14352
/* 8981 */    MCD::OPC_Decode, 219, 8, 21, // Opcode: MOVM32mf
/* 8985 */    MCD::OPC_FilterValue, 1, 242, 20, 0, // Skip to: 14352
/* 8990 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 8993 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 9002
/* 8998 */    MCD::OPC_Decode, 217, 8, 22, // Opcode: MOVM32mb
/* 9002 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 9011
/* 9007 */    MCD::OPC_Decode, 224, 8, 23, // Opcode: MOVM32mq
/* 9011 */    MCD::OPC_FilterValue, 3, 216, 20, 0, // Skip to: 14352
/* 9016 */    MCD::OPC_CheckField, 40, 4, 8, 209, 20, 0, // Skip to: 14352
/* 9023 */    MCD::OPC_Decode, 221, 8, 24, // Opcode: MOVM32mk
/* 9027 */    MCD::OPC_FilterValue, 30, 11, 0, 0, // Skip to: 9043
/* 9032 */    MCD::OPC_CheckField, 3, 1, 1, 193, 20, 0, // Skip to: 14352
/* 9039 */    MCD::OPC_Decode, 174, 5, 55, // Opcode: LEA32p
/* 9043 */    MCD::OPC_FilterValue, 31, 184, 20, 0, // Skip to: 14352
/* 9048 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 9051 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 9067
/* 9056 */    MCD::OPC_CheckField, 24, 4, 8, 169, 20, 0, // Skip to: 14352
/* 9063 */    MCD::OPC_Decode, 172, 5, 56, // Opcode: LEA32f
/* 9067 */    MCD::OPC_FilterValue, 1, 160, 20, 0, // Skip to: 14352
/* 9072 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 9075 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 9084
/* 9080 */    MCD::OPC_Decode, 171, 5, 57, // Opcode: LEA32b
/* 9084 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 9093
/* 9089 */    MCD::OPC_Decode, 175, 5, 58, // Opcode: LEA32q
/* 9093 */    MCD::OPC_FilterValue, 3, 134, 20, 0, // Skip to: 14352
/* 9098 */    MCD::OPC_CheckField, 24, 4, 8, 127, 20, 0, // Skip to: 14352
/* 9105 */    MCD::OPC_Decode, 173, 5, 59, // Opcode: LEA32k
/* 9109 */    MCD::OPC_FilterValue, 5, 203, 2, 0, // Skip to: 9829
/* 9114 */    MCD::OPC_ExtractField, 4, 8,  // Inst{11-4} ...
/* 9117 */    MCD::OPC_FilterValue, 12, 5, 0, 0, // Skip to: 9127
/* 9122 */    MCD::OPC_Decode, 182, 9, 185, 1, // Opcode: SETd8t
/* 9127 */    MCD::OPC_FilterValue, 13, 12, 0, 0, // Skip to: 9144
/* 9132 */    MCD::OPC_CheckField, 3, 1, 0, 93, 20, 0, // Skip to: 14352
/* 9139 */    MCD::OPC_Decode, 198, 9, 169, 1, // Opcode: SETj8t
/* 9144 */    MCD::OPC_FilterValue, 14, 11, 0, 0, // Skip to: 9160
/* 9149 */    MCD::OPC_CheckField, 3, 1, 1, 76, 20, 0, // Skip to: 14352
/* 9156 */    MCD::OPC_Decode, 214, 9, 17, // Opcode: SETp8t
/* 9160 */    MCD::OPC_FilterValue, 28, 5, 0, 0, // Skip to: 9170
/* 9165 */    MCD::OPC_Decode, 172, 9, 185, 1, // Opcode: SETd8f
/* 9170 */    MCD::OPC_FilterValue, 29, 12, 0, 0, // Skip to: 9187
/* 9175 */    MCD::OPC_CheckField, 3, 1, 0, 50, 20, 0, // Skip to: 14352
/* 9182 */    MCD::OPC_Decode, 188, 9, 169, 1, // Opcode: SETj8f
/* 9187 */    MCD::OPC_FilterValue, 30, 11, 0, 0, // Skip to: 9203
/* 9192 */    MCD::OPC_CheckField, 3, 1, 1, 33, 20, 0, // Skip to: 14352
/* 9199 */    MCD::OPC_Decode, 204, 9, 17, // Opcode: SETp8f
/* 9203 */    MCD::OPC_FilterValue, 44, 5, 0, 0, // Skip to: 9213
/* 9208 */    MCD::OPC_Decode, 175, 9, 185, 1, // Opcode: SETd8hi
/* 9213 */    MCD::OPC_FilterValue, 45, 12, 0, 0, // Skip to: 9230
/* 9218 */    MCD::OPC_CheckField, 3, 1, 0, 7, 20, 0, // Skip to: 14352
/* 9225 */    MCD::OPC_Decode, 191, 9, 169, 1, // Opcode: SETj8hi
/* 9230 */    MCD::OPC_FilterValue, 46, 11, 0, 0, // Skip to: 9246
/* 9235 */    MCD::OPC_CheckField, 3, 1, 1, 246, 19, 0, // Skip to: 14352
/* 9242 */    MCD::OPC_Decode, 207, 9, 17, // Opcode: SETp8hi
/* 9246 */    MCD::OPC_FilterValue, 60, 5, 0, 0, // Skip to: 9256
/* 9251 */    MCD::OPC_Decode, 177, 9, 185, 1, // Opcode: SETd8ls
/* 9256 */    MCD::OPC_FilterValue, 61, 12, 0, 0, // Skip to: 9273
/* 9261 */    MCD::OPC_CheckField, 3, 1, 0, 220, 19, 0, // Skip to: 14352
/* 9268 */    MCD::OPC_Decode, 193, 9, 169, 1, // Opcode: SETj8ls
/* 9273 */    MCD::OPC_FilterValue, 62, 11, 0, 0, // Skip to: 9289
/* 9278 */    MCD::OPC_CheckField, 3, 1, 1, 203, 19, 0, // Skip to: 14352
/* 9285 */    MCD::OPC_Decode, 209, 9, 17, // Opcode: SETp8ls
/* 9289 */    MCD::OPC_FilterValue, 76, 5, 0, 0, // Skip to: 9299
/* 9294 */    MCD::OPC_Decode, 169, 9, 185, 1, // Opcode: SETd8cc
/* 9299 */    MCD::OPC_FilterValue, 77, 12, 0, 0, // Skip to: 9316
/* 9304 */    MCD::OPC_CheckField, 3, 1, 0, 177, 19, 0, // Skip to: 14352
/* 9311 */    MCD::OPC_Decode, 185, 9, 169, 1, // Opcode: SETj8cc
/* 9316 */    MCD::OPC_FilterValue, 78, 11, 0, 0, // Skip to: 9332
/* 9321 */    MCD::OPC_CheckField, 3, 1, 1, 160, 19, 0, // Skip to: 14352
/* 9328 */    MCD::OPC_Decode, 201, 9, 17, // Opcode: SETp8cc
/* 9332 */    MCD::OPC_FilterValue, 92, 5, 0, 0, // Skip to: 9342
/* 9337 */    MCD::OPC_Decode, 170, 9, 185, 1, // Opcode: SETd8cs
/* 9342 */    MCD::OPC_FilterValue, 93, 12, 0, 0, // Skip to: 9359
/* 9347 */    MCD::OPC_CheckField, 3, 1, 0, 134, 19, 0, // Skip to: 14352
/* 9354 */    MCD::OPC_Decode, 186, 9, 169, 1, // Opcode: SETj8cs
/* 9359 */    MCD::OPC_FilterValue, 94, 11, 0, 0, // Skip to: 9375
/* 9364 */    MCD::OPC_CheckField, 3, 1, 1, 117, 19, 0, // Skip to: 14352
/* 9371 */    MCD::OPC_Decode, 202, 9, 17, // Opcode: SETp8cs
/* 9375 */    MCD::OPC_FilterValue, 108, 5, 0, 0, // Skip to: 9385
/* 9380 */    MCD::OPC_Decode, 180, 9, 185, 1, // Opcode: SETd8ne
/* 9385 */    MCD::OPC_FilterValue, 109, 12, 0, 0, // Skip to: 9402
/* 9390 */    MCD::OPC_CheckField, 3, 1, 0, 91, 19, 0, // Skip to: 14352
/* 9397 */    MCD::OPC_Decode, 196, 9, 169, 1, // Opcode: SETj8ne
/* 9402 */    MCD::OPC_FilterValue, 110, 11, 0, 0, // Skip to: 9418
/* 9407 */    MCD::OPC_CheckField, 3, 1, 1, 74, 19, 0, // Skip to: 14352
/* 9414 */    MCD::OPC_Decode, 212, 9, 17, // Opcode: SETp8ne
/* 9418 */    MCD::OPC_FilterValue, 124, 5, 0, 0, // Skip to: 9428
/* 9423 */    MCD::OPC_Decode, 171, 9, 185, 1, // Opcode: SETd8eq
/* 9428 */    MCD::OPC_FilterValue, 125, 12, 0, 0, // Skip to: 9445
/* 9433 */    MCD::OPC_CheckField, 3, 1, 0, 48, 19, 0, // Skip to: 14352
/* 9440 */    MCD::OPC_Decode, 187, 9, 169, 1, // Opcode: SETj8eq
/* 9445 */    MCD::OPC_FilterValue, 126, 11, 0, 0, // Skip to: 9461
/* 9450 */    MCD::OPC_CheckField, 3, 1, 1, 31, 19, 0, // Skip to: 14352
/* 9457 */    MCD::OPC_Decode, 203, 9, 17, // Opcode: SETp8eq
/* 9461 */    MCD::OPC_FilterValue, 140, 1, 5, 0, 0, // Skip to: 9472
/* 9467 */    MCD::OPC_Decode, 183, 9, 185, 1, // Opcode: SETd8vc
/* 9472 */    MCD::OPC_FilterValue, 141, 1, 12, 0, 0, // Skip to: 9490
/* 9478 */    MCD::OPC_CheckField, 3, 1, 0, 3, 19, 0, // Skip to: 14352
/* 9485 */    MCD::OPC_Decode, 199, 9, 169, 1, // Opcode: SETj8vc
/* 9490 */    MCD::OPC_FilterValue, 142, 1, 11, 0, 0, // Skip to: 9507
/* 9496 */    MCD::OPC_CheckField, 3, 1, 1, 241, 18, 0, // Skip to: 14352
/* 9503 */    MCD::OPC_Decode, 215, 9, 17, // Opcode: SETp8vc
/* 9507 */    MCD::OPC_FilterValue, 156, 1, 5, 0, 0, // Skip to: 9518
/* 9513 */    MCD::OPC_Decode, 184, 9, 185, 1, // Opcode: SETd8vs
/* 9518 */    MCD::OPC_FilterValue, 157, 1, 12, 0, 0, // Skip to: 9536
/* 9524 */    MCD::OPC_CheckField, 3, 1, 0, 213, 18, 0, // Skip to: 14352
/* 9531 */    MCD::OPC_Decode, 200, 9, 169, 1, // Opcode: SETj8vs
/* 9536 */    MCD::OPC_FilterValue, 158, 1, 11, 0, 0, // Skip to: 9553
/* 9542 */    MCD::OPC_CheckField, 3, 1, 1, 195, 18, 0, // Skip to: 14352
/* 9549 */    MCD::OPC_Decode, 216, 9, 17, // Opcode: SETp8vs
/* 9553 */    MCD::OPC_FilterValue, 172, 1, 5, 0, 0, // Skip to: 9564
/* 9559 */    MCD::OPC_Decode, 181, 9, 185, 1, // Opcode: SETd8pl
/* 9564 */    MCD::OPC_FilterValue, 173, 1, 12, 0, 0, // Skip to: 9582
/* 9570 */    MCD::OPC_CheckField, 3, 1, 0, 167, 18, 0, // Skip to: 14352
/* 9577 */    MCD::OPC_Decode, 197, 9, 169, 1, // Opcode: SETj8pl
/* 9582 */    MCD::OPC_FilterValue, 174, 1, 11, 0, 0, // Skip to: 9599
/* 9588 */    MCD::OPC_CheckField, 3, 1, 1, 149, 18, 0, // Skip to: 14352
/* 9595 */    MCD::OPC_Decode, 213, 9, 17, // Opcode: SETp8pl
/* 9599 */    MCD::OPC_FilterValue, 188, 1, 5, 0, 0, // Skip to: 9610
/* 9605 */    MCD::OPC_Decode, 179, 9, 185, 1, // Opcode: SETd8mi
/* 9610 */    MCD::OPC_FilterValue, 189, 1, 12, 0, 0, // Skip to: 9628
/* 9616 */    MCD::OPC_CheckField, 3, 1, 0, 121, 18, 0, // Skip to: 14352
/* 9623 */    MCD::OPC_Decode, 195, 9, 169, 1, // Opcode: SETj8mi
/* 9628 */    MCD::OPC_FilterValue, 190, 1, 11, 0, 0, // Skip to: 9645
/* 9634 */    MCD::OPC_CheckField, 3, 1, 1, 103, 18, 0, // Skip to: 14352
/* 9641 */    MCD::OPC_Decode, 211, 9, 17, // Opcode: SETp8mi
/* 9645 */    MCD::OPC_FilterValue, 204, 1, 5, 0, 0, // Skip to: 9656
/* 9651 */    MCD::OPC_Decode, 173, 9, 185, 1, // Opcode: SETd8ge
/* 9656 */    MCD::OPC_FilterValue, 205, 1, 12, 0, 0, // Skip to: 9674
/* 9662 */    MCD::OPC_CheckField, 3, 1, 0, 75, 18, 0, // Skip to: 14352
/* 9669 */    MCD::OPC_Decode, 189, 9, 169, 1, // Opcode: SETj8ge
/* 9674 */    MCD::OPC_FilterValue, 206, 1, 11, 0, 0, // Skip to: 9691
/* 9680 */    MCD::OPC_CheckField, 3, 1, 1, 57, 18, 0, // Skip to: 14352
/* 9687 */    MCD::OPC_Decode, 205, 9, 17, // Opcode: SETp8ge
/* 9691 */    MCD::OPC_FilterValue, 220, 1, 5, 0, 0, // Skip to: 9702
/* 9697 */    MCD::OPC_Decode, 178, 9, 185, 1, // Opcode: SETd8lt
/* 9702 */    MCD::OPC_FilterValue, 221, 1, 12, 0, 0, // Skip to: 9720
/* 9708 */    MCD::OPC_CheckField, 3, 1, 0, 29, 18, 0, // Skip to: 14352
/* 9715 */    MCD::OPC_Decode, 194, 9, 169, 1, // Opcode: SETj8lt
/* 9720 */    MCD::OPC_FilterValue, 222, 1, 11, 0, 0, // Skip to: 9737
/* 9726 */    MCD::OPC_CheckField, 3, 1, 1, 11, 18, 0, // Skip to: 14352
/* 9733 */    MCD::OPC_Decode, 210, 9, 17, // Opcode: SETp8lt
/* 9737 */    MCD::OPC_FilterValue, 236, 1, 5, 0, 0, // Skip to: 9748
/* 9743 */    MCD::OPC_Decode, 174, 9, 185, 1, // Opcode: SETd8gt
/* 9748 */    MCD::OPC_FilterValue, 237, 1, 12, 0, 0, // Skip to: 9766
/* 9754 */    MCD::OPC_CheckField, 3, 1, 0, 239, 17, 0, // Skip to: 14352
/* 9761 */    MCD::OPC_Decode, 190, 9, 169, 1, // Opcode: SETj8gt
/* 9766 */    MCD::OPC_FilterValue, 238, 1, 11, 0, 0, // Skip to: 9783
/* 9772 */    MCD::OPC_CheckField, 3, 1, 1, 221, 17, 0, // Skip to: 14352
/* 9779 */    MCD::OPC_Decode, 206, 9, 17, // Opcode: SETp8gt
/* 9783 */    MCD::OPC_FilterValue, 252, 1, 5, 0, 0, // Skip to: 9794
/* 9789 */    MCD::OPC_Decode, 176, 9, 185, 1, // Opcode: SETd8le
/* 9794 */    MCD::OPC_FilterValue, 253, 1, 12, 0, 0, // Skip to: 9812
/* 9800 */    MCD::OPC_CheckField, 3, 1, 0, 193, 17, 0, // Skip to: 14352
/* 9807 */    MCD::OPC_Decode, 192, 9, 169, 1, // Opcode: SETj8le
/* 9812 */    MCD::OPC_FilterValue, 254, 1, 182, 17, 0, // Skip to: 14352
/* 9818 */    MCD::OPC_CheckField, 3, 1, 1, 175, 17, 0, // Skip to: 14352
/* 9825 */    MCD::OPC_Decode, 208, 9, 17, // Opcode: SETp8le
/* 9829 */    MCD::OPC_FilterValue, 6, 111, 1, 0, // Skip to: 10201
/* 9834 */    MCD::OPC_ExtractField, 8, 4,  // Inst{11-8} ...
/* 9837 */    MCD::OPC_FilterValue, 0, 17, 0, 0, // Skip to: 9859
/* 9842 */    MCD::OPC_CheckField, 0, 8, 0, 5, 0, 0, // Skip to: 9854
/* 9849 */    MCD::OPC_Decode, 249, 3, 174, 1, // Opcode: BRA16
/* 9854 */    MCD::OPC_Decode, 250, 3, 186, 1, // Opcode: BRA8
/* 9859 */    MCD::OPC_FilterValue, 1, 29, 0, 0, // Skip to: 9893
/* 9864 */    MCD::OPC_ExtractField, 0, 8,  // Inst{7-0} ...
/* 9867 */    MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 9877
/* 9872 */    MCD::OPC_Decode, 135, 4, 174, 1, // Opcode: BSR16
/* 9877 */    MCD::OPC_FilterValue, 255, 1, 5, 0, 0, // Skip to: 9888
/* 9883 */    MCD::OPC_Decode, 136, 4, 173, 1, // Opcode: BSR32
/* 9888 */    MCD::OPC_Decode, 137, 4, 186, 1, // Opcode: BSR8
/* 9893 */    MCD::OPC_FilterValue, 2, 17, 0, 0, // Skip to: 9915
/* 9898 */    MCD::OPC_CheckField, 0, 8, 0, 5, 0, 0, // Skip to: 9910
/* 9905 */    MCD::OPC_Decode, 164, 4, 174, 1, // Opcode: Bhi16
/* 9910 */    MCD::OPC_Decode, 165, 4, 186, 1, // Opcode: Bhi8
/* 9915 */    MCD::OPC_FilterValue, 3, 17, 0, 0, // Skip to: 9937
/* 9920 */    MCD::OPC_CheckField, 0, 8, 0, 5, 0, 0, // Skip to: 9932
/* 9927 */    MCD::OPC_Decode, 168, 4, 174, 1, // Opcode: Bls16
/* 9932 */    MCD::OPC_Decode, 169, 4, 186, 1, // Opcode: Bls8
/* 9937 */    MCD::OPC_FilterValue, 4, 17, 0, 0, // Skip to: 9959
/* 9942 */    MCD::OPC_CheckField, 0, 8, 0, 5, 0, 0, // Skip to: 9954
/* 9949 */    MCD::OPC_Decode, 154, 4, 174, 1, // Opcode: Bcc16
/* 9954 */    MCD::OPC_Decode, 155, 4, 186, 1, // Opcode: Bcc8
/* 9959 */    MCD::OPC_FilterValue, 5, 17, 0, 0, // Skip to: 9981
/* 9964 */    MCD::OPC_CheckField, 0, 8, 0, 5, 0, 0, // Skip to: 9976
/* 9971 */    MCD::OPC_Decode, 156, 4, 174, 1, // Opcode: Bcs16
/* 9976 */    MCD::OPC_Decode, 157, 4, 186, 1, // Opcode: Bcs8
/* 9981 */    MCD::OPC_FilterValue, 6, 17, 0, 0, // Skip to: 10003
/* 9986 */    MCD::OPC_CheckField, 0, 8, 0, 5, 0, 0, // Skip to: 9998
/* 9993 */    MCD::OPC_Decode, 174, 4, 174, 1, // Opcode: Bne16
/* 9998 */    MCD::OPC_Decode, 175, 4, 186, 1, // Opcode: Bne8
/* 10003 */   MCD::OPC_FilterValue, 7, 17, 0, 0, // Skip to: 10025
/* 10008 */   MCD::OPC_CheckField, 0, 8, 0, 5, 0, 0, // Skip to: 10020
/* 10015 */   MCD::OPC_Decode, 158, 4, 174, 1, // Opcode: Beq16
/* 10020 */   MCD::OPC_Decode, 159, 4, 186, 1, // Opcode: Beq8
/* 10025 */   MCD::OPC_FilterValue, 8, 17, 0, 0, // Skip to: 10047
/* 10030 */   MCD::OPC_CheckField, 0, 8, 0, 5, 0, 0, // Skip to: 10042
/* 10037 */   MCD::OPC_Decode, 178, 4, 174, 1, // Opcode: Bvc16
/* 10042 */   MCD::OPC_Decode, 179, 4, 186, 1, // Opcode: Bvc8
/* 10047 */   MCD::OPC_FilterValue, 9, 17, 0, 0, // Skip to: 10069
/* 10052 */   MCD::OPC_CheckField, 0, 8, 0, 5, 0, 0, // Skip to: 10064
/* 10059 */   MCD::OPC_Decode, 180, 4, 174, 1, // Opcode: Bvs16
/* 10064 */   MCD::OPC_Decode, 181, 4, 186, 1, // Opcode: Bvs8
/* 10069 */   MCD::OPC_FilterValue, 10, 17, 0, 0, // Skip to: 10091
/* 10074 */   MCD::OPC_CheckField, 0, 8, 0, 5, 0, 0, // Skip to: 10086
/* 10081 */   MCD::OPC_Decode, 176, 4, 174, 1, // Opcode: Bpl16
/* 10086 */   MCD::OPC_Decode, 177, 4, 186, 1, // Opcode: Bpl8
/* 10091 */   MCD::OPC_FilterValue, 11, 17, 0, 0, // Skip to: 10113
/* 10096 */   MCD::OPC_CheckField, 0, 8, 0, 5, 0, 0, // Skip to: 10108
/* 10103 */   MCD::OPC_Decode, 172, 4, 174, 1, // Opcode: Bmi16
/* 10108 */   MCD::OPC_Decode, 173, 4, 186, 1, // Opcode: Bmi8
/* 10113 */   MCD::OPC_FilterValue, 12, 17, 0, 0, // Skip to: 10135
/* 10118 */   MCD::OPC_CheckField, 0, 8, 0, 5, 0, 0, // Skip to: 10130
/* 10125 */   MCD::OPC_Decode, 160, 4, 174, 1, // Opcode: Bge16
/* 10130 */   MCD::OPC_Decode, 161, 4, 186, 1, // Opcode: Bge8
/* 10135 */   MCD::OPC_FilterValue, 13, 17, 0, 0, // Skip to: 10157
/* 10140 */   MCD::OPC_CheckField, 0, 8, 0, 5, 0, 0, // Skip to: 10152
/* 10147 */   MCD::OPC_Decode, 170, 4, 174, 1, // Opcode: Blt16
/* 10152 */   MCD::OPC_Decode, 171, 4, 186, 1, // Opcode: Blt8
/* 10157 */   MCD::OPC_FilterValue, 14, 17, 0, 0, // Skip to: 10179
/* 10162 */   MCD::OPC_CheckField, 0, 8, 0, 5, 0, 0, // Skip to: 10174
/* 10169 */   MCD::OPC_Decode, 162, 4, 174, 1, // Opcode: Bgt16
/* 10174 */   MCD::OPC_Decode, 163, 4, 186, 1, // Opcode: Bgt8
/* 10179 */   MCD::OPC_FilterValue, 15, 72, 16, 0, // Skip to: 14352
/* 10184 */   MCD::OPC_CheckField, 0, 8, 0, 5, 0, 0, // Skip to: 10196
/* 10191 */   MCD::OPC_Decode, 166, 4, 174, 1, // Opcode: Ble16
/* 10196 */   MCD::OPC_Decode, 167, 4, 186, 1, // Opcode: Ble8
/* 10201 */   MCD::OPC_FilterValue, 7, 12, 0, 0, // Skip to: 10218
/* 10206 */   MCD::OPC_CheckField, 8, 1, 0, 43, 16, 0, // Skip to: 14352
/* 10213 */   MCD::OPC_Decode, 228, 8, 187, 1, // Opcode: MOVQ
/* 10218 */   MCD::OPC_FilterValue, 8, 110, 2, 0, // Skip to: 10845
/* 10223 */   MCD::OPC_ExtractField, 4, 5,  // Inst{8-4} ...
/* 10226 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 10243
/* 10231 */   MCD::OPC_CheckField, 3, 1, 0, 18, 16, 0, // Skip to: 14352
/* 10238 */   MCD::OPC_Decode, 139, 9, 188, 1, // Opcode: OR8dd
/* 10243 */   MCD::OPC_FilterValue, 1, 12, 0, 0, // Skip to: 10260
/* 10248 */   MCD::OPC_CheckField, 3, 1, 0, 1, 16, 0, // Skip to: 14352
/* 10255 */   MCD::OPC_Decode, 142, 9, 189, 1, // Opcode: OR8dj
/* 10260 */   MCD::OPC_FilterValue, 2, 12, 0, 0, // Skip to: 10277
/* 10265 */   MCD::OPC_CheckField, 3, 1, 1, 240, 15, 0, // Skip to: 14352
/* 10272 */   MCD::OPC_Decode, 144, 9, 190, 1, // Opcode: OR8dp
/* 10277 */   MCD::OPC_FilterValue, 3, 72, 0, 0, // Skip to: 10354
/* 10282 */   MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 10285 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 10302
/* 10290 */   MCD::OPC_CheckField, 24, 4, 8, 215, 15, 0, // Skip to: 14352
/* 10297 */   MCD::OPC_Decode, 140, 9, 191, 1, // Opcode: OR8df
/* 10302 */   MCD::OPC_FilterValue, 1, 205, 15, 0, // Skip to: 14352
/* 10307 */   MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 10310 */   MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 10320
/* 10315 */   MCD::OPC_Decode, 145, 9, 192, 1, // Opcode: OR8dq
/* 10320 */   MCD::OPC_FilterValue, 3, 12, 0, 0, // Skip to: 10337
/* 10325 */   MCD::OPC_CheckField, 24, 4, 8, 180, 15, 0, // Skip to: 14352
/* 10332 */   MCD::OPC_Decode, 143, 9, 193, 1, // Opcode: OR8dk
/* 10337 */   MCD::OPC_FilterValue, 4, 170, 15, 0, // Skip to: 14352
/* 10342 */   MCD::OPC_CheckField, 24, 8, 0, 163, 15, 0, // Skip to: 14352
/* 10349 */   MCD::OPC_Decode, 141, 9, 194, 1, // Opcode: OR8di
/* 10354 */   MCD::OPC_FilterValue, 4, 17, 0, 0, // Skip to: 10376
/* 10359 */   MCD::OPC_CheckField, 3, 1, 0, 5, 0, 0, // Skip to: 10371
/* 10366 */   MCD::OPC_Decode, 239, 8, 195, 1, // Opcode: OR16dd
/* 10371 */   MCD::OPC_Decode, 246, 8, 196, 1, // Opcode: OR16dr
/* 10376 */   MCD::OPC_FilterValue, 5, 12, 0, 0, // Skip to: 10393
/* 10381 */   MCD::OPC_CheckField, 3, 1, 0, 124, 15, 0, // Skip to: 14352
/* 10388 */   MCD::OPC_Decode, 242, 8, 197, 1, // Opcode: OR16dj
/* 10393 */   MCD::OPC_FilterValue, 6, 12, 0, 0, // Skip to: 10410
/* 10398 */   MCD::OPC_CheckField, 3, 1, 1, 107, 15, 0, // Skip to: 14352
/* 10405 */   MCD::OPC_Decode, 244, 8, 198, 1, // Opcode: OR16dp
/* 10410 */   MCD::OPC_FilterValue, 7, 65, 0, 0, // Skip to: 10480
/* 10415 */   MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 10418 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 10435
/* 10423 */   MCD::OPC_CheckField, 24, 4, 8, 82, 15, 0, // Skip to: 14352
/* 10430 */   MCD::OPC_Decode, 240, 8, 199, 1, // Opcode: OR16df
/* 10435 */   MCD::OPC_FilterValue, 1, 72, 15, 0, // Skip to: 14352
/* 10440 */   MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 10443 */   MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 10453
/* 10448 */   MCD::OPC_Decode, 245, 8, 200, 1, // Opcode: OR16dq
/* 10453 */   MCD::OPC_FilterValue, 3, 12, 0, 0, // Skip to: 10470
/* 10458 */   MCD::OPC_CheckField, 24, 4, 8, 47, 15, 0, // Skip to: 14352
/* 10465 */   MCD::OPC_Decode, 243, 8, 201, 1, // Opcode: OR16dk
/* 10470 */   MCD::OPC_FilterValue, 4, 37, 15, 0, // Skip to: 14352
/* 10475 */   MCD::OPC_Decode, 241, 8, 200, 1, // Opcode: OR16di
/* 10480 */   MCD::OPC_FilterValue, 8, 17, 0, 0, // Skip to: 10502
/* 10485 */   MCD::OPC_CheckField, 3, 1, 0, 5, 0, 0, // Skip to: 10497
/* 10492 */   MCD::OPC_Decode, 253, 8, 202, 1, // Opcode: OR32dd
/* 10497 */   MCD::OPC_Decode, 132, 9, 203, 1, // Opcode: OR32dr
/* 10502 */   MCD::OPC_FilterValue, 9, 12, 0, 0, // Skip to: 10519
/* 10507 */   MCD::OPC_CheckField, 3, 1, 0, 254, 14, 0, // Skip to: 14352
/* 10514 */   MCD::OPC_Decode, 128, 9, 204, 1, // Opcode: OR32dj
/* 10519 */   MCD::OPC_FilterValue, 10, 12, 0, 0, // Skip to: 10536
/* 10524 */   MCD::OPC_CheckField, 3, 1, 1, 237, 14, 0, // Skip to: 14352
/* 10531 */   MCD::OPC_Decode, 130, 9, 205, 1, // Opcode: OR32dp
/* 10536 */   MCD::OPC_FilterValue, 11, 65, 0, 0, // Skip to: 10606
/* 10541 */   MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 10544 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 10561
/* 10549 */   MCD::OPC_CheckField, 24, 4, 8, 212, 14, 0, // Skip to: 14352
/* 10556 */   MCD::OPC_Decode, 254, 8, 206, 1, // Opcode: OR32df
/* 10561 */   MCD::OPC_FilterValue, 1, 202, 14, 0, // Skip to: 14352
/* 10566 */   MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 10569 */   MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 10579
/* 10574 */   MCD::OPC_Decode, 131, 9, 207, 1, // Opcode: OR32dq
/* 10579 */   MCD::OPC_FilterValue, 3, 12, 0, 0, // Skip to: 10596
/* 10584 */   MCD::OPC_CheckField, 24, 4, 8, 177, 14, 0, // Skip to: 14352
/* 10591 */   MCD::OPC_Decode, 129, 9, 208, 1, // Opcode: OR32dk
/* 10596 */   MCD::OPC_FilterValue, 4, 167, 14, 0, // Skip to: 14352
/* 10601 */   MCD::OPC_Decode, 255, 8, 209, 1, // Opcode: OR32di
/* 10606 */   MCD::OPC_FilterValue, 12, 12, 0, 0, // Skip to: 10623
/* 10611 */   MCD::OPC_CheckField, 3, 1, 0, 150, 14, 0, // Skip to: 14352
/* 10618 */   MCD::OPC_Decode, 152, 10, 210, 1, // Opcode: UDIVd32d16
/* 10623 */   MCD::OPC_FilterValue, 15, 12, 0, 0, // Skip to: 10640
/* 10628 */   MCD::OPC_CheckField, 0, 4, 12, 133, 14, 0, // Skip to: 14352
/* 10635 */   MCD::OPC_Decode, 154, 10, 207, 1, // Opcode: UDIVd32i16
/* 10640 */   MCD::OPC_FilterValue, 17, 11, 0, 0, // Skip to: 10656
/* 10645 */   MCD::OPC_CheckField, 3, 1, 0, 116, 14, 0, // Skip to: 14352
/* 10652 */   MCD::OPC_Decode, 148, 9, 40, // Opcode: OR8jd
/* 10656 */   MCD::OPC_FilterValue, 18, 11, 0, 0, // Skip to: 10672
/* 10661 */   MCD::OPC_CheckField, 3, 1, 1, 100, 14, 0, // Skip to: 14352
/* 10668 */   MCD::OPC_Decode, 150, 9, 41, // Opcode: OR8pd
/* 10672 */   MCD::OPC_FilterValue, 19, 18, 0, 0, // Skip to: 10695
/* 10677 */   MCD::OPC_CheckField, 24, 4, 8, 84, 14, 0, // Skip to: 14352
/* 10684 */   MCD::OPC_CheckField, 3, 1, 0, 77, 14, 0, // Skip to: 14352
/* 10691 */   MCD::OPC_Decode, 146, 9, 42, // Opcode: OR8fd
/* 10695 */   MCD::OPC_FilterValue, 21, 12, 0, 0, // Skip to: 10712
/* 10700 */   MCD::OPC_CheckField, 3, 1, 0, 61, 14, 0, // Skip to: 14352
/* 10707 */   MCD::OPC_Decode, 249, 8, 211, 1, // Opcode: OR16jd
/* 10712 */   MCD::OPC_FilterValue, 22, 12, 0, 0, // Skip to: 10729
/* 10717 */   MCD::OPC_CheckField, 3, 1, 1, 44, 14, 0, // Skip to: 14352
/* 10724 */   MCD::OPC_Decode, 251, 8, 212, 1, // Opcode: OR16pd
/* 10729 */   MCD::OPC_FilterValue, 23, 19, 0, 0, // Skip to: 10753
/* 10734 */   MCD::OPC_CheckField, 24, 4, 8, 27, 14, 0, // Skip to: 14352
/* 10741 */   MCD::OPC_CheckField, 3, 1, 0, 20, 14, 0, // Skip to: 14352
/* 10748 */   MCD::OPC_Decode, 247, 8, 213, 1, // Opcode: OR16fd
/* 10753 */   MCD::OPC_FilterValue, 25, 12, 0, 0, // Skip to: 10770
/* 10758 */   MCD::OPC_CheckField, 3, 1, 0, 3, 14, 0, // Skip to: 14352
/* 10765 */   MCD::OPC_Decode, 135, 9, 214, 1, // Opcode: OR32jd
/* 10770 */   MCD::OPC_FilterValue, 26, 12, 0, 0, // Skip to: 10787
/* 10775 */   MCD::OPC_CheckField, 3, 1, 1, 242, 13, 0, // Skip to: 14352
/* 10782 */   MCD::OPC_Decode, 137, 9, 215, 1, // Opcode: OR32pd
/* 10787 */   MCD::OPC_FilterValue, 27, 19, 0, 0, // Skip to: 10811
/* 10792 */   MCD::OPC_CheckField, 24, 4, 8, 225, 13, 0, // Skip to: 14352
/* 10799 */   MCD::OPC_CheckField, 3, 1, 0, 218, 13, 0, // Skip to: 14352
/* 10806 */   MCD::OPC_Decode, 133, 9, 216, 1, // Opcode: OR32fd
/* 10811 */   MCD::OPC_FilterValue, 28, 12, 0, 0, // Skip to: 10828
/* 10816 */   MCD::OPC_CheckField, 3, 1, 0, 201, 13, 0, // Skip to: 14352
/* 10823 */   MCD::OPC_Decode, 166, 9, 210, 1, // Opcode: SDIVd32d16
/* 10828 */   MCD::OPC_FilterValue, 31, 191, 13, 0, // Skip to: 14352
/* 10833 */   MCD::OPC_CheckField, 0, 4, 12, 184, 13, 0, // Skip to: 14352
/* 10840 */   MCD::OPC_Decode, 168, 9, 207, 1, // Opcode: SDIVd32i16
/* 10845 */   MCD::OPC_FilterValue, 9, 217, 2, 0, // Skip to: 11579
/* 10850 */   MCD::OPC_ExtractField, 4, 5,  // Inst{8-4} ...
/* 10853 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 10870
/* 10858 */   MCD::OPC_CheckField, 3, 1, 0, 159, 13, 0, // Skip to: 14352
/* 10865 */   MCD::OPC_Decode, 134, 10, 188, 1, // Opcode: SUB8dd
/* 10870 */   MCD::OPC_FilterValue, 1, 12, 0, 0, // Skip to: 10887
/* 10875 */   MCD::OPC_CheckField, 3, 1, 0, 142, 13, 0, // Skip to: 14352
/* 10882 */   MCD::OPC_Decode, 137, 10, 189, 1, // Opcode: SUB8dj
/* 10887 */   MCD::OPC_FilterValue, 2, 12, 0, 0, // Skip to: 10904
/* 10892 */   MCD::OPC_CheckField, 3, 1, 1, 125, 13, 0, // Skip to: 14352
/* 10899 */   MCD::OPC_Decode, 139, 10, 190, 1, // Opcode: SUB8dp
/* 10904 */   MCD::OPC_FilterValue, 3, 72, 0, 0, // Skip to: 10981
/* 10909 */   MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 10912 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 10929
/* 10917 */   MCD::OPC_CheckField, 24, 4, 8, 100, 13, 0, // Skip to: 14352
/* 10924 */   MCD::OPC_Decode, 135, 10, 191, 1, // Opcode: SUB8df
/* 10929 */   MCD::OPC_FilterValue, 1, 90, 13, 0, // Skip to: 14352
/* 10934 */   MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 10937 */   MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 10947
/* 10942 */   MCD::OPC_Decode, 140, 10, 192, 1, // Opcode: SUB8dq
/* 10947 */   MCD::OPC_FilterValue, 3, 12, 0, 0, // Skip to: 10964
/* 10952 */   MCD::OPC_CheckField, 24, 4, 8, 65, 13, 0, // Skip to: 14352
/* 10959 */   MCD::OPC_Decode, 138, 10, 193, 1, // Opcode: SUB8dk
/* 10964 */   MCD::OPC_FilterValue, 4, 55, 13, 0, // Skip to: 14352
/* 10969 */   MCD::OPC_CheckField, 24, 8, 0, 48, 13, 0, // Skip to: 14352
/* 10976 */   MCD::OPC_Decode, 136, 10, 194, 1, // Opcode: SUB8di
/* 10981 */   MCD::OPC_FilterValue, 4, 17, 0, 0, // Skip to: 11003
/* 10986 */   MCD::OPC_CheckField, 3, 1, 0, 5, 0, 0, // Skip to: 10998
/* 10993 */   MCD::OPC_Decode, 226, 9, 195, 1, // Opcode: SUB16dd
/* 10998 */   MCD::OPC_Decode, 233, 9, 196, 1, // Opcode: SUB16dr
/* 11003 */   MCD::OPC_FilterValue, 5, 12, 0, 0, // Skip to: 11020
/* 11008 */   MCD::OPC_CheckField, 3, 1, 0, 9, 13, 0, // Skip to: 14352
/* 11015 */   MCD::OPC_Decode, 229, 9, 197, 1, // Opcode: SUB16dj
/* 11020 */   MCD::OPC_FilterValue, 6, 12, 0, 0, // Skip to: 11037
/* 11025 */   MCD::OPC_CheckField, 3, 1, 1, 248, 12, 0, // Skip to: 14352
/* 11032 */   MCD::OPC_Decode, 231, 9, 198, 1, // Opcode: SUB16dp
/* 11037 */   MCD::OPC_FilterValue, 7, 65, 0, 0, // Skip to: 11107
/* 11042 */   MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 11045 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 11062
/* 11050 */   MCD::OPC_CheckField, 24, 4, 8, 223, 12, 0, // Skip to: 14352
/* 11057 */   MCD::OPC_Decode, 227, 9, 199, 1, // Opcode: SUB16df
/* 11062 */   MCD::OPC_FilterValue, 1, 213, 12, 0, // Skip to: 14352
/* 11067 */   MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 11070 */   MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 11080
/* 11075 */   MCD::OPC_Decode, 232, 9, 200, 1, // Opcode: SUB16dq
/* 11080 */   MCD::OPC_FilterValue, 3, 12, 0, 0, // Skip to: 11097
/* 11085 */   MCD::OPC_CheckField, 24, 4, 8, 188, 12, 0, // Skip to: 14352
/* 11092 */   MCD::OPC_Decode, 230, 9, 201, 1, // Opcode: SUB16dk
/* 11097 */   MCD::OPC_FilterValue, 4, 178, 12, 0, // Skip to: 14352
/* 11102 */   MCD::OPC_Decode, 228, 9, 200, 1, // Opcode: SUB16di
/* 11107 */   MCD::OPC_FilterValue, 8, 17, 0, 0, // Skip to: 11129
/* 11112 */   MCD::OPC_CheckField, 3, 1, 0, 5, 0, 0, // Skip to: 11124
/* 11119 */   MCD::OPC_Decode, 248, 9, 202, 1, // Opcode: SUB32dd
/* 11124 */   MCD::OPC_Decode, 255, 9, 203, 1, // Opcode: SUB32dr
/* 11129 */   MCD::OPC_FilterValue, 9, 12, 0, 0, // Skip to: 11146
/* 11134 */   MCD::OPC_CheckField, 3, 1, 0, 139, 12, 0, // Skip to: 14352
/* 11141 */   MCD::OPC_Decode, 251, 9, 204, 1, // Opcode: SUB32dj
/* 11146 */   MCD::OPC_FilterValue, 10, 12, 0, 0, // Skip to: 11163
/* 11151 */   MCD::OPC_CheckField, 3, 1, 1, 122, 12, 0, // Skip to: 14352
/* 11158 */   MCD::OPC_Decode, 253, 9, 205, 1, // Opcode: SUB32dp
/* 11163 */   MCD::OPC_FilterValue, 11, 65, 0, 0, // Skip to: 11233
/* 11168 */   MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 11171 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 11188
/* 11176 */   MCD::OPC_CheckField, 24, 4, 8, 97, 12, 0, // Skip to: 14352
/* 11183 */   MCD::OPC_Decode, 249, 9, 206, 1, // Opcode: SUB32df
/* 11188 */   MCD::OPC_FilterValue, 1, 87, 12, 0, // Skip to: 14352
/* 11193 */   MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 11196 */   MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 11206
/* 11201 */   MCD::OPC_Decode, 254, 9, 207, 1, // Opcode: SUB32dq
/* 11206 */   MCD::OPC_FilterValue, 3, 12, 0, 0, // Skip to: 11223
/* 11211 */   MCD::OPC_CheckField, 24, 4, 8, 62, 12, 0, // Skip to: 14352
/* 11218 */   MCD::OPC_Decode, 252, 9, 208, 1, // Opcode: SUB32dk
/* 11223 */   MCD::OPC_FilterValue, 4, 52, 12, 0, // Skip to: 14352
/* 11228 */   MCD::OPC_Decode, 250, 9, 209, 1, // Opcode: SUB32di
/* 11233 */   MCD::OPC_FilterValue, 16, 12, 0, 0, // Skip to: 11250
/* 11238 */   MCD::OPC_CheckField, 3, 1, 0, 35, 12, 0, // Skip to: 14352
/* 11245 */   MCD::OPC_Decode, 149, 10, 188, 1, // Opcode: SUBX8dd
/* 11250 */   MCD::OPC_FilterValue, 17, 11, 0, 0, // Skip to: 11266
/* 11255 */   MCD::OPC_CheckField, 3, 1, 0, 18, 12, 0, // Skip to: 14352
/* 11262 */   MCD::OPC_Decode, 143, 10, 40, // Opcode: SUB8jd
/* 11266 */   MCD::OPC_FilterValue, 18, 11, 0, 0, // Skip to: 11282
/* 11271 */   MCD::OPC_CheckField, 3, 1, 1, 2, 12, 0, // Skip to: 14352
/* 11278 */   MCD::OPC_Decode, 145, 10, 41, // Opcode: SUB8pd
/* 11282 */   MCD::OPC_FilterValue, 19, 18, 0, 0, // Skip to: 11305
/* 11287 */   MCD::OPC_CheckField, 24, 4, 8, 242, 11, 0, // Skip to: 14352
/* 11294 */   MCD::OPC_CheckField, 3, 1, 0, 235, 11, 0, // Skip to: 14352
/* 11301 */   MCD::OPC_Decode, 141, 10, 42, // Opcode: SUB8fd
/* 11305 */   MCD::OPC_FilterValue, 20, 12, 0, 0, // Skip to: 11322
/* 11310 */   MCD::OPC_CheckField, 3, 1, 0, 219, 11, 0, // Skip to: 14352
/* 11317 */   MCD::OPC_Decode, 147, 10, 195, 1, // Opcode: SUBX16dd
/* 11322 */   MCD::OPC_FilterValue, 21, 12, 0, 0, // Skip to: 11339
/* 11327 */   MCD::OPC_CheckField, 3, 1, 0, 202, 11, 0, // Skip to: 14352
/* 11334 */   MCD::OPC_Decode, 236, 9, 211, 1, // Opcode: SUB16jd
/* 11339 */   MCD::OPC_FilterValue, 22, 12, 0, 0, // Skip to: 11356
/* 11344 */   MCD::OPC_CheckField, 3, 1, 1, 185, 11, 0, // Skip to: 14352
/* 11351 */   MCD::OPC_Decode, 238, 9, 212, 1, // Opcode: SUB16pd
/* 11356 */   MCD::OPC_FilterValue, 23, 19, 0, 0, // Skip to: 11380
/* 11361 */   MCD::OPC_CheckField, 24, 4, 8, 168, 11, 0, // Skip to: 14352
/* 11368 */   MCD::OPC_CheckField, 3, 1, 0, 161, 11, 0, // Skip to: 14352
/* 11375 */   MCD::OPC_Decode, 234, 9, 213, 1, // Opcode: SUB16fd
/* 11380 */   MCD::OPC_FilterValue, 24, 12, 0, 0, // Skip to: 11397
/* 11385 */   MCD::OPC_CheckField, 3, 1, 0, 144, 11, 0, // Skip to: 14352
/* 11392 */   MCD::OPC_Decode, 148, 10, 202, 1, // Opcode: SUBX32dd
/* 11397 */   MCD::OPC_FilterValue, 25, 12, 0, 0, // Skip to: 11414
/* 11402 */   MCD::OPC_CheckField, 3, 1, 0, 127, 11, 0, // Skip to: 14352
/* 11409 */   MCD::OPC_Decode, 130, 10, 214, 1, // Opcode: SUB32jd
/* 11414 */   MCD::OPC_FilterValue, 26, 12, 0, 0, // Skip to: 11431
/* 11419 */   MCD::OPC_CheckField, 3, 1, 1, 110, 11, 0, // Skip to: 14352
/* 11426 */   MCD::OPC_Decode, 132, 10, 215, 1, // Opcode: SUB32pd
/* 11431 */   MCD::OPC_FilterValue, 27, 19, 0, 0, // Skip to: 11455
/* 11436 */   MCD::OPC_CheckField, 24, 4, 8, 93, 11, 0, // Skip to: 14352
/* 11443 */   MCD::OPC_CheckField, 3, 1, 0, 86, 11, 0, // Skip to: 14352
/* 11450 */   MCD::OPC_Decode, 128, 10, 216, 1, // Opcode: SUB32fd
/* 11455 */   MCD::OPC_FilterValue, 28, 5, 0, 0, // Skip to: 11465
/* 11460 */   MCD::OPC_Decode, 247, 9, 217, 1, // Opcode: SUB32ar
/* 11465 */   MCD::OPC_FilterValue, 29, 12, 0, 0, // Skip to: 11482
/* 11470 */   MCD::OPC_CheckField, 3, 1, 0, 59, 11, 0, // Skip to: 14352
/* 11477 */   MCD::OPC_Decode, 243, 9, 218, 1, // Opcode: SUB32aj
/* 11482 */   MCD::OPC_FilterValue, 30, 12, 0, 0, // Skip to: 11499
/* 11487 */   MCD::OPC_CheckField, 3, 1, 1, 42, 11, 0, // Skip to: 14352
/* 11494 */   MCD::OPC_Decode, 245, 9, 219, 1, // Opcode: SUB32ap
/* 11499 */   MCD::OPC_FilterValue, 31, 32, 11, 0, // Skip to: 14352
/* 11504 */   MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 11507 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 11524
/* 11512 */   MCD::OPC_CheckField, 24, 4, 8, 17, 11, 0, // Skip to: 14352
/* 11519 */   MCD::OPC_Decode, 241, 9, 220, 1, // Opcode: SUB32af
/* 11524 */   MCD::OPC_FilterValue, 1, 7, 11, 0, // Skip to: 14352
/* 11529 */   MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 11532 */   MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 11542
/* 11537 */   MCD::OPC_Decode, 240, 9, 221, 1, // Opcode: SUB32ab
/* 11542 */   MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 11552
/* 11547 */   MCD::OPC_Decode, 246, 9, 222, 1, // Opcode: SUB32aq
/* 11552 */   MCD::OPC_FilterValue, 3, 12, 0, 0, // Skip to: 11569
/* 11557 */   MCD::OPC_CheckField, 24, 4, 8, 228, 10, 0, // Skip to: 14352
/* 11564 */   MCD::OPC_Decode, 244, 9, 223, 1, // Opcode: SUB32ak
/* 11569 */   MCD::OPC_FilterValue, 4, 218, 10, 0, // Skip to: 14352
/* 11574 */   MCD::OPC_Decode, 242, 9, 221, 1, // Opcode: SUB32ai
/* 11579 */   MCD::OPC_FilterValue, 11, 100, 1, 0, // Skip to: 11940
/* 11584 */   MCD::OPC_ExtractField, 4, 5,  // Inst{8-4} ...
/* 11587 */   MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 11597
/* 11592 */   MCD::OPC_Decode, 216, 4, 224, 1, // Opcode: CMP8dd
/* 11597 */   MCD::OPC_FilterValue, 1, 11, 0, 0, // Skip to: 11613
/* 11602 */   MCD::OPC_CheckField, 3, 1, 0, 183, 10, 0, // Skip to: 14352
/* 11609 */   MCD::OPC_Decode, 219, 4, 46, // Opcode: CMP8dj
/* 11613 */   MCD::OPC_FilterValue, 2, 11, 0, 0, // Skip to: 11629
/* 11618 */   MCD::OPC_CheckField, 3, 1, 1, 167, 10, 0, // Skip to: 14352
/* 11625 */   MCD::OPC_Decode, 221, 4, 47, // Opcode: CMP8dp
/* 11629 */   MCD::OPC_FilterValue, 3, 52, 0, 0, // Skip to: 11686
/* 11634 */   MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 11637 */   MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 11653
/* 11642 */   MCD::OPC_CheckField, 24, 4, 8, 143, 10, 0, // Skip to: 14352
/* 11649 */   MCD::OPC_Decode, 217, 4, 48, // Opcode: CMP8df
/* 11653 */   MCD::OPC_FilterValue, 1, 134, 10, 0, // Skip to: 14352
/* 11658 */   MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 11661 */   MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 11670
/* 11666 */   MCD::OPC_Decode, 222, 4, 50, // Opcode: CMP8dq
/* 11670 */   MCD::OPC_FilterValue, 3, 117, 10, 0, // Skip to: 14352
/* 11675 */   MCD::OPC_CheckField, 24, 4, 8, 110, 10, 0, // Skip to: 14352
/* 11682 */   MCD::OPC_Decode, 220, 4, 51, // Opcode: CMP8dk
/* 11686 */   MCD::OPC_FilterValue, 4, 5, 0, 0, // Skip to: 11696
/* 11691 */   MCD::OPC_Decode, 196, 4, 225, 1, // Opcode: CMP16dr
/* 11696 */   MCD::OPC_FilterValue, 5, 12, 0, 0, // Skip to: 11713
/* 11701 */   MCD::OPC_CheckField, 3, 1, 0, 84, 10, 0, // Skip to: 14352
/* 11708 */   MCD::OPC_Decode, 192, 4, 144, 1, // Opcode: CMP16dj
/* 11713 */   MCD::OPC_FilterValue, 6, 12, 0, 0, // Skip to: 11730
/* 11718 */   MCD::OPC_CheckField, 3, 1, 1, 67, 10, 0, // Skip to: 14352
/* 11725 */   MCD::OPC_Decode, 194, 4, 147, 1, // Opcode: CMP16dp
/* 11730 */   MCD::OPC_FilterValue, 7, 55, 0, 0, // Skip to: 11790
/* 11735 */   MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 11738 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 11755
/* 11743 */   MCD::OPC_CheckField, 24, 4, 8, 42, 10, 0, // Skip to: 14352
/* 11750 */   MCD::OPC_Decode, 190, 4, 150, 1, // Opcode: CMP16df
/* 11755 */   MCD::OPC_FilterValue, 1, 32, 10, 0, // Skip to: 14352
/* 11760 */   MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 11763 */   MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 11773
/* 11768 */   MCD::OPC_Decode, 195, 4, 156, 1, // Opcode: CMP16dq
/* 11773 */   MCD::OPC_FilterValue, 3, 14, 10, 0, // Skip to: 14352
/* 11778 */   MCD::OPC_CheckField, 24, 4, 8, 7, 10, 0, // Skip to: 14352
/* 11785 */   MCD::OPC_Decode, 193, 4, 159, 1, // Opcode: CMP16dk
/* 11790 */   MCD::OPC_FilterValue, 8, 5, 0, 0, // Skip to: 11800
/* 11795 */   MCD::OPC_Decode, 209, 4, 226, 1, // Opcode: CMP32dr
/* 11800 */   MCD::OPC_FilterValue, 9, 11, 0, 0, // Skip to: 11816
/* 11805 */   MCD::OPC_CheckField, 3, 1, 0, 236, 9, 0, // Skip to: 14352
/* 11812 */   MCD::OPC_Decode, 205, 4, 111, // Opcode: CMP32dj
/* 11816 */   MCD::OPC_FilterValue, 10, 11, 0, 0, // Skip to: 11832
/* 11821 */   MCD::OPC_CheckField, 3, 1, 1, 220, 9, 0, // Skip to: 14352
/* 11828 */   MCD::OPC_Decode, 207, 4, 112, // Opcode: CMP32dp
/* 11832 */   MCD::OPC_FilterValue, 11, 52, 0, 0, // Skip to: 11889
/* 11837 */   MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 11840 */   MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 11856
/* 11845 */   MCD::OPC_CheckField, 24, 4, 8, 196, 9, 0, // Skip to: 14352
/* 11852 */   MCD::OPC_Decode, 203, 4, 114, // Opcode: CMP32df
/* 11856 */   MCD::OPC_FilterValue, 1, 187, 9, 0, // Skip to: 14352
/* 11861 */   MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 11864 */   MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 11873
/* 11869 */   MCD::OPC_Decode, 208, 4, 118, // Opcode: CMP32dq
/* 11873 */   MCD::OPC_FilterValue, 3, 170, 9, 0, // Skip to: 14352
/* 11878 */   MCD::OPC_CheckField, 24, 4, 8, 163, 9, 0, // Skip to: 14352
/* 11885 */   MCD::OPC_Decode, 206, 4, 120, // Opcode: CMP32dk
/* 11889 */   MCD::OPC_FilterValue, 16, 12, 0, 0, // Skip to: 11906
/* 11894 */   MCD::OPC_CheckField, 3, 1, 0, 147, 9, 0, // Skip to: 14352
/* 11901 */   MCD::OPC_Decode, 163, 10, 227, 1, // Opcode: XOR8dd
/* 11906 */   MCD::OPC_FilterValue, 20, 12, 0, 0, // Skip to: 11923
/* 11911 */   MCD::OPC_CheckField, 3, 1, 0, 130, 9, 0, // Skip to: 14352
/* 11918 */   MCD::OPC_Decode, 159, 10, 228, 1, // Opcode: XOR16dd
/* 11923 */   MCD::OPC_FilterValue, 24, 120, 9, 0, // Skip to: 14352
/* 11928 */   MCD::OPC_CheckField, 3, 1, 0, 113, 9, 0, // Skip to: 14352
/* 11935 */   MCD::OPC_Decode, 161, 10, 229, 1, // Opcode: XOR32dd
/* 11940 */   MCD::OPC_FilterValue, 12, 110, 2, 0, // Skip to: 12567
/* 11945 */   MCD::OPC_ExtractField, 4, 5,  // Inst{8-4} ...
/* 11948 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 11965
/* 11953 */   MCD::OPC_CheckField, 3, 1, 0, 88, 9, 0, // Skip to: 14352
/* 11960 */   MCD::OPC_Decode, 205, 3, 188, 1, // Opcode: AND8dd
/* 11965 */   MCD::OPC_FilterValue, 1, 12, 0, 0, // Skip to: 11982
/* 11970 */   MCD::OPC_CheckField, 3, 1, 0, 71, 9, 0, // Skip to: 14352
/* 11977 */   MCD::OPC_Decode, 208, 3, 189, 1, // Opcode: AND8dj
/* 11982 */   MCD::OPC_FilterValue, 2, 12, 0, 0, // Skip to: 11999
/* 11987 */   MCD::OPC_CheckField, 3, 1, 1, 54, 9, 0, // Skip to: 14352
/* 11994 */   MCD::OPC_Decode, 210, 3, 190, 1, // Opcode: AND8dp
/* 11999 */   MCD::OPC_FilterValue, 3, 72, 0, 0, // Skip to: 12076
/* 12004 */   MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 12007 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 12024
/* 12012 */   MCD::OPC_CheckField, 24, 4, 8, 29, 9, 0, // Skip to: 14352
/* 12019 */   MCD::OPC_Decode, 206, 3, 191, 1, // Opcode: AND8df
/* 12024 */   MCD::OPC_FilterValue, 1, 19, 9, 0, // Skip to: 14352
/* 12029 */   MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 12032 */   MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 12042
/* 12037 */   MCD::OPC_Decode, 211, 3, 192, 1, // Opcode: AND8dq
/* 12042 */   MCD::OPC_FilterValue, 3, 12, 0, 0, // Skip to: 12059
/* 12047 */   MCD::OPC_CheckField, 24, 4, 8, 250, 8, 0, // Skip to: 14352
/* 12054 */   MCD::OPC_Decode, 209, 3, 193, 1, // Opcode: AND8dk
/* 12059 */   MCD::OPC_FilterValue, 4, 240, 8, 0, // Skip to: 14352
/* 12064 */   MCD::OPC_CheckField, 24, 8, 0, 233, 8, 0, // Skip to: 14352
/* 12071 */   MCD::OPC_Decode, 207, 3, 194, 1, // Opcode: AND8di
/* 12076 */   MCD::OPC_FilterValue, 4, 17, 0, 0, // Skip to: 12098
/* 12081 */   MCD::OPC_CheckField, 3, 1, 0, 5, 0, 0, // Skip to: 12093
/* 12088 */   MCD::OPC_Decode, 177, 3, 195, 1, // Opcode: AND16dd
/* 12093 */   MCD::OPC_Decode, 184, 3, 196, 1, // Opcode: AND16dr
/* 12098 */   MCD::OPC_FilterValue, 5, 12, 0, 0, // Skip to: 12115
/* 12103 */   MCD::OPC_CheckField, 3, 1, 0, 194, 8, 0, // Skip to: 14352
/* 12110 */   MCD::OPC_Decode, 180, 3, 197, 1, // Opcode: AND16dj
/* 12115 */   MCD::OPC_FilterValue, 6, 12, 0, 0, // Skip to: 12132
/* 12120 */   MCD::OPC_CheckField, 3, 1, 1, 177, 8, 0, // Skip to: 14352
/* 12127 */   MCD::OPC_Decode, 182, 3, 198, 1, // Opcode: AND16dp
/* 12132 */   MCD::OPC_FilterValue, 7, 65, 0, 0, // Skip to: 12202
/* 12137 */   MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 12140 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 12157
/* 12145 */   MCD::OPC_CheckField, 24, 4, 8, 152, 8, 0, // Skip to: 14352
/* 12152 */   MCD::OPC_Decode, 178, 3, 199, 1, // Opcode: AND16df
/* 12157 */   MCD::OPC_FilterValue, 1, 142, 8, 0, // Skip to: 14352
/* 12162 */   MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 12165 */   MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 12175
/* 12170 */   MCD::OPC_Decode, 183, 3, 200, 1, // Opcode: AND16dq
/* 12175 */   MCD::OPC_FilterValue, 3, 12, 0, 0, // Skip to: 12192
/* 12180 */   MCD::OPC_CheckField, 24, 4, 8, 117, 8, 0, // Skip to: 14352
/* 12187 */   MCD::OPC_Decode, 181, 3, 201, 1, // Opcode: AND16dk
/* 12192 */   MCD::OPC_FilterValue, 4, 107, 8, 0, // Skip to: 14352
/* 12197 */   MCD::OPC_Decode, 179, 3, 200, 1, // Opcode: AND16di
/* 12202 */   MCD::OPC_FilterValue, 8, 17, 0, 0, // Skip to: 12224
/* 12207 */   MCD::OPC_CheckField, 3, 1, 0, 5, 0, 0, // Skip to: 12219
/* 12214 */   MCD::OPC_Decode, 191, 3, 202, 1, // Opcode: AND32dd
/* 12219 */   MCD::OPC_Decode, 198, 3, 203, 1, // Opcode: AND32dr
/* 12224 */   MCD::OPC_FilterValue, 9, 12, 0, 0, // Skip to: 12241
/* 12229 */   MCD::OPC_CheckField, 3, 1, 0, 68, 8, 0, // Skip to: 14352
/* 12236 */   MCD::OPC_Decode, 194, 3, 204, 1, // Opcode: AND32dj
/* 12241 */   MCD::OPC_FilterValue, 10, 12, 0, 0, // Skip to: 12258
/* 12246 */   MCD::OPC_CheckField, 3, 1, 1, 51, 8, 0, // Skip to: 14352
/* 12253 */   MCD::OPC_Decode, 196, 3, 205, 1, // Opcode: AND32dp
/* 12258 */   MCD::OPC_FilterValue, 11, 65, 0, 0, // Skip to: 12328
/* 12263 */   MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 12266 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 12283
/* 12271 */   MCD::OPC_CheckField, 24, 4, 8, 26, 8, 0, // Skip to: 14352
/* 12278 */   MCD::OPC_Decode, 192, 3, 206, 1, // Opcode: AND32df
/* 12283 */   MCD::OPC_FilterValue, 1, 16, 8, 0, // Skip to: 14352
/* 12288 */   MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 12291 */   MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 12301
/* 12296 */   MCD::OPC_Decode, 197, 3, 207, 1, // Opcode: AND32dq
/* 12301 */   MCD::OPC_FilterValue, 3, 12, 0, 0, // Skip to: 12318
/* 12306 */   MCD::OPC_CheckField, 24, 4, 8, 247, 7, 0, // Skip to: 14352
/* 12313 */   MCD::OPC_Decode, 195, 3, 208, 1, // Opcode: AND32dk
/* 12318 */   MCD::OPC_FilterValue, 4, 237, 7, 0, // Skip to: 14352
/* 12323 */   MCD::OPC_Decode, 193, 3, 209, 1, // Opcode: AND32di
/* 12328 */   MCD::OPC_FilterValue, 12, 12, 0, 0, // Skip to: 12345
/* 12333 */   MCD::OPC_CheckField, 3, 1, 0, 220, 7, 0, // Skip to: 14352
/* 12340 */   MCD::OPC_Decode, 155, 10, 210, 1, // Opcode: UMULd32d16
/* 12345 */   MCD::OPC_FilterValue, 15, 12, 0, 0, // Skip to: 12362
/* 12350 */   MCD::OPC_CheckField, 0, 4, 12, 203, 7, 0, // Skip to: 14352
/* 12357 */   MCD::OPC_Decode, 157, 10, 207, 1, // Opcode: UMULd32i16
/* 12362 */   MCD::OPC_FilterValue, 17, 11, 0, 0, // Skip to: 12378
/* 12367 */   MCD::OPC_CheckField, 3, 1, 0, 186, 7, 0, // Skip to: 14352
/* 12374 */   MCD::OPC_Decode, 214, 3, 40, // Opcode: AND8jd
/* 12378 */   MCD::OPC_FilterValue, 18, 11, 0, 0, // Skip to: 12394
/* 12383 */   MCD::OPC_CheckField, 3, 1, 1, 170, 7, 0, // Skip to: 14352
/* 12390 */   MCD::OPC_Decode, 216, 3, 41, // Opcode: AND8pd
/* 12394 */   MCD::OPC_FilterValue, 19, 18, 0, 0, // Skip to: 12417
/* 12399 */   MCD::OPC_CheckField, 24, 4, 8, 154, 7, 0, // Skip to: 14352
/* 12406 */   MCD::OPC_CheckField, 3, 1, 0, 147, 7, 0, // Skip to: 14352
/* 12413 */   MCD::OPC_Decode, 212, 3, 42, // Opcode: AND8fd
/* 12417 */   MCD::OPC_FilterValue, 21, 12, 0, 0, // Skip to: 12434
/* 12422 */   MCD::OPC_CheckField, 3, 1, 0, 131, 7, 0, // Skip to: 14352
/* 12429 */   MCD::OPC_Decode, 187, 3, 211, 1, // Opcode: AND16jd
/* 12434 */   MCD::OPC_FilterValue, 22, 12, 0, 0, // Skip to: 12451
/* 12439 */   MCD::OPC_CheckField, 3, 1, 1, 114, 7, 0, // Skip to: 14352
/* 12446 */   MCD::OPC_Decode, 189, 3, 212, 1, // Opcode: AND16pd
/* 12451 */   MCD::OPC_FilterValue, 23, 19, 0, 0, // Skip to: 12475
/* 12456 */   MCD::OPC_CheckField, 24, 4, 8, 97, 7, 0, // Skip to: 14352
/* 12463 */   MCD::OPC_CheckField, 3, 1, 0, 90, 7, 0, // Skip to: 14352
/* 12470 */   MCD::OPC_Decode, 185, 3, 213, 1, // Opcode: AND16fd
/* 12475 */   MCD::OPC_FilterValue, 25, 12, 0, 0, // Skip to: 12492
/* 12480 */   MCD::OPC_CheckField, 3, 1, 0, 73, 7, 0, // Skip to: 14352
/* 12487 */   MCD::OPC_Decode, 201, 3, 214, 1, // Opcode: AND32jd
/* 12492 */   MCD::OPC_FilterValue, 26, 12, 0, 0, // Skip to: 12509
/* 12497 */   MCD::OPC_CheckField, 3, 1, 1, 56, 7, 0, // Skip to: 14352
/* 12504 */   MCD::OPC_Decode, 203, 3, 215, 1, // Opcode: AND32pd
/* 12509 */   MCD::OPC_FilterValue, 27, 19, 0, 0, // Skip to: 12533
/* 12514 */   MCD::OPC_CheckField, 24, 4, 8, 39, 7, 0, // Skip to: 14352
/* 12521 */   MCD::OPC_CheckField, 3, 1, 0, 32, 7, 0, // Skip to: 14352
/* 12528 */   MCD::OPC_Decode, 199, 3, 216, 1, // Opcode: AND32fd
/* 12533 */   MCD::OPC_FilterValue, 28, 12, 0, 0, // Skip to: 12550
/* 12538 */   MCD::OPC_CheckField, 3, 1, 0, 15, 7, 0, // Skip to: 14352
/* 12545 */   MCD::OPC_Decode, 223, 9, 210, 1, // Opcode: SMULd32d16
/* 12550 */   MCD::OPC_FilterValue, 31, 5, 7, 0, // Skip to: 14352
/* 12555 */   MCD::OPC_CheckField, 0, 4, 12, 254, 6, 0, // Skip to: 14352
/* 12562 */   MCD::OPC_Decode, 225, 9, 207, 1, // Opcode: SMULd32i16
/* 12567 */   MCD::OPC_FilterValue, 13, 217, 2, 0, // Skip to: 13301
/* 12572 */   MCD::OPC_ExtractField, 4, 5,  // Inst{8-4} ...
/* 12575 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 12592
/* 12580 */   MCD::OPC_CheckField, 3, 1, 0, 229, 6, 0, // Skip to: 14352
/* 12587 */   MCD::OPC_Decode, 161, 3, 188, 1, // Opcode: ADD8dd
/* 12592 */   MCD::OPC_FilterValue, 1, 12, 0, 0, // Skip to: 12609
/* 12597 */   MCD::OPC_CheckField, 3, 1, 0, 212, 6, 0, // Skip to: 14352
/* 12604 */   MCD::OPC_Decode, 164, 3, 189, 1, // Opcode: ADD8dj
/* 12609 */   MCD::OPC_FilterValue, 2, 12, 0, 0, // Skip to: 12626
/* 12614 */   MCD::OPC_CheckField, 3, 1, 1, 195, 6, 0, // Skip to: 14352
/* 12621 */   MCD::OPC_Decode, 166, 3, 190, 1, // Opcode: ADD8dp
/* 12626 */   MCD::OPC_FilterValue, 3, 72, 0, 0, // Skip to: 12703
/* 12631 */   MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 12634 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 12651
/* 12639 */   MCD::OPC_CheckField, 24, 4, 8, 170, 6, 0, // Skip to: 14352
/* 12646 */   MCD::OPC_Decode, 162, 3, 191, 1, // Opcode: ADD8df
/* 12651 */   MCD::OPC_FilterValue, 1, 160, 6, 0, // Skip to: 14352
/* 12656 */   MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 12659 */   MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 12669
/* 12664 */   MCD::OPC_Decode, 167, 3, 192, 1, // Opcode: ADD8dq
/* 12669 */   MCD::OPC_FilterValue, 3, 12, 0, 0, // Skip to: 12686
/* 12674 */   MCD::OPC_CheckField, 24, 4, 8, 135, 6, 0, // Skip to: 14352
/* 12681 */   MCD::OPC_Decode, 165, 3, 193, 1, // Opcode: ADD8dk
/* 12686 */   MCD::OPC_FilterValue, 4, 125, 6, 0, // Skip to: 14352
/* 12691 */   MCD::OPC_CheckField, 24, 8, 0, 118, 6, 0, // Skip to: 14352
/* 12698 */   MCD::OPC_Decode, 163, 3, 194, 1, // Opcode: ADD8di
/* 12703 */   MCD::OPC_FilterValue, 4, 17, 0, 0, // Skip to: 12725
/* 12708 */   MCD::OPC_CheckField, 3, 1, 0, 5, 0, 0, // Skip to: 12720
/* 12715 */   MCD::OPC_Decode, 253, 2, 195, 1, // Opcode: ADD16dd
/* 12720 */   MCD::OPC_Decode, 132, 3, 196, 1, // Opcode: ADD16dr
/* 12725 */   MCD::OPC_FilterValue, 5, 12, 0, 0, // Skip to: 12742
/* 12730 */   MCD::OPC_CheckField, 3, 1, 0, 79, 6, 0, // Skip to: 14352
/* 12737 */   MCD::OPC_Decode, 128, 3, 197, 1, // Opcode: ADD16dj
/* 12742 */   MCD::OPC_FilterValue, 6, 12, 0, 0, // Skip to: 12759
/* 12747 */   MCD::OPC_CheckField, 3, 1, 1, 62, 6, 0, // Skip to: 14352
/* 12754 */   MCD::OPC_Decode, 130, 3, 198, 1, // Opcode: ADD16dp
/* 12759 */   MCD::OPC_FilterValue, 7, 65, 0, 0, // Skip to: 12829
/* 12764 */   MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 12767 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 12784
/* 12772 */   MCD::OPC_CheckField, 24, 4, 8, 37, 6, 0, // Skip to: 14352
/* 12779 */   MCD::OPC_Decode, 254, 2, 199, 1, // Opcode: ADD16df
/* 12784 */   MCD::OPC_FilterValue, 1, 27, 6, 0, // Skip to: 14352
/* 12789 */   MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 12792 */   MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 12802
/* 12797 */   MCD::OPC_Decode, 131, 3, 200, 1, // Opcode: ADD16dq
/* 12802 */   MCD::OPC_FilterValue, 3, 12, 0, 0, // Skip to: 12819
/* 12807 */   MCD::OPC_CheckField, 24, 4, 8, 2, 6, 0, // Skip to: 14352
/* 12814 */   MCD::OPC_Decode, 129, 3, 201, 1, // Opcode: ADD16dk
/* 12819 */   MCD::OPC_FilterValue, 4, 248, 5, 0, // Skip to: 14352
/* 12824 */   MCD::OPC_Decode, 255, 2, 200, 1, // Opcode: ADD16di
/* 12829 */   MCD::OPC_FilterValue, 8, 17, 0, 0, // Skip to: 12851
/* 12834 */   MCD::OPC_CheckField, 3, 1, 0, 5, 0, 0, // Skip to: 12846
/* 12841 */   MCD::OPC_Decode, 147, 3, 202, 1, // Opcode: ADD32dd
/* 12846 */   MCD::OPC_Decode, 154, 3, 203, 1, // Opcode: ADD32dr
/* 12851 */   MCD::OPC_FilterValue, 9, 12, 0, 0, // Skip to: 12868
/* 12856 */   MCD::OPC_CheckField, 3, 1, 0, 209, 5, 0, // Skip to: 14352
/* 12863 */   MCD::OPC_Decode, 150, 3, 204, 1, // Opcode: ADD32dj
/* 12868 */   MCD::OPC_FilterValue, 10, 12, 0, 0, // Skip to: 12885
/* 12873 */   MCD::OPC_CheckField, 3, 1, 1, 192, 5, 0, // Skip to: 14352
/* 12880 */   MCD::OPC_Decode, 152, 3, 205, 1, // Opcode: ADD32dp
/* 12885 */   MCD::OPC_FilterValue, 11, 65, 0, 0, // Skip to: 12955
/* 12890 */   MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 12893 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 12910
/* 12898 */   MCD::OPC_CheckField, 24, 4, 8, 167, 5, 0, // Skip to: 14352
/* 12905 */   MCD::OPC_Decode, 148, 3, 206, 1, // Opcode: ADD32df
/* 12910 */   MCD::OPC_FilterValue, 1, 157, 5, 0, // Skip to: 14352
/* 12915 */   MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 12918 */   MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 12928
/* 12923 */   MCD::OPC_Decode, 153, 3, 207, 1, // Opcode: ADD32dq
/* 12928 */   MCD::OPC_FilterValue, 3, 12, 0, 0, // Skip to: 12945
/* 12933 */   MCD::OPC_CheckField, 24, 4, 8, 132, 5, 0, // Skip to: 14352
/* 12940 */   MCD::OPC_Decode, 151, 3, 208, 1, // Opcode: ADD32dk
/* 12945 */   MCD::OPC_FilterValue, 4, 122, 5, 0, // Skip to: 14352
/* 12950 */   MCD::OPC_Decode, 149, 3, 209, 1, // Opcode: ADD32di
/* 12955 */   MCD::OPC_FilterValue, 16, 12, 0, 0, // Skip to: 12972
/* 12960 */   MCD::OPC_CheckField, 3, 1, 0, 105, 5, 0, // Skip to: 14352
/* 12967 */   MCD::OPC_Decode, 176, 3, 188, 1, // Opcode: ADDX8dd
/* 12972 */   MCD::OPC_FilterValue, 17, 11, 0, 0, // Skip to: 12988
/* 12977 */   MCD::OPC_CheckField, 3, 1, 0, 88, 5, 0, // Skip to: 14352
/* 12984 */   MCD::OPC_Decode, 170, 3, 40, // Opcode: ADD8jd
/* 12988 */   MCD::OPC_FilterValue, 18, 11, 0, 0, // Skip to: 13004
/* 12993 */   MCD::OPC_CheckField, 3, 1, 1, 72, 5, 0, // Skip to: 14352
/* 13000 */   MCD::OPC_Decode, 172, 3, 41, // Opcode: ADD8pd
/* 13004 */   MCD::OPC_FilterValue, 19, 18, 0, 0, // Skip to: 13027
/* 13009 */   MCD::OPC_CheckField, 24, 4, 8, 56, 5, 0, // Skip to: 14352
/* 13016 */   MCD::OPC_CheckField, 3, 1, 0, 49, 5, 0, // Skip to: 14352
/* 13023 */   MCD::OPC_Decode, 168, 3, 42, // Opcode: ADD8fd
/* 13027 */   MCD::OPC_FilterValue, 20, 12, 0, 0, // Skip to: 13044
/* 13032 */   MCD::OPC_CheckField, 3, 1, 0, 33, 5, 0, // Skip to: 14352
/* 13039 */   MCD::OPC_Decode, 174, 3, 195, 1, // Opcode: ADDX16dd
/* 13044 */   MCD::OPC_FilterValue, 21, 12, 0, 0, // Skip to: 13061
/* 13049 */   MCD::OPC_CheckField, 3, 1, 0, 16, 5, 0, // Skip to: 14352
/* 13056 */   MCD::OPC_Decode, 135, 3, 211, 1, // Opcode: ADD16jd
/* 13061 */   MCD::OPC_FilterValue, 22, 12, 0, 0, // Skip to: 13078
/* 13066 */   MCD::OPC_CheckField, 3, 1, 1, 255, 4, 0, // Skip to: 14352
/* 13073 */   MCD::OPC_Decode, 137, 3, 212, 1, // Opcode: ADD16pd
/* 13078 */   MCD::OPC_FilterValue, 23, 19, 0, 0, // Skip to: 13102
/* 13083 */   MCD::OPC_CheckField, 24, 4, 8, 238, 4, 0, // Skip to: 14352
/* 13090 */   MCD::OPC_CheckField, 3, 1, 0, 231, 4, 0, // Skip to: 14352
/* 13097 */   MCD::OPC_Decode, 133, 3, 213, 1, // Opcode: ADD16fd
/* 13102 */   MCD::OPC_FilterValue, 24, 12, 0, 0, // Skip to: 13119
/* 13107 */   MCD::OPC_CheckField, 3, 1, 0, 214, 4, 0, // Skip to: 14352
/* 13114 */   MCD::OPC_Decode, 175, 3, 202, 1, // Opcode: ADDX32dd
/* 13119 */   MCD::OPC_FilterValue, 25, 12, 0, 0, // Skip to: 13136
/* 13124 */   MCD::OPC_CheckField, 3, 1, 0, 197, 4, 0, // Skip to: 14352
/* 13131 */   MCD::OPC_Decode, 157, 3, 214, 1, // Opcode: ADD32jd
/* 13136 */   MCD::OPC_FilterValue, 26, 12, 0, 0, // Skip to: 13153
/* 13141 */   MCD::OPC_CheckField, 3, 1, 1, 180, 4, 0, // Skip to: 14352
/* 13148 */   MCD::OPC_Decode, 159, 3, 215, 1, // Opcode: ADD32pd
/* 13153 */   MCD::OPC_FilterValue, 27, 19, 0, 0, // Skip to: 13177
/* 13158 */   MCD::OPC_CheckField, 24, 4, 8, 163, 4, 0, // Skip to: 14352
/* 13165 */   MCD::OPC_CheckField, 3, 1, 0, 156, 4, 0, // Skip to: 14352
/* 13172 */   MCD::OPC_Decode, 155, 3, 216, 1, // Opcode: ADD32fd
/* 13177 */   MCD::OPC_FilterValue, 28, 5, 0, 0, // Skip to: 13187
/* 13182 */   MCD::OPC_Decode, 146, 3, 217, 1, // Opcode: ADD32ar
/* 13187 */   MCD::OPC_FilterValue, 29, 12, 0, 0, // Skip to: 13204
/* 13192 */   MCD::OPC_CheckField, 3, 1, 0, 129, 4, 0, // Skip to: 14352
/* 13199 */   MCD::OPC_Decode, 142, 3, 218, 1, // Opcode: ADD32aj
/* 13204 */   MCD::OPC_FilterValue, 30, 12, 0, 0, // Skip to: 13221
/* 13209 */   MCD::OPC_CheckField, 3, 1, 1, 112, 4, 0, // Skip to: 14352
/* 13216 */   MCD::OPC_Decode, 144, 3, 219, 1, // Opcode: ADD32ap
/* 13221 */   MCD::OPC_FilterValue, 31, 102, 4, 0, // Skip to: 14352
/* 13226 */   MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 13229 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 13246
/* 13234 */   MCD::OPC_CheckField, 24, 4, 8, 87, 4, 0, // Skip to: 14352
/* 13241 */   MCD::OPC_Decode, 140, 3, 220, 1, // Opcode: ADD32af
/* 13246 */   MCD::OPC_FilterValue, 1, 77, 4, 0, // Skip to: 14352
/* 13251 */   MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 13254 */   MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 13264
/* 13259 */   MCD::OPC_Decode, 139, 3, 221, 1, // Opcode: ADD32ab
/* 13264 */   MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 13274
/* 13269 */   MCD::OPC_Decode, 145, 3, 222, 1, // Opcode: ADD32aq
/* 13274 */   MCD::OPC_FilterValue, 3, 12, 0, 0, // Skip to: 13291
/* 13279 */   MCD::OPC_CheckField, 24, 4, 8, 42, 4, 0, // Skip to: 14352
/* 13286 */   MCD::OPC_Decode, 143, 3, 223, 1, // Opcode: ADD32ak
/* 13291 */   MCD::OPC_FilterValue, 4, 32, 4, 0, // Skip to: 14352
/* 13296 */   MCD::OPC_Decode, 141, 3, 221, 1, // Opcode: ADD32ai
/* 13301 */   MCD::OPC_FilterValue, 14, 47, 1, 0, // Skip to: 13609
/* 13306 */   MCD::OPC_ExtractField, 3, 6,  // Inst{8-3} ...
/* 13309 */   MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 13319
/* 13314 */   MCD::OPC_Decode, 223, 3, 230, 1, // Opcode: ASR8di
/* 13319 */   MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 13329
/* 13324 */   MCD::OPC_Decode, 183, 5, 230, 1, // Opcode: LSR8di
/* 13329 */   MCD::OPC_FilterValue, 3, 5, 0, 0, // Skip to: 13339
/* 13334 */   MCD::OPC_Decode, 163, 9, 230, 1, // Opcode: ROR8di
/* 13339 */   MCD::OPC_FilterValue, 4, 5, 0, 0, // Skip to: 13349
/* 13344 */   MCD::OPC_Decode, 222, 3, 227, 1, // Opcode: ASR8dd
/* 13349 */   MCD::OPC_FilterValue, 5, 5, 0, 0, // Skip to: 13359
/* 13354 */   MCD::OPC_Decode, 182, 5, 227, 1, // Opcode: LSR8dd
/* 13359 */   MCD::OPC_FilterValue, 7, 5, 0, 0, // Skip to: 13369
/* 13364 */   MCD::OPC_Decode, 162, 9, 227, 1, // Opcode: ROR8dd
/* 13369 */   MCD::OPC_FilterValue, 8, 5, 0, 0, // Skip to: 13379
/* 13374 */   MCD::OPC_Decode, 219, 3, 231, 1, // Opcode: ASR16di
/* 13379 */   MCD::OPC_FilterValue, 9, 5, 0, 0, // Skip to: 13389
/* 13384 */   MCD::OPC_Decode, 179, 5, 231, 1, // Opcode: LSR16di
/* 13389 */   MCD::OPC_FilterValue, 11, 5, 0, 0, // Skip to: 13399
/* 13394 */   MCD::OPC_Decode, 159, 9, 231, 1, // Opcode: ROR16di
/* 13399 */   MCD::OPC_FilterValue, 12, 5, 0, 0, // Skip to: 13409
/* 13404 */   MCD::OPC_Decode, 218, 3, 228, 1, // Opcode: ASR16dd
/* 13409 */   MCD::OPC_FilterValue, 13, 5, 0, 0, // Skip to: 13419
/* 13414 */   MCD::OPC_Decode, 178, 5, 228, 1, // Opcode: LSR16dd
/* 13419 */   MCD::OPC_FilterValue, 15, 5, 0, 0, // Skip to: 13429
/* 13424 */   MCD::OPC_Decode, 158, 9, 228, 1, // Opcode: ROR16dd
/* 13429 */   MCD::OPC_FilterValue, 16, 5, 0, 0, // Skip to: 13439
/* 13434 */   MCD::OPC_Decode, 221, 3, 232, 1, // Opcode: ASR32di
/* 13439 */   MCD::OPC_FilterValue, 17, 5, 0, 0, // Skip to: 13449
/* 13444 */   MCD::OPC_Decode, 181, 5, 232, 1, // Opcode: LSR32di
/* 13449 */   MCD::OPC_FilterValue, 19, 5, 0, 0, // Skip to: 13459
/* 13454 */   MCD::OPC_Decode, 161, 9, 232, 1, // Opcode: ROR32di
/* 13459 */   MCD::OPC_FilterValue, 20, 5, 0, 0, // Skip to: 13469
/* 13464 */   MCD::OPC_Decode, 220, 3, 229, 1, // Opcode: ASR32dd
/* 13469 */   MCD::OPC_FilterValue, 21, 5, 0, 0, // Skip to: 13479
/* 13474 */   MCD::OPC_Decode, 180, 5, 229, 1, // Opcode: LSR32dd
/* 13479 */   MCD::OPC_FilterValue, 23, 5, 0, 0, // Skip to: 13489
/* 13484 */   MCD::OPC_Decode, 160, 9, 229, 1, // Opcode: ROR32dd
/* 13489 */   MCD::OPC_FilterValue, 33, 5, 0, 0, // Skip to: 13499
/* 13494 */   MCD::OPC_Decode, 222, 9, 230, 1, // Opcode: SHL8di
/* 13499 */   MCD::OPC_FilterValue, 35, 5, 0, 0, // Skip to: 13509
/* 13504 */   MCD::OPC_Decode, 157, 9, 230, 1, // Opcode: ROL8di
/* 13509 */   MCD::OPC_FilterValue, 37, 5, 0, 0, // Skip to: 13519
/* 13514 */   MCD::OPC_Decode, 221, 9, 227, 1, // Opcode: SHL8dd
/* 13519 */   MCD::OPC_FilterValue, 39, 5, 0, 0, // Skip to: 13529
/* 13524 */   MCD::OPC_Decode, 156, 9, 227, 1, // Opcode: ROL8dd
/* 13529 */   MCD::OPC_FilterValue, 41, 5, 0, 0, // Skip to: 13539
/* 13534 */   MCD::OPC_Decode, 218, 9, 231, 1, // Opcode: SHL16di
/* 13539 */   MCD::OPC_FilterValue, 43, 5, 0, 0, // Skip to: 13549
/* 13544 */   MCD::OPC_Decode, 153, 9, 231, 1, // Opcode: ROL16di
/* 13549 */   MCD::OPC_FilterValue, 45, 5, 0, 0, // Skip to: 13559
/* 13554 */   MCD::OPC_Decode, 217, 9, 228, 1, // Opcode: SHL16dd
/* 13559 */   MCD::OPC_FilterValue, 47, 5, 0, 0, // Skip to: 13569
/* 13564 */   MCD::OPC_Decode, 152, 9, 228, 1, // Opcode: ROL16dd
/* 13569 */   MCD::OPC_FilterValue, 49, 5, 0, 0, // Skip to: 13579
/* 13574 */   MCD::OPC_Decode, 220, 9, 232, 1, // Opcode: SHL32di
/* 13579 */   MCD::OPC_FilterValue, 51, 5, 0, 0, // Skip to: 13589
/* 13584 */   MCD::OPC_Decode, 155, 9, 232, 1, // Opcode: ROL32di
/* 13589 */   MCD::OPC_FilterValue, 53, 5, 0, 0, // Skip to: 13599
/* 13594 */   MCD::OPC_Decode, 219, 9, 229, 1, // Opcode: SHL32dd
/* 13599 */   MCD::OPC_FilterValue, 55, 236, 2, 0, // Skip to: 14352
/* 13604 */   MCD::OPC_Decode, 154, 9, 229, 1, // Opcode: ROL32dd
/* 13609 */   MCD::OPC_FilterValue, 15, 226, 2, 0, // Skip to: 14352
/* 13614 */   MCD::OPC_ExtractField, 16, 7,  // Inst{22-16} ...
/* 13617 */   MCD::OPC_FilterValue, 0, 130, 0, 0, // Skip to: 13752
/* 13622 */   MCD::OPC_ExtractField, 29, 3,  // Inst{31-29} ...
/* 13625 */   MCD::OPC_FilterValue, 0, 18, 0, 0, // Skip to: 13648
/* 13630 */   MCD::OPC_CheckPredicate, 2, 205, 2, 0, // Skip to: 14352
/* 13635 */   MCD::OPC_CheckField, 0, 12, 128, 4, 197, 2, 0, // Skip to: 14352
/* 13643 */   MCD::OPC_Decode, 134, 5, 233, 1, // Opcode: FMOV80fp_fp
/* 13648 */   MCD::OPC_FilterValue, 4, 47, 0, 0, // Skip to: 13700
/* 13653 */   MCD::OPC_ExtractField, 3, 9,  // Inst{11-3} ...
/* 13656 */   MCD::OPC_FilterValue, 64, 17, 0, 0, // Skip to: 13678
/* 13661 */   MCD::OPC_CheckPredicate, 2, 174, 2, 0, // Skip to: 14352
/* 13666 */   MCD::OPC_CheckField, 23, 3, 0, 167, 2, 0, // Skip to: 14352
/* 13673 */   MCD::OPC_Decode, 137, 5, 234, 1, // Opcode: FMOVE32fpcs_d
/* 13678 */   MCD::OPC_FilterValue, 65, 157, 2, 0, // Skip to: 14352
/* 13683 */   MCD::OPC_CheckPredicate, 2, 152, 2, 0, // Skip to: 14352
/* 13688 */   MCD::OPC_CheckField, 23, 3, 0, 145, 2, 0, // Skip to: 14352
/* 13695 */   MCD::OPC_Decode, 138, 5, 235, 1, // Opcode: FMOVE32fpi_a
/* 13700 */   MCD::OPC_FilterValue, 5, 135, 2, 0, // Skip to: 14352
/* 13705 */   MCD::OPC_ExtractField, 3, 9,  // Inst{11-3} ...
/* 13708 */   MCD::OPC_FilterValue, 64, 17, 0, 0, // Skip to: 13730
/* 13713 */   MCD::OPC_CheckPredicate, 2, 122, 2, 0, // Skip to: 14352
/* 13718 */   MCD::OPC_CheckField, 23, 3, 0, 115, 2, 0, // Skip to: 14352
/* 13725 */   MCD::OPC_Decode, 136, 5, 236, 1, // Opcode: FMOVE32d_fpcs
/* 13730 */   MCD::OPC_FilterValue, 65, 105, 2, 0, // Skip to: 14352
/* 13735 */   MCD::OPC_CheckPredicate, 2, 100, 2, 0, // Skip to: 14352
/* 13740 */   MCD::OPC_CheckField, 23, 3, 0, 93, 2, 0, // Skip to: 14352
/* 13747 */   MCD::OPC_Decode, 135, 5, 237, 1, // Opcode: FMOVE32a_fpi
/* 13752 */   MCD::OPC_FilterValue, 24, 25, 0, 0, // Skip to: 13782
/* 13757 */   MCD::OPC_CheckPredicate, 2, 78, 2, 0, // Skip to: 14352
/* 13762 */   MCD::OPC_CheckField, 29, 3, 0, 71, 2, 0, // Skip to: 14352
/* 13769 */   MCD::OPC_CheckField, 0, 12, 128, 4, 63, 2, 0, // Skip to: 14352
/* 13777 */   MCD::OPC_Decode, 232, 4, 233, 1, // Opcode: FABS80fp_fp
/* 13782 */   MCD::OPC_FilterValue, 26, 25, 0, 0, // Skip to: 13812
/* 13787 */   MCD::OPC_CheckPredicate, 2, 48, 2, 0, // Skip to: 14352
/* 13792 */   MCD::OPC_CheckField, 29, 3, 0, 41, 2, 0, // Skip to: 14352
/* 13799 */   MCD::OPC_CheckField, 0, 12, 128, 4, 33, 2, 0, // Skip to: 14352
/* 13807 */   MCD::OPC_Decode, 144, 5, 233, 1, // Opcode: FNEG80fp_fp
/* 13812 */   MCD::OPC_FilterValue, 32, 25, 0, 0, // Skip to: 13842
/* 13817 */   MCD::OPC_CheckPredicate, 2, 18, 2, 0, // Skip to: 14352
/* 13822 */   MCD::OPC_CheckField, 29, 3, 0, 11, 2, 0, // Skip to: 14352
/* 13829 */   MCD::OPC_CheckField, 0, 12, 128, 4, 3, 2, 0, // Skip to: 14352
/* 13837 */   MCD::OPC_Decode, 247, 4, 238, 1, // Opcode: FDIV80fp_fp
/* 13842 */   MCD::OPC_FilterValue, 34, 25, 0, 0, // Skip to: 13872
/* 13847 */   MCD::OPC_CheckPredicate, 2, 244, 1, 0, // Skip to: 14352
/* 13852 */   MCD::OPC_CheckField, 29, 3, 0, 237, 1, 0, // Skip to: 14352
/* 13859 */   MCD::OPC_CheckField, 0, 12, 128, 4, 229, 1, 0, // Skip to: 14352
/* 13867 */   MCD::OPC_Decode, 235, 4, 238, 1, // Opcode: FADD80fp_fp
/* 13872 */   MCD::OPC_FilterValue, 35, 25, 0, 0, // Skip to: 13902
/* 13877 */   MCD::OPC_CheckPredicate, 2, 214, 1, 0, // Skip to: 14352
/* 13882 */   MCD::OPC_CheckField, 29, 3, 0, 207, 1, 0, // Skip to: 14352
/* 13889 */   MCD::OPC_CheckField, 0, 12, 128, 4, 199, 1, 0, // Skip to: 14352
/* 13897 */   MCD::OPC_Decode, 141, 5, 238, 1, // Opcode: FMUL80fp_fp
/* 13902 */   MCD::OPC_FilterValue, 40, 25, 0, 0, // Skip to: 13932
/* 13907 */   MCD::OPC_CheckPredicate, 2, 184, 1, 0, // Skip to: 14352
/* 13912 */   MCD::OPC_CheckField, 29, 3, 0, 177, 1, 0, // Skip to: 14352
/* 13919 */   MCD::OPC_CheckField, 0, 12, 128, 4, 169, 1, 0, // Skip to: 14352
/* 13927 */   MCD::OPC_Decode, 168, 5, 238, 1, // Opcode: FSUB80fp_fp
/* 13932 */   MCD::OPC_FilterValue, 64, 25, 0, 0, // Skip to: 13962
/* 13937 */   MCD::OPC_CheckPredicate, 3, 154, 1, 0, // Skip to: 14352
/* 13942 */   MCD::OPC_CheckField, 29, 3, 0, 147, 1, 0, // Skip to: 14352
/* 13949 */   MCD::OPC_CheckField, 0, 12, 128, 4, 139, 1, 0, // Skip to: 14352
/* 13957 */   MCD::OPC_Decode, 156, 5, 233, 1, // Opcode: FSMOV80fp_fp
/* 13962 */   MCD::OPC_FilterValue, 68, 25, 0, 0, // Skip to: 13992
/* 13967 */   MCD::OPC_CheckPredicate, 3, 124, 1, 0, // Skip to: 14352
/* 13972 */   MCD::OPC_CheckField, 29, 3, 0, 117, 1, 0, // Skip to: 14352
/* 13979 */   MCD::OPC_CheckField, 0, 12, 128, 4, 109, 1, 0, // Skip to: 14352
/* 13987 */   MCD::OPC_Decode, 250, 4, 233, 1, // Opcode: FDMOV80fp_fp
/* 13992 */   MCD::OPC_FilterValue, 88, 25, 0, 0, // Skip to: 14022
/* 13997 */   MCD::OPC_CheckPredicate, 3, 94, 1, 0, // Skip to: 14352
/* 14002 */   MCD::OPC_CheckField, 29, 3, 0, 87, 1, 0, // Skip to: 14352
/* 14009 */   MCD::OPC_CheckField, 0, 12, 128, 4, 79, 1, 0, // Skip to: 14352
/* 14017 */   MCD::OPC_Decode, 147, 5, 233, 1, // Opcode: FSABS80fp_fp
/* 14022 */   MCD::OPC_FilterValue, 90, 25, 0, 0, // Skip to: 14052
/* 14027 */   MCD::OPC_CheckPredicate, 3, 64, 1, 0, // Skip to: 14352
/* 14032 */   MCD::OPC_CheckField, 29, 3, 0, 57, 1, 0, // Skip to: 14352
/* 14039 */   MCD::OPC_CheckField, 0, 12, 128, 4, 49, 1, 0, // Skip to: 14352
/* 14047 */   MCD::OPC_Decode, 162, 5, 233, 1, // Opcode: FSNEG80fp_fp
/* 14052 */   MCD::OPC_FilterValue, 92, 25, 0, 0, // Skip to: 14082
/* 14057 */   MCD::OPC_CheckPredicate, 3, 34, 1, 0, // Skip to: 14352
/* 14062 */   MCD::OPC_CheckField, 29, 3, 0, 27, 1, 0, // Skip to: 14352
/* 14069 */   MCD::OPC_CheckField, 0, 12, 128, 4, 19, 1, 0, // Skip to: 14352
/* 14077 */   MCD::OPC_Decode, 238, 4, 233, 1, // Opcode: FDABS80fp_fp
/* 14082 */   MCD::OPC_FilterValue, 94, 25, 0, 0, // Skip to: 14112
/* 14087 */   MCD::OPC_CheckPredicate, 3, 4, 1, 0, // Skip to: 14352
/* 14092 */   MCD::OPC_CheckField, 29, 3, 0, 253, 0, 0, // Skip to: 14352
/* 14099 */   MCD::OPC_CheckField, 0, 12, 128, 4, 245, 0, 0, // Skip to: 14352
/* 14107 */   MCD::OPC_Decode, 128, 5, 233, 1, // Opcode: FDNEG80fp_fp
/* 14112 */   MCD::OPC_FilterValue, 96, 25, 0, 0, // Skip to: 14142
/* 14117 */   MCD::OPC_CheckPredicate, 3, 230, 0, 0, // Skip to: 14352
/* 14122 */   MCD::OPC_CheckField, 29, 3, 0, 223, 0, 0, // Skip to: 14352
/* 14129 */   MCD::OPC_CheckField, 0, 12, 128, 4, 215, 0, 0, // Skip to: 14352
/* 14137 */   MCD::OPC_Decode, 153, 5, 238, 1, // Opcode: FSDIV80fp_fp
/* 14142 */   MCD::OPC_FilterValue, 98, 25, 0, 0, // Skip to: 14172
/* 14147 */   MCD::OPC_CheckPredicate, 3, 200, 0, 0, // Skip to: 14352
/* 14152 */   MCD::OPC_CheckField, 29, 3, 0, 193, 0, 0, // Skip to: 14352
/* 14159 */   MCD::OPC_CheckField, 0, 12, 128, 4, 185, 0, 0, // Skip to: 14352
/* 14167 */   MCD::OPC_Decode, 150, 5, 238, 1, // Opcode: FSADD80fp_fp
/* 14172 */   MCD::OPC_FilterValue, 99, 25, 0, 0, // Skip to: 14202
/* 14177 */   MCD::OPC_CheckPredicate, 3, 170, 0, 0, // Skip to: 14352
/* 14182 */   MCD::OPC_CheckField, 29, 3, 0, 163, 0, 0, // Skip to: 14352
/* 14189 */   MCD::OPC_CheckField, 0, 12, 128, 4, 155, 0, 0, // Skip to: 14352
/* 14197 */   MCD::OPC_Decode, 159, 5, 238, 1, // Opcode: FSMUL80fp_fp
/* 14202 */   MCD::OPC_FilterValue, 100, 25, 0, 0, // Skip to: 14232
/* 14207 */   MCD::OPC_CheckPredicate, 3, 140, 0, 0, // Skip to: 14352
/* 14212 */   MCD::OPC_CheckField, 29, 3, 0, 133, 0, 0, // Skip to: 14352
/* 14219 */   MCD::OPC_CheckField, 0, 12, 128, 4, 125, 0, 0, // Skip to: 14352
/* 14227 */   MCD::OPC_Decode, 244, 4, 238, 1, // Opcode: FDDIV80fp_fp
/* 14232 */   MCD::OPC_FilterValue, 102, 25, 0, 0, // Skip to: 14262
/* 14237 */   MCD::OPC_CheckPredicate, 3, 110, 0, 0, // Skip to: 14352
/* 14242 */   MCD::OPC_CheckField, 29, 3, 0, 103, 0, 0, // Skip to: 14352
/* 14249 */   MCD::OPC_CheckField, 0, 12, 128, 4, 95, 0, 0, // Skip to: 14352
/* 14257 */   MCD::OPC_Decode, 241, 4, 238, 1, // Opcode: FDADD80fp_fp
/* 14262 */   MCD::OPC_FilterValue, 103, 25, 0, 0, // Skip to: 14292
/* 14267 */   MCD::OPC_CheckPredicate, 3, 80, 0, 0, // Skip to: 14352
/* 14272 */   MCD::OPC_CheckField, 29, 3, 0, 73, 0, 0, // Skip to: 14352
/* 14279 */   MCD::OPC_CheckField, 0, 12, 128, 4, 65, 0, 0, // Skip to: 14352
/* 14287 */   MCD::OPC_Decode, 253, 4, 238, 1, // Opcode: FDMUL80fp_fp
/* 14292 */   MCD::OPC_FilterValue, 104, 25, 0, 0, // Skip to: 14322
/* 14297 */   MCD::OPC_CheckPredicate, 3, 50, 0, 0, // Skip to: 14352
/* 14302 */   MCD::OPC_CheckField, 29, 3, 0, 43, 0, 0, // Skip to: 14352
/* 14309 */   MCD::OPC_CheckField, 0, 12, 128, 4, 35, 0, 0, // Skip to: 14352
/* 14317 */   MCD::OPC_Decode, 165, 5, 238, 1, // Opcode: FSSUB80fp_fp
/* 14322 */   MCD::OPC_FilterValue, 108, 25, 0, 0, // Skip to: 14352
/* 14327 */   MCD::OPC_CheckPredicate, 3, 20, 0, 0, // Skip to: 14352
/* 14332 */   MCD::OPC_CheckField, 29, 3, 0, 13, 0, 0, // Skip to: 14352
/* 14339 */   MCD::OPC_CheckField, 0, 12, 128, 4, 5, 0, 0, // Skip to: 14352
/* 14347 */   MCD::OPC_Decode, 131, 5, 238, 1, // Opcode: FDSUB80fp_fp
/* 14352 */   MCD::OPC_Fail,
  0
};

static const uint8_t InstrLenTable[] = {
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
16,
32,
32,
16,
32,
32,
32,
16,
32,
48,
16,
32,
32,
48,
48,
32,
48,
16,
32,
32,
32,
16,
16,
32,
48,
16,
32,
32,
32,
16,
32,
64,
16,
48,
32,
64,
16,
32,
32,
16,
32,
32,
32,
32,
48,
16,
32,
32,
48,
16,
16,
16,
16,
32,
32,
16,
32,
32,
32,
16,
32,
48,
16,
32,
32,
48,
16,
32,
48,
16,
32,
32,
32,
16,
32,
64,
16,
48,
32,
64,
16,
32,
32,
16,
32,
32,
32,
32,
48,
16,
32,
32,
48,
16,
16,
16,
16,
16,
16,
16,
32,
16,
32,
32,
48,
16,
32,
16,
32,
32,
48,
16,
32,
16,
32,
32,
48,
16,
32,
16,
32,
32,
48,
16,
32,
16,
16,
32,
16,
32,
32,
48,
16,
32,
16,
32,
32,
48,
32,
48,
16,
16,
32,
16,
32,
32,
48,
16,
32,
32,
48,
16,
32,
32,
48,
32,
48,
32,
16,
32,
16,
32,
16,
32,
16,
32,
16,
32,
16,
32,
16,
32,
16,
32,
16,
32,
16,
32,
16,
32,
16,
32,
16,
32,
16,
48,
16,
32,
32,
32,
32,
32,
64,
32,
32,
16,
32,
32,
32,
16,
48,
32,
48,
48,
48,
80,
32,
48,
16,
32,
32,
32,
16,
64,
48,
64,
64,
64,
64,
16,
32,
32,
16,
32,
32,
32,
48,
32,
48,
48,
48,
16,
16,
0,
0,
32,
0,
0,
32,
0,
0,
32,
0,
0,
32,
0,
0,
32,
0,
0,
32,
0,
0,
32,
0,
0,
32,
0,
0,
32,
0,
0,
32,
0,
0,
32,
32,
32,
32,
32,
0,
0,
32,
0,
0,
32,
0,
0,
32,
0,
0,
32,
0,
0,
32,
0,
0,
32,
0,
0,
32,
0,
0,
32,
0,
0,
32,
0,
0,
32,
16,
16,
48,
32,
32,
32,
32,
32,
48,
16,
16,
16,
16,
16,
16,
16,
48,
0,
16,
0,
32,
0,
32,
16,
0,
32,
0,
16,
0,
32,
0,
32,
0,
16,
48,
80,
48,
48,
48,
64,
64,
48,
64,
48,
64,
64,
48,
48,
16,
16,
32,
16,
32,
16,
32,
32,
48,
16,
16,
16,
32,
32,
16,
32,
16,
32,
32,
16,
48,
16,
16,
16,
32,
32,
16,
32,
16,
32,
32,
16,
32,
64,
32,
32,
32,
48,
48,
32,
48,
32,
48,
48,
32,
16,
48,
16,
16,
16,
32,
32,
16,
32,
16,
32,
32,
16,
32,
64,
32,
32,
32,
48,
48,
32,
48,
32,
48,
48,
32,
16,
48,
16,
16,
16,
32,
32,
16,
32,
16,
32,
32,
16,
32,
64,
32,
32,
32,
48,
48,
32,
48,
32,
48,
48,
32,
32,
64,
32,
32,
32,
48,
48,
32,
48,
32,
48,
48,
32,
16,
48,
0,
16,
0,
32,
0,
32,
16,
0,
32,
0,
16,
0,
32,
0,
32,
0,
16,
16,
48,
0,
16,
0,
32,
0,
48,
16,
0,
32,
0,
16,
0,
32,
0,
32,
0,
16,
48,
80,
48,
48,
64,
80,
48,
64,
48,
64,
64,
48,
48,
16,
16,
32,
48,
16,
32,
16,
32,
32,
16,
48,
16,
16,
32,
48,
16,
32,
16,
32,
32,
16,
32,
64,
32,
32,
48,
64,
32,
48,
32,
48,
48,
32,
16,
48,
16,
16,
32,
48,
16,
32,
16,
32,
32,
16,
32,
64,
32,
32,
48,
64,
32,
48,
32,
48,
48,
32,
16,
48,
16,
16,
32,
48,
16,
32,
16,
32,
32,
16,
32,
64,
32,
32,
48,
64,
32,
48,
32,
48,
48,
32,
32,
64,
32,
32,
48,
64,
32,
48,
32,
48,
48,
32,
16,
48,
0,
16,
0,
32,
0,
48,
16,
0,
32,
0,
16,
0,
32,
0,
32,
0,
16,
80,
48,
48,
64,
64,
48,
64,
48,
64,
64,
48,
16,
16,
32,
32,
16,
32,
16,
32,
32,
48,
16,
16,
32,
32,
16,
32,
16,
32,
32,
64,
32,
32,
48,
48,
32,
48,
32,
48,
48,
48,
16,
16,
32,
32,
16,
32,
16,
32,
32,
64,
32,
32,
48,
48,
32,
48,
32,
48,
48,
48,
16,
16,
32,
32,
16,
32,
16,
32,
32,
64,
32,
32,
48,
48,
32,
48,
32,
48,
48,
64,
32,
32,
48,
48,
32,
48,
32,
48,
48,
64,
32,
48,
32,
48,
64,
32,
48,
32,
48,
32,
48,
48,
32,
48,
48,
64,
32,
48,
32,
48,
64,
32,
48,
32,
48,
32,
48,
48,
32,
48,
48,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
32,
32,
16,
32,
32,
32,
16,
32,
48,
16,
32,
32,
48,
16,
32,
48,
16,
32,
32,
32,
16,
32,
64,
16,
48,
32,
64,
16,
32,
32,
16,
32,
32,
32,
32,
48,
16,
32,
32,
48,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
32,
32,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
16,
16,
16,
16,
16,
16,
16,
32,
32,
16,
32,
32,
16,
32,
32,
32,
16,
32,
48,
16,
32,
32,
48,
48,
32,
48,
16,
32,
32,
32,
16,
16,
32,
48,
16,
32,
32,
32,
16,
32,
64,
16,
48,
32,
64,
16,
32,
32,
16,
32,
32,
32,
32,
48,
16,
32,
32,
48,
16,
16,
16,
16,
16,
16,
32,
32,
16,
32,
32,
16,
16,
32,
16,
48,
16,
32,
};

static bool checkDecoderPredicate(unsigned Idx, const FeatureBitset &Bits) {
  switch (Idx) {
  default: llvm_unreachable("Invalid index!");
  case 0:
    return (Bits[M68k::FeatureISA20]);
  case 1:
    return (Bits[M68k::FeatureISA10]);
  case 2:
    return (Bits[M68k::FeatureISA881]);
  case 3:
    return (Bits[M68k::FeatureISA40]);
  }
}

template <typename InsnType>
static DecodeStatus decodeToMCInst(DecodeStatus S, unsigned Idx, InsnType insn, MCInst &MI,
                                   uint64_t Address, const MCDisassembler *Decoder, bool &DecodeComplete) {
  DecodeComplete = true;
  using TmpType = std::conditional_t<std::is_integral<InsnType>::value, InsnType, uint64_t>;
  TmpType tmp;
  switch (Idx) {
  default: llvm_unreachable("Invalid index!");
  case 0:
    tmp = fieldFromInstruction(insn, 0, 4);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 1:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 2:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 3:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 4:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 5:
    tmp = fieldFromInstruction(insn, 32, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 6:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 32, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 7:
    tmp = fieldFromInstruction(insn, 32, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 44, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 8:
    tmp = fieldFromInstruction(insn, 32, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 9:
    tmp = fieldFromInstruction(insn, 32, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 44, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 10:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 32, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 44, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 11:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 32, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 12:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 32, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 13:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 32, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 44, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 14:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 15:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 16:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 17:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 18:
    tmp = fieldFromInstruction(insn, 32, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 19:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 32, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 20:
    tmp = fieldFromInstruction(insn, 32, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 44, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 21:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 32, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 44, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 22:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 32, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 23:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 32, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 24:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 32, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 44, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 25:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 26:
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 27:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 28:
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 29:
    tmp = fieldFromInstruction(insn, 48, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 30:
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 48, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 31:
    tmp = fieldFromInstruction(insn, 48, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 60, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 32:
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 48, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 60, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 33:
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 48, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 34:
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 48, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 35:
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 48, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 60, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 36:
    tmp = fieldFromInstruction(insn, 16, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 22, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 37:
    tmp = fieldFromInstruction(insn, 16, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 22, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 38:
    tmp = fieldFromInstruction(insn, 16, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 22, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 39:
    tmp = fieldFromInstruction(insn, 0, 4);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 40:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 41:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 42:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 43:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 44:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 45:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 46:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 47:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 48:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 49:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 50:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 51:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 52:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 53:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 54:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 55:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 56:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 57:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 58:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 59:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 60:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 61:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 62:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 63:
    tmp = fieldFromInstruction(insn, 32, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 64:
    tmp = fieldFromInstruction(insn, 32, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 65:
    tmp = fieldFromInstruction(insn, 48, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 66:
    tmp = fieldFromInstruction(insn, 32, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 67:
    tmp = fieldFromInstruction(insn, 32, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 68:
    tmp = fieldFromInstruction(insn, 32, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 69:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 70:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 71:
    tmp = fieldFromInstruction(insn, 32, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 44, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 72:
    tmp = fieldFromInstruction(insn, 32, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 44, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 73:
    tmp = fieldFromInstruction(insn, 48, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 60, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 74:
    tmp = fieldFromInstruction(insn, 32, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 44, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 75:
    tmp = fieldFromInstruction(insn, 32, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 44, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 76:
    tmp = fieldFromInstruction(insn, 32, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 44, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 77:
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 78:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 79:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 80:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 81:
    tmp = fieldFromInstruction(insn, 32, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 82:
    tmp = fieldFromInstruction(insn, 32, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 83:
    tmp = fieldFromInstruction(insn, 32, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 44, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 84:
    tmp = fieldFromInstruction(insn, 32, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 85:
    tmp = fieldFromInstruction(insn, 32, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 86:
    tmp = fieldFromInstruction(insn, 32, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 44, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 87:
    tmp = fieldFromInstruction(insn, 48, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 88:
    tmp = fieldFromInstruction(insn, 48, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 89:
    tmp = fieldFromInstruction(insn, 48, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 60, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 90:
    tmp = fieldFromInstruction(insn, 32, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 91:
    tmp = fieldFromInstruction(insn, 32, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 92:
    tmp = fieldFromInstruction(insn, 32, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 44, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 93:
    tmp = fieldFromInstruction(insn, 32, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 94:
    tmp = fieldFromInstruction(insn, 32, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 95:
    tmp = fieldFromInstruction(insn, 32, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 44, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 96:
    tmp = fieldFromInstruction(insn, 32, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 97:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 98:
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 6, 1), 3, 1);
    insertBits(tmp, fieldFromInstruction(insn, 9, 3), 0, 3);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 99:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 0, 3), 0, 3);
    insertBits(tmp, fieldFromInstruction(insn, 3, 1), 3, 1);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 100:
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 6, 1), 3, 1);
    insertBits(tmp, fieldFromInstruction(insn, 9, 3), 0, 3);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 0, 3), 0, 3);
    insertBits(tmp, fieldFromInstruction(insn, 3, 1), 3, 1);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 101:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 102:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 103:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 0, 3), 0, 3);
    insertBits(tmp, fieldFromInstruction(insn, 3, 1), 3, 1);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 104:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 105:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 0, 3), 0, 3);
    insertBits(tmp, fieldFromInstruction(insn, 3, 1), 3, 1);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 106:
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 0, 3), 0, 3);
    insertBits(tmp, fieldFromInstruction(insn, 3, 1), 3, 1);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 107:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 108:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 0, 3), 0, 3);
    insertBits(tmp, fieldFromInstruction(insn, 3, 1), 3, 1);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 109:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 110:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 0, 3), 0, 3);
    insertBits(tmp, fieldFromInstruction(insn, 3, 1), 3, 1);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 111:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 112:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 113:
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 6, 1), 3, 1);
    insertBits(tmp, fieldFromInstruction(insn, 9, 3), 0, 3);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 114:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 115:
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 6, 1), 3, 1);
    insertBits(tmp, fieldFromInstruction(insn, 9, 3), 0, 3);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 116:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 117:
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 6, 1), 3, 1);
    insertBits(tmp, fieldFromInstruction(insn, 9, 3), 0, 3);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 118:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 119:
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 6, 1), 3, 1);
    insertBits(tmp, fieldFromInstruction(insn, 9, 3), 0, 3);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 120:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 121:
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 6, 1), 3, 1);
    insertBits(tmp, fieldFromInstruction(insn, 9, 3), 0, 3);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 122:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 123:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 124:
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 6, 1), 3, 1);
    insertBits(tmp, fieldFromInstruction(insn, 9, 3), 0, 3);
    if (!Check(S, DecodeXR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 125:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 0, 3), 0, 3);
    insertBits(tmp, fieldFromInstruction(insn, 3, 1), 3, 1);
    if (!Check(S, DecodeXR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 126:
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 6, 1), 3, 1);
    insertBits(tmp, fieldFromInstruction(insn, 9, 3), 0, 3);
    if (!Check(S, DecodeXR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 0, 3), 0, 3);
    insertBits(tmp, fieldFromInstruction(insn, 3, 1), 3, 1);
    if (!Check(S, DecodeXR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 127:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 128:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 129:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 0, 3), 0, 3);
    insertBits(tmp, fieldFromInstruction(insn, 3, 1), 3, 1);
    if (!Check(S, DecodeXR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 130:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 131:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 132:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 0, 3), 0, 3);
    insertBits(tmp, fieldFromInstruction(insn, 3, 1), 3, 1);
    if (!Check(S, DecodeXR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 133:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 134:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 135:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 0, 3), 0, 3);
    insertBits(tmp, fieldFromInstruction(insn, 3, 1), 3, 1);
    if (!Check(S, DecodeXR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 136:
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 137:
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 138:
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 0, 3), 0, 3);
    insertBits(tmp, fieldFromInstruction(insn, 3, 1), 3, 1);
    if (!Check(S, DecodeXR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 139:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 140:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 0, 3), 0, 3);
    insertBits(tmp, fieldFromInstruction(insn, 3, 1), 3, 1);
    if (!Check(S, DecodeXR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 141:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 142:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 143:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 0, 3), 0, 3);
    insertBits(tmp, fieldFromInstruction(insn, 3, 1), 3, 1);
    if (!Check(S, DecodeXR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 144:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 145:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 146:
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 6, 1), 3, 1);
    insertBits(tmp, fieldFromInstruction(insn, 9, 3), 0, 3);
    if (!Check(S, DecodeXR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 147:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 148:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 149:
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 6, 1), 3, 1);
    insertBits(tmp, fieldFromInstruction(insn, 9, 3), 0, 3);
    if (!Check(S, DecodeXR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 150:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 151:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 152:
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 6, 1), 3, 1);
    insertBits(tmp, fieldFromInstruction(insn, 9, 3), 0, 3);
    if (!Check(S, DecodeXR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 153:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 154:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 155:
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 6, 1), 3, 1);
    insertBits(tmp, fieldFromInstruction(insn, 9, 3), 0, 3);
    if (!Check(S, DecodeXR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 156:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 157:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 158:
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 6, 1), 3, 1);
    insertBits(tmp, fieldFromInstruction(insn, 9, 3), 0, 3);
    if (!Check(S, DecodeXR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 159:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 160:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 161:
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 6, 1), 3, 1);
    insertBits(tmp, fieldFromInstruction(insn, 9, 3), 0, 3);
    if (!Check(S, DecodeXR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 162:
    tmp = fieldFromInstruction(insn, 0, 4);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 4);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 163:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 16, 16), 16, 16);
    insertBits(tmp, fieldFromInstruction(insn, 32, 16), 0, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 164:
    tmp = fieldFromInstruction(insn, 28, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 165:
    tmp = fieldFromInstruction(insn, 0, 4);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 4);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 166:
    tmp = fieldFromInstruction(insn, 0, 3);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 167:
    tmp = fieldFromInstruction(insn, 0, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 168:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 169:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 170:
    return S;
  case 171:
    tmp = fieldFromInstruction(insn, 0, 4);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 4);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 172:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 173:
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 174:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 175:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 176:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    if (!Check(S, DecodeCCRCRegisterClass(MI, insn, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 177:
    if (!Check(S, DecodeCCRCRegisterClass(MI, insn, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 178:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 179:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    if (!Check(S, DecodeCCRCRegisterClass(MI, insn, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 180:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    if (!Check(S, DecodeCCRCRegisterClass(MI, insn, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 181:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    if (!Check(S, DecodeCCRCRegisterClass(MI, insn, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 182:
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    if (!Check(S, DecodeCCRCRegisterClass(MI, insn, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 183:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    if (!Check(S, DecodeCCRCRegisterClass(MI, insn, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 184:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    if (!Check(S, DecodeCCRCRegisterClass(MI, insn, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 185:
    tmp = fieldFromInstruction(insn, 0, 4);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 186:
    tmp = fieldFromInstruction(insn, 0, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 187:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 188:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 189:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 190:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 191:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 192:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 193:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 194:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 195:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 196:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 4);
    if (!Check(S, DecodeXR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 197:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 198:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 199:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 200:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 201:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 202:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 203:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 204:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 205:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 206:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 207:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 208:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 209:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 210:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 211:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 212:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 213:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 214:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 215:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 216:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 217:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 218:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 219:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 220:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 221:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 222:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 223:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 224:
    tmp = fieldFromInstruction(insn, 0, 4);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 225:
    tmp = fieldFromInstruction(insn, 0, 4);
    if (!Check(S, DecodeXR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 226:
    tmp = fieldFromInstruction(insn, 0, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 227:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 228:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 229:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 230:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 231:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 232:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 233:
    tmp = fieldFromInstruction(insn, 23, 3);
    if (!Check(S, DecodeFPDR80RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 26, 3);
    if (!Check(S, DecodeFPDR80RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 234:
    tmp = fieldFromInstruction(insn, 26, 3);
    if (!Check(S, DecodeFPCSCRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 235:
    tmp = fieldFromInstruction(insn, 26, 3);
    if (!Check(S, DecodeFPICRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 236:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 26, 3);
    if (!Check(S, DecodeFPCSCRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 237:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 26, 3);
    if (!Check(S, DecodeFPICRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 238:
    tmp = fieldFromInstruction(insn, 23, 3);
    if (!Check(S, DecodeFPDR80RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 23, 3);
    if (!Check(S, DecodeFPDR80RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 26, 3);
    if (!Check(S, DecodeFPDR80RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  }
}

template <typename InsnType>
static DecodeStatus decodeInstruction(const uint8_t DecodeTable[], MCInst &MI,
                                      InsnType insn, uint64_t Address,
                                      const MCDisassembler *DisAsm,
                                      const MCSubtargetInfo &STI,
                                      llvm::function_ref<void(APInt &, uint64_t)> makeUp) {
  const FeatureBitset &Bits = STI.getFeatureBits();

  const uint8_t *Ptr = DecodeTable;
  uint64_t CurFieldValue = 0;
  DecodeStatus S = MCDisassembler::Success;
  while (true) {
    ptrdiff_t Loc = Ptr - DecodeTable;
    switch (*Ptr) {
    default:
      errs() << Loc << ": Unexpected decode table opcode!\n";
      return MCDisassembler::Fail;
    case MCD::OPC_ExtractField: {
      // Decode the start value.
      unsigned Start = decodeULEB128AndIncUnsafe(++Ptr);
      unsigned Len = *Ptr++;
      makeUp(insn, Start + Len);
      CurFieldValue = fieldFromInstruction(insn, Start, Len);
      LLVM_DEBUG(dbgs() << Loc << ": OPC_ExtractField(" << Start << ", "
                   << Len << "): " << CurFieldValue << "\n");
      break;
    }
    case MCD::OPC_FilterValue: {
      // Decode the field value.
      uint64_t Val = decodeULEB128AndIncUnsafe(++Ptr);
      // NumToSkip is a plain 24-bit integer.
      unsigned NumToSkip = *Ptr++;
      NumToSkip |= (*Ptr++) << 8;
      NumToSkip |= (*Ptr++) << 16;

      // Perform the filter operation.
      if (Val != CurFieldValue)
        Ptr += NumToSkip;
      LLVM_DEBUG(dbgs() << Loc << ": OPC_FilterValue(" << Val << ", " << NumToSkip
                   << "): " << ((Val != CurFieldValue) ? "FAIL:" : "PASS:")
                   << " continuing at " << (Ptr - DecodeTable) << "\n");

      break;
    }
    case MCD::OPC_CheckField: {
      // Decode the start value.
      unsigned Start = decodeULEB128AndIncUnsafe(++Ptr);
      unsigned Len = *Ptr;
      makeUp(insn, Start + Len);
      uint64_t FieldValue = fieldFromInstruction(insn, Start, Len);
      // Decode the field value.
      unsigned PtrLen = 0;
      uint64_t ExpectedValue = decodeULEB128(++Ptr, &PtrLen);
      Ptr += PtrLen;
      // NumToSkip is a plain 24-bit integer.
      unsigned NumToSkip = *Ptr++;
      NumToSkip |= (*Ptr++) << 8;
      NumToSkip |= (*Ptr++) << 16;

      // If the actual and expected values don't match, skip.
      if (ExpectedValue != FieldValue)
        Ptr += NumToSkip;
      LLVM_DEBUG(dbgs() << Loc << ": OPC_CheckField(" << Start << ", "
                   << Len << ", " << ExpectedValue << ", " << NumToSkip
                   << "): FieldValue = " << FieldValue << ", ExpectedValue = "
                   << ExpectedValue << ": "
                   << ((ExpectedValue == FieldValue) ? "PASS\n" : "FAIL\n"));
      break;
    }
    case MCD::OPC_CheckPredicate: {
      // Decode the Predicate Index value.
      unsigned PIdx = decodeULEB128AndIncUnsafe(++Ptr);
      // NumToSkip is a plain 24-bit integer.
      unsigned NumToSkip = *Ptr++;
      NumToSkip |= (*Ptr++) << 8;
      NumToSkip |= (*Ptr++) << 16;
      // Check the predicate.
      bool Pred;
      if (!(Pred = checkDecoderPredicate(PIdx, Bits)))
        Ptr += NumToSkip;
      (void)Pred;
      LLVM_DEBUG(dbgs() << Loc << ": OPC_CheckPredicate(" << PIdx << "): "
            << (Pred ? "PASS\n" : "FAIL\n"));

      break;
    }
    case MCD::OPC_Decode: {
      // Decode the Opcode value.
      unsigned Opc = decodeULEB128AndIncUnsafe(++Ptr);
      unsigned DecodeIdx = decodeULEB128AndIncUnsafe(Ptr);

      MI.clear();
      MI.setOpcode(Opc);
      bool DecodeComplete;
      unsigned Len = InstrLenTable[Opc];
      makeUp(insn, Len);
      S = decodeToMCInst(S, DecodeIdx, insn, MI, Address, DisAsm, DecodeComplete);
      assert(DecodeComplete);

      LLVM_DEBUG(dbgs() << Loc << ": OPC_Decode: opcode " << Opc
                   << ", using decoder " << DecodeIdx << ": "
                   << (S != MCDisassembler::Fail ? "PASS" : "FAIL") << "\n");
      return S;
    }
    case MCD::OPC_TryDecode: {
      // Decode the Opcode value.
      unsigned Opc = decodeULEB128AndIncUnsafe(++Ptr);
      unsigned DecodeIdx = decodeULEB128AndIncUnsafe(Ptr);
      // NumToSkip is a plain 24-bit integer.
      unsigned NumToSkip = *Ptr++;
      NumToSkip |= (*Ptr++) << 8;
      NumToSkip |= (*Ptr++) << 16;

      // Perform the decode operation.
      MCInst TmpMI;
      TmpMI.setOpcode(Opc);
      bool DecodeComplete;
      S = decodeToMCInst(S, DecodeIdx, insn, TmpMI, Address, DisAsm, DecodeComplete);
      LLVM_DEBUG(dbgs() << Loc << ": OPC_TryDecode: opcode " << Opc
                   << ", using decoder " << DecodeIdx << ": ");

      if (DecodeComplete) {
        // Decoding complete.
        LLVM_DEBUG(dbgs() << (S != MCDisassembler::Fail ? "PASS" : "FAIL") << "\n");
        MI = TmpMI;
        return S;
      } else {
        assert(S == MCDisassembler::Fail);
        // If the decoding was incomplete, skip.
        Ptr += NumToSkip;
        LLVM_DEBUG(dbgs() << "FAIL: continuing at " << (Ptr - DecodeTable) << "\n");
        // Reset decode status. This also drops a SoftFail status that could be
        // set before the decode attempt.
        S = MCDisassembler::Success;
      }
      break;
    }
    case MCD::OPC_SoftFail: {
      // Decode the mask values.
      uint64_t PositiveMask = decodeULEB128AndIncUnsafe(++Ptr);
      uint64_t NegativeMask = decodeULEB128AndIncUnsafe(Ptr);
      bool Fail = (insn & PositiveMask) != 0 || (~insn & NegativeMask) != 0;
      if (Fail)
        S = MCDisassembler::SoftFail;
      LLVM_DEBUG(dbgs() << Loc << ": OPC_SoftFail: " << (Fail ? "FAIL\n" : "PASS\n"));
      break;
    }
    case MCD::OPC_Fail: {
      LLVM_DEBUG(dbgs() << Loc << ": OPC_Fail\n");
      return MCDisassembler::Fail;
    }
    }
  }
  llvm_unreachable("bogosity detected in disassembler state machine!");
}


} // end namespace llvm
